'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _component = require('react-pure-render/component');

var _component2 = _interopRequireDefault(_component);

var _defaultGlobals = require('./styles/defaultGlobals');

var _defaultGlobals2 = _interopRequireDefault(_defaultGlobals);

var _reactImmutableProptypes = require('react-immutable-proptypes');

var _reactImmutableProptypes2 = _interopRequireDefault(_reactImmutableProptypes);

var _unaryMemoize = require('./unaryMemoize');

var _unaryMemoize2 = _interopRequireDefault(_unaryMemoize);

var _immutable = require('immutable');

var _react = require('react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StyledComponent = function (_Component) {
  (0, _inherits3.default)(StyledComponent, _Component);

  function StyledComponent(props, context) {
    (0, _classCallCheck3.default)(this, StyledComponent);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props, context));

    _this._updateThemeStyle();

    if (process.env.ALLOW_LIVE_STYLE_RELOAD) _this._getStyle = _this._getStyle.bind(_this);else _this._getStyle = (0, _unaryMemoize2.default)(_this._getStyle.bind(_this));
    return _this;
  }

  StyledComponent.prototype.getStyle = function getStyle() {
    if (process.env.ALLOW_LIVE_STYLE_RELOAD) this._updateThemeStyle();

    return this._getStyle(this.props.style);
  };

  StyledComponent.prototype._getStyleRoot = function _getStyleRoot() {
    if (!this.constructor.styleRoot) throw new TypeError('Property styleRoot is required for StyledComponent: ' + this.constructor.displayName + ' ');

    return this.constructor.styleRoot;
  };

  StyledComponent.prototype._getStyle = function _getStyle(localStyle) {
    return this.componentThemeStyle.mergeDeep(this._resolveStyleObject(localStyle)).toJS();
  };

  StyledComponent.prototype._resolveStyleObject = function _resolveStyleObject() {
    var functionOrObject = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    return (0, _immutable.fromJS)(typeof functionOrObject === 'function' ? functionOrObject(this.globals, this.props) : functionOrObject);
  };

  StyledComponent.prototype._updateThemeStyle = function _updateThemeStyle() {
    var themeStyle = this.context.themeStyle || (0, _immutable.Map)();

    if (!_immutable.Map.isMap(themeStyle)) console.error('context.themeStyle must be immutable Map'); // eslint-disable-line no-console

    this.globals = (themeStyle.get('globals') || _defaultGlobals2.default).toJS();

    // Check sliders/SliderSteps.react.js stepStyle() for dynamic style calculation
    if (process.env.NODE_ENV === 'development' && typeof this.constructor.style === 'function' && this.constructor.style.length === 2) console.warn('using `static style(_, props)` props as second argument is deprecated and change of prop will not trigger style recalculation'); // eslint-disable-line no-console

    this.componentThemeStyle = this._resolveStyleObject(this.constructor.style).mergeDeep(this._resolveStyleObject(themeStyle.get(this._getStyleRoot())));
  };

  return StyledComponent;
}(_component2.default);

StyledComponent.propTypes = {
  style: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.object])
};
StyledComponent.contextTypes = {
  themeStyle: _reactImmutableProptypes2.default.map
};
exports.default = StyledComponent;
module.exports = exports['default'];