'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reset = require('./styles/reset.js');

var _reset2 = _interopRequireDefault(_reset);

var _radium = require('radium');

var _defaultGlobals = require('./styles/defaultGlobals');

var _defaultGlobals2 = _interopRequireDefault(_defaultGlobals);

var _reactImmutableProptypes = require('react-immutable-proptypes');

var _reactImmutableProptypes2 = _interopRequireDefault(_reactImmutableProptypes);

var _unaryMemoize = require('./unaryMemoize');

var _unaryMemoize2 = _interopRequireDefault(_unaryMemoize);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ThemeProvider = function (_Component) {
  (0, _inherits3.default)(ThemeProvider, _Component);

  function ThemeProvider(props, context) {
    (0, _classCallCheck3.default)(this, ThemeProvider);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props, context));

    if (process.env.ALLOW_LIVE_STYLE_RELOAD) _this._getChildContext = _this._getChildContext.bind(_this);else _this._getChildContext = (0, _unaryMemoize2.default)(_this._getChildContext.bind(_this));
    _this.emptyStyleMap = (0, _immutable.Map)();
    return _this;
  }

  ThemeProvider.prototype.getChildContext = function getChildContext() {
    return this._getChildContext(this.props.style || this.emptyStyleMap);
  };

  ThemeProvider.prototype._getChildContext = function _getChildContext(style) {
    return {
      themeStyle: style.set('globals', _defaultGlobals2.default.mergeDeep(style.get('globals')))
    };
  };

  ThemeProvider.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(_radium.Style, { rules: _reset2.default }),
      this.props.children
    );
  };

  return ThemeProvider;
}(_react.Component);

ThemeProvider.childContextTypes = {
  themeStyle: _reactImmutableProptypes2.default.map
};
ThemeProvider.propTypes = {
  children: _react2.default.PropTypes.node,
  style: _reactImmutableProptypes2.default.map.isRequired
};
exports.default = ThemeProvider;
module.exports = exports['default'];