'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Content = require('../markdown/Content.react');

var _Content2 = _interopRequireDefault(_Content);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Social = require('./Social.react');

var _Social2 = _interopRequireDefault(_Social);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Article = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Article, _StyledComponent);

  function Article() {
    (0, _classCallCheck3.default)(this, Article);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Article.prototype.render = function render() {
    var _props = this.props,
        image = _props.image,
        text = _props.text,
        title = _props.title,
        url = _props.url,
        publishTime = _props.publishTime;


    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.article },
      _react2.default.createElement(
        'div',
        { style: (0, _extends3.default)({ backgroundImage: 'url(' + (image ? image.fields.file.url : '') + ')' }, style.image) },
        _react2.default.createElement('div', { style: style.overlay })
      ),
      _react2.default.createElement(
        'div',
        { style: style.text },
        _react2.default.createElement(
          'h1',
          { style: style.heading },
          title
        ),
        _react2.default.createElement(_Content2.default, { text: text || '' }),
        _react2.default.createElement(
          'div',
          { style: style.credits },
          _react2.default.createElement(
            'div',
            null,
            publishTime
          )
        ),
        _react2.default.createElement(_Social2.default, { heading: 'Share:', title: title, url: url })
      )
    );
  };

  return Article;
}(_StyledComponent3.default)) || _class;

Article.styleRoot = 'BlogPost';
Article.propTypes = {
  image: _react.PropTypes.string,
  publishTime: _react.PropTypes.string.isRequired,
  text: _react.PropTypes.string.isRequired,
  title: _react.PropTypes.string.isRequired,
  url: _react.PropTypes.string.isRequired
};

Article.style = function (_ref) {
  var _credits;

  var mediaQueries = _ref.mediaQueries;
  return {
    article: {
      background: '#fff'
    },
    text: {
      padding: '25px'
    },
    heading: {
      margin: '0 0 40px',
      lineHeight: 1.3,
      fontSize: '35px',
      fontWeight: 'normal',
      padding: 0
    },
    image: {
      backgroundSize: 'cover',
      height: '350px',
      position: 'relative'
    },
    overlay: {
      position: 'absolute',
      left: 0,
      top: 0,
      right: 0,
      bottom: 0,
      background: 'linear-gradient(to bottom,rgba(255,255,255,0) 70%,#fff 100%)'
    },
    credits: (_credits = {
      padding: '40px 0 60px',
      color: '#6f6f6f'
    }, _credits[mediaQueries.breakpointTablet] = {
      padding: '20px 0',
      textAlign: 'center'
    }, _credits)
  };
};

exports.default = Article;
module.exports = exports['default'];