'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Article = require('./Article.react');

var _Article2 = _interopRequireDefault(_Article);

var _Column = require('../grid/Column.react');

var _Column2 = _interopRequireDefault(_Column);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RelatedPosts = require('./RelatedPosts.react');

var _RelatedPosts2 = _interopRequireDefault(_RelatedPosts);

var _Row = require('../grid/Row.react');

var _Row2 = _interopRequireDefault(_Row);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _Tags = require('./Tags.react');

var _Tags2 = _interopRequireDefault(_Tags);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArticlePage = function (_StyledComponent) {
  (0, _inherits3.default)(ArticlePage, _StyledComponent);

  function ArticlePage() {
    (0, _classCallCheck3.default)(this, ArticlePage);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  ArticlePage.prototype.render = function render() {
    var _props = this.props,
        article = _props.article,
        relatedPostsHeading = _props.relatedPostsHeading,
        tagsHeading = _props.tagsHeading,
        timeFormater = _props.timeFormater;

    if (!article || !article.fields || !article.fields.title) return null;

    var _article$fields = article.fields,
        image = _article$fields.image,
        title = _article$fields.title,
        text = _article$fields.text,
        url = _article$fields.url,
        publishTime = _article$fields.publishTime,
        relatedPosts = _article$fields.relatedPosts,
        tags = _article$fields.tags;


    return _react2.default.createElement(
      _Row2.default,
      null,
      _react2.default.createElement(
        _Column2.default,
        { lg: 8, md: 8, ms: 12, sm: 8, xs: 12 },
        _react2.default.createElement(_Article2.default, {
          image: image,
          title: title,
          text: text,
          url: url,
          publishTime: timeFormater(publishTime)
        })
      ),
      _react2.default.createElement(
        _Column2.default,
        { lg: 4, md: 4, ms: 12, sm: 4, xs: 12 },
        _react2.default.createElement(_RelatedPosts2.default, { heading: relatedPostsHeading, relatedPosts: relatedPosts }),
        _react2.default.createElement(_Tags2.default, { heading: tagsHeading, tags: tags })
      )
    );
  };

  return ArticlePage;
}(_StyledComponent3.default);

ArticlePage.styleRoot = 'BlogArticlePage';
ArticlePage.propTypes = {
  article: _react.PropTypes.shape({
    fields: _react.PropTypes.shape({
      image: _react.PropTypes.string,
      title: _react.PropTypes.string,
      text: _react.PropTypes.string,
      url: _react.PropTypes.string,
      publishTime: _react.PropTypes.string,
      relatedPosts: _react.PropTypes.arrayOf(_react.PropTypes.shape({
        fields: _react.PropTypes.shape({
          title: _react.PropTypes.string,
          text: _react.PropTypes.string,
          url: _react.PropTypes.string,
          publishTime: _react.PropTypes.string
        })
      })),
      tags: _react.PropTypes.arrayOf(_react.PropTypes.shape({
        fields: _react.PropTypes.shape({
          name: _react.PropTypes.string,
          url: _react.PropTypes.string
        })
      }))
    })
  }).isRequired,
  relatedPostsHeading: _react.PropTypes.string,
  tagsHeading: _react.PropTypes.string,
  timeFormater: _react.PropTypes.func
};
ArticlePage.defaultProps = {
  article: {
    fields: {
      image: '',
      title: '',
      text: '',
      url: '',
      publishTime: '',
      relatedPosts: [],
      tags: []
    }
  },
  relatedPostsHeading: 'Related articles:',
  tagsHeading: 'Tags:',
  timeFormater: function timeFormater(time) {
    return time;
  } // => (moment(time).format('DD. MM. YYYY')) // BlueKit won't start with this :(
};
exports.default = ArticlePage;
module.exports = exports['default'];