'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _ArticlePage = require('./ArticlePage.react');

var _ArticlePage2 = _interopRequireDefault(_ArticlePage);

var _CategoryPage = require('./CategoryPage.react');

var _CategoryPage2 = _interopRequireDefault(_CategoryPage);

var _Homepage = require('./Homepage.react');

var _Homepage2 = _interopRequireDefault(_Homepage);

var _Menu = require('./menu/Menu.react');

var _Menu2 = _interopRequireDefault(_Menu);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TagPage = require('./TagPage.react');

var _TagPage2 = _interopRequireDefault(_TagPage);

var _immutable = require('immutable');

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Example = function (_Component) {
  (0, _inherits3.default)(Example, _Component);

  function Example() {
    (0, _classCallCheck3.default)(this, Example);
    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
  }

  Example.prototype.render = function render() {
    var blogPosts = (0, _immutable.Map)({
      'first-post': {
        fields: {
          title: 'First Post',
          url: 'first-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: '2014-12-23',
          text: '# Lorem ipsum dolor sit amet\n consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. ![](//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png) Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
          categories: [{ fields: { title: 'General', url: 'general' } }, { fields: { title: 'Supercategory', url: 'supercategory' } }],
          tags: [{ fields: { name: 'General', url: 'general' } }, { fields: { name: 'Money', url: 'money' } }, { fields: { name: 'Article', url: 'article' } }],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: [{ fields: { title: 'lorem ipsum', image: { fields: { file: { fields: { url: '' } } } }, url: 'lorem-ipsum' } }, { fields: { title: 'dolor sit amet', image: { fields: { file: { fields: { url: '' } } } }, url: 'dolor-sit-amet' } }, { fields: { title: 'domatavus vestum', image: { fields: { file: { fields: { url: '' } } } }, url: 'domatavus-vestum' } }]
        }
      },
      'second-post': {
        fields: {
          title: 'Second Post',
          url: 'second-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: '2015-10-01',
          text: '# Lorem ipsum dolor sit amet\n consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
          categories: [{ fields: { title: 'General', url: 'general' } }],
          tags: [{ fields: { name: 'General', url: 'general' } }, { fields: { name: 'Money', url: 'money' } }],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: []
        }
      },
      'third-post': {
        fields: {
          title: 'third Post',
          url: 'third-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: '2015-10-02',
          text: '# Lorem ipsum dolor sit amet\n consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
          categories: [{ fields: { title: 'Supercategory', url: 'supercategory' } }],
          tags: [{ fields: { name: 'General', url: 'general' } }],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: []
        }
      },
      'invisible-post': {
        fields: {
          title: 'Invisible Post',
          url: 'invisible-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: new Date().getFullYear() + 1 + '-01-01',
          text: '# Invisible',
          categories: [{ fields: { title: 'General', url: 'general' } }, { fields: { title: 'Supercategory', url: 'supercategory' } }],
          tags: [{ fields: { name: 'Money', url: 'money' } }],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: []
        }
      },
      'fifth-post': {
        fields: {
          title: 'fifth Post',
          url: 'fifth-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: '2015-10-04',
          text: '# Lorem ipsum dolor sit amet\n consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
          categories: [{ fields: { title: 'General', url: 'general' } }],
          tags: [{ fields: { name: 'Article', url: 'article' } }],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: []
        }
      },
      'sixth-post': {
        fields: {
          title: 'sixth Post',
          url: 'sixth-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: '2015-10-05',
          text: '# Lorem ipsum dolor sit amet\n consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
          categories: [{ fields: { title: 'Something completely different', url: 'something-completely-different' } }],
          tags: [{ fields: { name: 'General', url: 'general' } }, { fields: { title: 'Article', url: 'article' } }],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: []
        }
      },
      'fourth-post': {
        fields: {
          title: 'fourth Post',
          url: 'fourth-post',
          image: { fields: { file: { url: '//images.contentful.com/ckqhpllkz8uz/1eRjDeI2U6WGSswqG40mWk/22f56405a8ca149943936bd669d3e85a/blog.arbol.png' } } },
          publishTime: '2015-10-03',
          text: '# Lorem ipsum dolor sit amet\n consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
          categories: [{ fields: { title: 'Something completely different', url: 'something-completely-different' } }],
          tags: [],
          metaDescription: 'description of post',
          metaKeywords: 'keywords of post',
          relatedPosts: []
        }
      }
    });

    var ConnectedHomepage = function ConnectedHomepage() {
      return _react2.default.createElement(_Homepage2.default, { blogPosts: blogPosts });
    };
    var ConnectedArticlePage = function ConnectedArticlePage(_ref) {
      var id = _ref.params.id;
      return _react2.default.createElement(_ArticlePage2.default, { article: blogPosts.get(id) });
    };
    var ConnectedCategoryPage = function ConnectedCategoryPage(_ref2) {
      var id = _ref2.params.id;
      return _react2.default.createElement(_CategoryPage2.default, { blogPosts: blogPosts, category: id });
    };
    var ConnectedTagPage = function ConnectedTagPage(_ref3) {
      var id = _ref3.params.id;
      return _react2.default.createElement(_TagPage2.default, { blogPosts: blogPosts, tag: id });
    };
    var BlogLayout = function BlogLayout(_ref4) {
      var children = _ref4.children;
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_Menu2.default, { homeTitle: 'Blog', blogPosts: blogPosts }),
        children
      );
    };

    return _react2.default.createElement(
      _reactRouter.Router,
      { history: (0, _reactRouter.createMemoryHistory)('/blog/') },
      _react2.default.createElement(
        _reactRouter.Route,
        { path: '/blog', component: BlogLayout },
        _react2.default.createElement(_reactRouter.IndexRoute, { component: ConnectedHomepage }),
        _react2.default.createElement(_reactRouter.Route, { path: ':id', component: ConnectedArticlePage }),
        _react2.default.createElement(_reactRouter.Route, { path: 'tag/:id', component: ConnectedTagPage }),
        _react2.default.createElement(_reactRouter.Route, { path: 'category/:id', component: ConnectedCategoryPage })
      )
    );
  };

  return Example;
}(_react.Component);

exports.default = Example;
module.exports = exports['default'];