'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _blogHelpers = require('../lib/blogHelpers');

var _blogHelpers2 = _interopRequireDefault(_blogHelpers);

var _Latest = require('./posts/Latest.react');

var _Latest2 = _interopRequireDefault(_Latest);

var _Normal = require('./posts/Normal.react');

var _Normal2 = _interopRequireDefault(_Normal);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Recent = require('./posts/Recent.react');

var _Recent2 = _interopRequireDefault(_Recent);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Homepage = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Homepage, _StyledComponent);

  function Homepage() {
    (0, _classCallCheck3.default)(this, Homepage);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Homepage.prototype.render = function render() {
    var _props = this.props,
        blogPosts = _props.blogPosts,
        timeFormater = _props.timeFormater;

    var style = this.getStyle();

    var _getActiveSortedBlogP = (0, _blogHelpers2.default)(blogPosts),
        first = _getActiveSortedBlogP[0],
        second = _getActiveSortedBlogP[1],
        third = _getActiveSortedBlogP[2],
        fourth = _getActiveSortedBlogP[3],
        normals = _getActiveSortedBlogP.slice(4);

    return _react2.default.createElement(
      'div',
      { style: style.base },
      first && _react2.default.createElement(_Latest2.default, { post: first, timeFormater: timeFormater }),
      _react2.default.createElement(
        'div',
        { style: style.left },
        second && _react2.default.createElement(_Recent2.default, { post: second }),
        third && _react2.default.createElement(_Recent2.default, { post: third }),
        fourth && _react2.default.createElement(_Recent2.default, { post: fourth })
      ),
      normals && _react2.default.createElement(
        'div',
        { style: style.normalsWrapper },
        normals.map(function (normal, i) {
          return _react2.default.createElement(_Normal2.default, { post: normal, key: i, timeFormater: timeFormater });
        })
      )
    );
  };

  return Homepage;
}(_StyledComponent3.default)) || _class;

Homepage.styleRoot = 'BlogHomepage';
Homepage.propTypes = {
  blogPosts: _react.PropTypes.object.isRequired,
  timeFormater: _react.PropTypes.func
};
Homepage.defaultProps = {
  timeFormater: function timeFormater(time) {
    return time;
  } // => (moment(time).format('DD. MM. YYYY')) // BlueKit won't start with this :(
};

Homepage.style = function (_ref) {
  var _left;

  var mediaQueries = _ref.mediaQueries;
  return {
    base: {
      display: 'flex',
      alignItems: 'stretch',
      flexWrap: 'wrap'
    },
    left: (_left = {
      float: 'left',
      width: 100 / 3 + '%',
      padding: '20px 20px 0px 20px',
      background: '#fff',
      borderRadius: '0 6px 6px 0'
    }, _left[mediaQueries.breakpointTablet] = {
      width: '100%',
      borderRadius: '0 0 6px 6px'
    }, _left),
    normalsWrapper: {
      marginLeft: '-10px',
      marginRight: '-10px',
      display: 'flex',
      flexWrap: 'wrap',
      alignItems: 'stretch',
      width: '100%'
    }
  };
};

exports.default = Homepage;
module.exports = exports['default'];