'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _blogHelpers = require('../lib/blogHelpers');

var _blogHelpers2 = _interopRequireDefault(_blogHelpers);

var _Normal = require('./posts/Normal.react');

var _Normal2 = _interopRequireDefault(_Normal);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ListingPage = function (_StyledComponent) {
  (0, _inherits3.default)(ListingPage, _StyledComponent);

  function ListingPage() {
    (0, _classCallCheck3.default)(this, ListingPage);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  // take all blogposts and collect all entites (with given entity - type)
  // tags = { '/tagurl': {fields: {title: 'Tag :D' } } }
  ListingPage.prototype.collectEntities = function collectEntities() {
    var _props = this.props,
        blogPosts = _props.blogPosts,
        entity = _props.entity;

    if (!blogPosts || (0, _keys2.default)(blogPosts).length <= 0) return {};

    return blogPosts.reduce(function (allEntities, post) {
      return (post.fields[entity] || []).reduce(function (postEntities, ent) {
        var _extends2;

        return (0, _extends4.default)({}, postEntities, (_extends2 = {}, _extends2[ent.fields.url] = ent.fields, _extends2));
      }, allEntities);
    }, {});
  };

  ListingPage.prototype.findEntity = function findEntity() {
    var search = this.props.search;

    return this.collectEntities()[search] || {};
  };

  // take all blogposts and return only blogposts which contains this entity


  ListingPage.prototype.filterPosts = function filterPosts() {
    var _props2 = this.props,
        blogPosts = _props2.blogPosts,
        entity = _props2.entity,
        search = _props2.search;


    return blogPosts && (0, _keys2.default)(blogPosts).length > 0 ? blogPosts.filter(function (post) {
      return (post.fields[entity] || []).find(function (_ref) {
        var url = _ref.fields.url;
        return url === search;
      });
    }) : {};
  };

  ListingPage.prototype.renderPost = function renderPost(post) {
    var timeFormater = this.props.timeFormater;


    return _react2.default.createElement(_Normal2.default, { key: post.fields.title, post: post, timeFormater: timeFormater });
  };

  ListingPage.prototype.render = function render() {
    var _findEntity = this.findEntity(),
        name = _findEntity.name,
        title = _findEntity.title;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'h1',
        null,
        title || name
      ),
      _react2.default.createElement(
        'div',
        { style: style.list },
        (0, _blogHelpers2.default)(this.filterPosts()).map(this.renderPost.bind(this))
      )
    );
  };

  return ListingPage;
}(_StyledComponent3.default);

ListingPage.styleRoot = 'BlogListingPage';
ListingPage.propTypes = {
  blogPosts: _react.PropTypes.object,
  entity: _react.PropTypes.string.isRequired,
  search: _react.PropTypes.string.isRequired,
  timeFormater: _react.PropTypes.func
};
ListingPage.defaultProps = {
  timeFormater: function timeFormater(time) {
    return time;
  } // => (moment(time).format('DD. MM. YYYY')) // BlueKit won't start with this :(
};

ListingPage.style = function () {
  return {
    list: {
      marginLeft: '-10px',
      marginRight: '-10px',
      display: 'flex',
      flexWrap: 'wrap',
      alignItems: 'stretch',
      width: '100%'
    }
  };
};

exports.default = ListingPage;
module.exports = exports['default'];