'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var RelatedPost = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(RelatedPost, _StyledComponent);

  function RelatedPost() {
    (0, _classCallCheck3.default)(this, RelatedPost);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  RelatedPost.prototype.render = function render() {
    var _props = this.props,
        image = _props.image,
        title = _props.title,
        url = _props.url;

    var isHovered = _radium2.default.getState(this.state, 'related-link', ':hover');
    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { key: 'related-link', style: style.wrapper },
      _react2.default.createElement(
        RadiumLink,
        { style: style.relatedPost, to: '/blog/' + url },
        _react2.default.createElement(
          'div',
          { style: style.imageBox },
          _react2.default.createElement('img', { src: '' + (image ? image.fields.file.url : ''), style: style.image })
        ),
        _react2.default.createElement(
          'div',
          { style: style.textBox },
          _react2.default.createElement(
            'h4',
            { style: [style.heading.base, isHovered && style.heading.hovered] },
            title
          )
        ),
        _react2.default.createElement('div', { style: style.clearfix })
      )
    );
  };

  return RelatedPost;
}(_StyledComponent3.default)) || _class;

RelatedPost.styleRoot = 'BlogRelatedPost';
RelatedPost.propTypes = {
  image: _react.PropTypes.object,
  title: _react.PropTypes.string.isRequired,
  url: _react.PropTypes.string.isRequired
};

RelatedPost.style = function (_ref) {
  var _imageBox, _textBox;

  var mediaQueries = _ref.mediaQueries;
  return {
    wrapper: {
      marginBottom: '20px',
      ':hover': {}
    },
    relatedPost: {
      display: 'flex',
      flexWrap: 'wrap',
      color: '#000',
      textDecoration: 'none'
    },
    imageBox: (_imageBox = {
      float: 'left',
      width: '40%',
      paddingRight: '20px'
    }, _imageBox[mediaQueries.breakpointLaptopSmall] = {
      width: '100%',
      paddingRight: 0
    }, _imageBox[mediaQueries.breakpointTablet] = {
      width: '40%',
      paddingRight: '20px'
    }, _imageBox[mediaQueries.breakpointSmall] = {
      width: '100%',
      paddingRight: 0
    }, _imageBox),
    image: {
      display: 'block',
      maxWidth: '100%',
      height: 'auto'
    },
    textBox: (_textBox = {
      float: 'left',
      width: '60%',
      paddingTop: '10px'
    }, _textBox[mediaQueries.breakpointLaptopSmall] = {
      width: '100%'
    }, _textBox[mediaQueries.breakpointTablet] = {
      width: '60%'
    }, _textBox[mediaQueries.breakpointSmall] = {
      width: '100%'
    }, _textBox),
    heading: {
      base: {
        margin: 0,
        display: 'inline',
        fontWeight: 'normal',
        borderBottom: '1px solid transparent',
        transition: 'border-bottom .1s'
      },
      hovered: {
        borderBottom: '1px solid #363636'
      }
    }
  };
};

exports.default = RelatedPost;
module.exports = exports['default'];