'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RelatedPost = require('./RelatedPost.react');

var _RelatedPost2 = _interopRequireDefault(_RelatedPost);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RelatedPosts = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(RelatedPosts, _StyledComponent);

  function RelatedPosts() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, RelatedPosts);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.defaultProps = {
      relatedPosts: [{ fields: { title: '', image: { fields: { file: { fields: { url: '' } } } }, url: '' } }]
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  RelatedPosts.prototype.renderRelatedPost = function renderRelatedPost(post) {
    var relatedPostComponent = post.relatedPostComponent,
        _post$fields = post.fields,
        image = _post$fields.image,
        title = _post$fields.title,
        url = _post$fields.url;

    var RelatedPostComponent = relatedPostComponent || _RelatedPost2.default;

    return _react2.default.createElement(RelatedPostComponent, {
      key: url,
      image: image,
      title: title,
      url: url
    });
  };

  RelatedPosts.prototype.render = function render() {
    var _props = this.props,
        heading = _props.heading,
        relatedPosts = _props.relatedPosts;

    var style = this.getStyle();

    if (!relatedPosts || relatedPosts.length === 0) return null;

    return _react2.default.createElement(
      'div',
      { style: style.base },
      _react2.default.createElement(
        'h3',
        { style: style.heading },
        heading
      ),
      relatedPosts && relatedPosts.map(this.renderRelatedPost)
    );
  };

  return RelatedPosts;
}(_StyledComponent3.default)) || _class;

RelatedPosts.styleRoot = 'BlogRelatedPosts';
RelatedPosts.propTypes = {
  heading: _react.PropTypes.string,
  relatedPosts: _react.PropTypes.arrayOf(_react.PropTypes.object).isRequired,
  relatedPostComponent: _react.PropTypes.object
};

RelatedPosts.style = function (_ref) {
  var _base;

  var mediaQueries = _ref.mediaQueries;
  return {
    base: (_base = {
      background: '#fff',
      padding: '25px'
    }, _base[mediaQueries.breakpointTablet] = {
      marginTop: '20px'
    }, _base),
    heading: {
      margin: '0 0 20px',
      fontSize: '20px'
    }
  };
};

exports.default = RelatedPosts;
module.exports = exports['default'];