'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SocialLink = require('./SocialLink.react');

var _SocialLink2 = _interopRequireDefault(_SocialLink);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Social = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Social, _StyledComponent);

  function Social() {
    (0, _classCallCheck3.default)(this, Social);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Social.prototype.render = function render() {
    var _props = this.props,
        title = _props.title,
        url = _props.url,
        domain = _props.domain,
        heading = _props.heading;

    var link = 'http://www.' + (domain || 'example.com') + '/blog/' + url;
    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.socialBox },
      _react2.default.createElement(
        'strong',
        { style: style.heading },
        heading
      ),
      _react2.default.createElement(_SocialLink2.default, { to: 'http://www.facebook.com/sharer/sharer.php?u=' + link + '&title=' + title, type: 'facebook' }),
      _react2.default.createElement(_SocialLink2.default, { to: 'http://twitter.com/intent/tweet?status=' + title + '+' + link, type: 'twitter' }),
      _react2.default.createElement(_SocialLink2.default, { to: 'https://plus.google.com/share?url=' + link, type: 'google_plus' })
    );
  };

  return Social;
}(_StyledComponent3.default)) || _class;

Social.styleRoot = 'BlogSocial';
Social.propTypes = {
  title: _react.PropTypes.string.isRequired,
  url: _react.PropTypes.string.isRequired,
  domain: _react.PropTypes.string.isRequired,
  heading: _react.PropTypes.string
};

Social.style = function (_ref) {
  var _socialBox;

  var mediaQueries = _ref.mediaQueries;
  return {
    heading: {
      marginRight: '5px'
    },
    socialBox: (_socialBox = {
      borderTop: '1px solid #e0e1e1',
      paddingTop: '25px',
      display: 'flex',
      flexWrap: 'wrap',
      alignItems: 'center'
    }, _socialBox[mediaQueries.breakpointTablet] = {
      justifyContent: 'center'
    }, _socialBox)
  };
};

exports.default = Social;
module.exports = exports['default'];