'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SocialLink = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(SocialLink, _StyledComponent);

  function SocialLink() {
    (0, _classCallCheck3.default)(this, SocialLink);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  SocialLink.prototype.openShareWindow = function openShareWindow(event) {
    event.preventDefault();

    window.open(this.props.to, 'sharer', 'toolbar=0,status=0,width=548,height=325');
  };

  SocialLink.prototype.render = function render() {
    var _props = this.props,
        to = _props.to,
        type = _props.type;

    var style = this.getStyle();

    return _react2.default.createElement(
      'a',
      { href: to, onClick: this.openShareWindow.bind(this), style: style.wrapper },
      _react2.default.createElement(_Icon2.default, { color: style.iconColor, kind: type, size: 30, style: style.icon })
    );
  };

  return SocialLink;
}(_StyledComponent3.default)) || _class;

SocialLink.styleRoot = 'BlogSocialLink';
SocialLink.propTypes = {
  to: _react.PropTypes.string.isRequired,
  type: _react.PropTypes.oneOf(['facebook', 'google_plus', 'twitter']).isRequired
};

SocialLink.style = function (_ref) {
  var colors = _ref.colors;
  return {
    wrapper: {
      width: '40px',
      height: '40px',
      borderRadius: '50%',
      backgroundColor: colors.primary,
      border: 0,
      display: 'inline-block',
      position: 'relative',
      marginLeft: '15px',
      transition: 'background-color .2s',
      ':hover': {
        backgroundColor: colors.primaryDarker
      }
    },
    icon: {
      position: 'absolute',
      top: '50%',
      left: '50%',
      transform: 'translate(-50%,-50%)'
    },
    iconColor: '#fff'
  };
};

exports.default = SocialLink;
module.exports = exports['default'];