'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _Tag = require('./Tag.react');

var _Tag2 = _interopRequireDefault(_Tag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tags = function (_StyledComponent) {
  (0, _inherits3.default)(Tags, _StyledComponent);

  function Tags() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Tags);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.renderTag = function (tag) {
      var _tag$fields = tag.fields,
          name = _tag$fields.name,
          url = _tag$fields.url;


      return _react2.default.createElement(_Tag2.default, { key: name, url: url, name: name });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  Tags.prototype.render = function render() {
    var _props = this.props,
        heading = _props.heading,
        tags = _props.tags;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.base },
      _react2.default.createElement(
        'h3',
        { style: style.heading },
        heading
      ),
      tags.map(this.renderTag)
    );
  };

  return Tags;
}(_StyledComponent3.default);

Tags.styleRoot = 'BlogTags';
Tags.propTypes = {
  heading: _react.PropTypes.string,
  tags: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    fields: _react.PropTypes.shape({
      name: _react.PropTypes.string,
      url: _react.PropTypes.string
    })
  }))
};
Tags.defaultProps = {
  tags: [{ fields: { name: 'General', url: 'general' } }]
};

Tags.style = function (_ref) {
  var colors = _ref.colors;
  return {
    base: {
      padding: '25px 25px 37.5px',
      backgroundColor: colors.primary
    },
    heading: {
      margin: '0px 0px 20px',
      fontSize: '20px'
    }
  };
};

exports.default = Tags;
module.exports = exports['default'];