'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _MenuItem = require('./MenuItem.react');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _ToggleButton = require('./ToggleButton.react');

var _ToggleButton2 = _interopRequireDefault(_ToggleButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Menu = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Menu, _StyledComponent);

  function Menu() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Menu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.state = {}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  Menu.prototype.handleToggleClick = function handleToggleClick() {
    this.setState({ opened: !this.state.opened });
  };

  Menu.prototype.filterCategories = function filterCategories(posts) {
    return (0, _values2.default)(posts && (0, _keys2.default)(posts).length > 0 ? posts.reduce(function (acc, post) {
      return post.fields.categories.reduce(function (accc, cat) {
        var _extends2;

        return (0, _extends4.default)({}, accc, (_extends2 = {}, _extends2[cat.fields.url] = cat.fields, _extends2));
      }, acc);
    }, {}) : {});
  };

  Menu.prototype.render = function render() {
    var _props = this.props,
        blogPosts = _props.blogPosts,
        homeTitle = _props.homeTitle;
    var opened = this.state.opened;

    var items = this.filterCategories(blogPosts);
    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.blogMenu },
      _react2.default.createElement('div', { style: [style.background.base, style.background.left] }),
      _react2.default.createElement('div', { style: [style.background.base, style.background.right] }),
      _react2.default.createElement(_ToggleButton2.default, { onClick: this.handleToggleClick.bind(this) }),
      _react2.default.createElement(
        'ul',
        { style: [style.list.base, opened && style.list.opened] },
        _react2.default.createElement(
          'li',
          { key: 'homeLink', style: style.item },
          _react2.default.createElement(_MenuItem2.default, { item: { title: homeTitle, url: '/blog' } })
        ),
        items && items.map(function (item, i) {
          return _react2.default.createElement(
            'li',
            { key: i, style: style.item },
            _react2.default.createElement(_MenuItem2.default, { item: item })
          );
        })
      )
    );
  };

  return Menu;
}(_StyledComponent3.default)) || _class;

Menu.styleRoot = 'BlogMenu';
Menu.propTypes = {
  blogPosts: _react.PropTypes.object.isRequired,
  homeTitle: _react.PropTypes.string
};
Menu.defaultProps = {
  homeTitle: 'Home'
};

Menu.style = function (_ref) {
  var _blogMenu, _base, _opened, _item;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    blogMenu: (_blogMenu = {
      backgroundColor: colors.primary,
      position: 'relative',
      zIndex: 2,
      minHeight: '60px',
      marginBottom: '40px'
    }, _blogMenu[mediaQueries.breakpointTablet] = {
      minHeight: '50px',
      position: 'fixed',
      top: '60px',
      left: 0,
      right: 0
    }, _blogMenu),
    background: {
      base: {
        backgroundColor: colors.primary,
        position: 'absolute',
        height: '100%',
        top: 0,
        width: '2000px',
        zIndex: 1
      },
      left: {
        right: '99%'
      },
      right: {
        left: '99%'
      }
    },
    list: {
      base: (_base = {
        display: 'table-row',
        marginBottom: 0,
        marginTop: 0,
        paddingLeft: 0
      }, _base[mediaQueries.breakpointTablet] = {
        display: 'block',
        position: 'absolute',
        backgroundColor: colors.primary,
        overflow: 'hidden',
        paddingBottom: '10px',
        top: '100%',
        left: 0,
        right: 0,
        maxHeight: 0,
        transition: 'max-height .3s'
      }, _base),
      opened: (_opened = {}, _opened[mediaQueries.breakpointTablet] = {
        position: 'absolute',
        maxHeight: '700px'
      }, _opened)
    },
    item: (_item = {
      display: 'table-cell',
      verticalAlign: 'middle',
      margin: '0 40px'
    }, _item[mediaQueries.breakpointTablet] = {
      display: 'block',
      margin: '0 20px'
    }, _item)
  };
};

exports.default = Menu;
module.exports = exports['default'];