'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var MenuItem = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(MenuItem, _StyledComponent);

  function MenuItem() {
    (0, _classCallCheck3.default)(this, MenuItem);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  MenuItem.prototype.render = function render() {
    var _props = this.props,
        _props$item = _props.item,
        title = _props$item.title,
        url = _props$item.url,
        path = _props.path;

    if (!title || !url) return null;
    var activeLink = url === path;
    // TODO: PROVIDE path to activeLink
    var isHovered = _radium2.default.getState(this.state, 'menu-item', ':hover');
    var style = this.getStyle();

    var menuLink = url.startsWith('/') ? url : '/blog/category/' + url;

    return _react2.default.createElement(
      'div',
      { key: 'menu-item', style: style.wrapper },
      _react2.default.createElement(
        RadiumLink,
        {
          style: style.innerWrapper,
          to: menuLink
        },
        _react2.default.createElement(
          'span',
          {
            style: [style.inner.base, isHovered && style.inner.active, activeLink && style.inner.active]
          },
          title
        ),
        activeLink && _react2.default.createElement('span', { style: style.arrow })
      )
    );
  };

  return MenuItem;
}(_StyledComponent3.default)) || _class;

MenuItem.styleRoot = 'BlogMenuItem';
MenuItem.propTypes = {
  item: _react.PropTypes.shape({
    title: _react.PropTypes.string,
    url: _react.PropTypes.string
  }).isRequired,
  path: _react.PropTypes.string
};

MenuItem.style = function (_ref) {
  var _innerWrapper, _arrow;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    wrapper: {
      ':hover': {}
    },
    innerWrapper: (_innerWrapper = {
      padding: '25px 20px',
      textDecoration: 'none',
      color: '#fff',
      display: 'block',
      position: 'relative',
      textAlign: 'center'
    }, _innerWrapper[mediaQueries.breakpointTablet] = {
      padding: '15px 0px'
    }, _innerWrapper),
    inner: {
      base: {
        borderBottomWidth: '1px',
        borderBottomStyle: 'solid',
        borderBottomColor: (0, _color2.default)(colors.primary).lighten(0.3).hex(),
        transition: 'border-bottom-color 0.2s',
        ':hover': {}
      },
      active: {
        borderBottomColor: '#fff'
      }
    },
    arrow: (_arrow = {
      position: 'absolute',
      top: '100%',
      left: '50%',
      borderStyle: 'solid',
      borderColor: colors.primary + ' transparent transparent',
      height: 0,
      width: 0,
      pointerEvents: 'none',
      borderWidth: '12px',
      marginLeft: '-12px'
    }, _arrow[mediaQueries.breakpointTablet] = {
      display: 'none'
    }, _arrow)
  };
};

exports.default = MenuItem;
module.exports = exports['default'];