'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var Latest = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Latest, _StyledComponent);

  function Latest() {
    (0, _classCallCheck3.default)(this, Latest);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Latest.prototype.render = function render() {
    if (!this.props.post || !this.props.post.fields) return null;

    var _props = this.props,
        _props$post$fields = _props.post.fields,
        title = _props$post$fields.title,
        url = _props$post$fields.url,
        publishTime = _props$post$fields.publishTime,
        image = _props$post$fields.image,
        timeFormater = _props.timeFormater;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: (0, _extends3.default)({ backgroundImage: 'url(' + (image ? image.fields.file.url : '') + ')' }, style.wrapper) },
      _react2.default.createElement(
        RadiumLink,
        { style: style.link, to: '/blog/' + url },
        _react2.default.createElement(
          'div',
          { style: style.innerWrapper },
          _react2.default.createElement(
            'small',
            { style: style.date },
            timeFormater(publishTime)
          ),
          _react2.default.createElement(
            'h2',
            { style: style.heading },
            title
          )
        )
      )
    );
  };

  return Latest;
}(_StyledComponent3.default)) || _class;

Latest.styleRoot = 'BlogListLatest';
Latest.propTypes = {
  post: _react.PropTypes.shape({
    fields: _react.PropTypes.shape({
      publishTime: _react.PropTypes.string,
      text: _react.PropTypes.string,
      title: _react.PropTypes.string,
      url: _react.PropTypes.string
    })
  }).isRequired,
  timeFormater: _react.PropTypes.func
};
Latest.defaultProps = {
  timeFormater: function timeFormater(time) {
    return time;
  } // => (moment(time).format('DD. MM. YYYY')) // BlueKit won't start with this :(
};

Latest.style = function (_ref) {
  var _wrapper, _link;

  var mediaQueries = _ref.mediaQueries;
  return {
    wrapper: (_wrapper = {
      float: 'left',
      width: 200 / 3 + '%',
      position: 'relative',
      borderRadius: '6px 0 0 6px',
      backgroundSize: 'cover',
      backgroundPosition: 'center'
    }, _wrapper[mediaQueries.breakpointTablet] = {
      width: '100%',
      borderRadius: '6px 6px 0 0'
    }, _wrapper),
    innerWrapper: {
      padding: '50px',
      maxWidth: '600px'
    },
    link: (_link = {
      color: '#fff',
      position: 'absolute',
      display: 'block',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      textDecoration: 'none',
      background: 'rgba(0,0,0,.3)',
      borderRadius: '6px 0 0 6px',
      transition: 'background .1s linear'
    }, _link[mediaQueries.breakpointTablet] = {
      position: 'static',
      minHeight: '350px',
      borderRadius: '6px 6px 0 0'
    }, _link[':hover'] = {
      background: 'rgba(0,0,0,.6)'
    }, _link),
    date: {
      fontSize: '16px',
      marginBottom: '15px'
    },
    heading: {
      fontSize: '35px'
    }
  };
};

exports.default = Latest;
module.exports = exports['default'];