'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var Other = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Other, _StyledComponent);

  function Other() {
    (0, _classCallCheck3.default)(this, Other);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Other.prototype.render = function render() {
    if (!this.props.post || !this.props.post.fields) return null;

    var _props = this.props,
        _props$post$fields = _props.post.fields,
        image = _props$post$fields.image,
        publishTime = _props$post$fields.publishTime,
        title = _props$post$fields.title,
        url = _props$post$fields.url,
        timeFormater = _props.timeFormater;

    var isHovered = _radium2.default.getState(this.state, 'post', ':hover');
    var style = this.getStyle();

    return _react2.default.createElement(
      RadiumLink,
      { style: style.wrapper, to: '/blog/' + url },
      _react2.default.createElement(
        'div',
        { key: 'post', style: style.post },
        _react2.default.createElement(
          'div',
          { style: style.imageWrapper },
          _react2.default.createElement('div', { style: [{ backgroundImage: 'url(' + (image ? image.fields.file.url : '') + ')' }, style.image.base, isHovered && style.image.hovered] })
        ),
        _react2.default.createElement(
          'div',
          { style: style.text },
          _react2.default.createElement(
            'h4',
            { style: style.heading },
            title
          ),
          _react2.default.createElement(
            'small',
            { style: style.date },
            timeFormater(publishTime)
          )
        )
      )
    );
  };

  return Other;
}(_StyledComponent3.default)) || _class;

Other.styleRoot = 'BlogListOther';
Other.propTypes = {
  post: _react.PropTypes.shape({
    fields: _react.PropTypes.shape({
      publishTime: _react.PropTypes.string,
      text: _react.PropTypes.string,
      title: _react.PropTypes.string,
      url: _react.PropTypes.string
    })
  }).isRequired,
  timeFormater: _react.PropTypes.func
};
Other.defaultProps = {
  timeFormater: function timeFormater(time) {
    return time;
  } // => (moment(time).format('DD. MM. YYYY')) // BlueKit won't start with this :(
};

Other.style = function (_ref) {
  var _wrapper, _imageWrapper;

  var mediaQueries = _ref.mediaQueries;
  return {
    wrapper: (_wrapper = {
      position: 'relative',
      float: 'left',
      textDecoration: 'none',
      display: 'flex',
      color: '#000',
      width: 100 / 3 + '%',
      paddingLeft: '10px',
      paddingRight: '10px'
    }, _wrapper[mediaQueries.breakpointTablet] = {
      width: '50%'
    }, _wrapper[mediaQueries.breakpointSmall] = {
      width: '100%'
    }, _wrapper),
    imageWrapper: (_imageWrapper = {
      height: '350px',
      borderRadius: '6px 6px 0px 0px',
      overflow: 'hidden'
    }, _imageWrapper[mediaQueries.breakpointLaptopSmall] = {
      height: '300px'
    }, _imageWrapper[mediaQueries.breakpointTablet] = {
      height: '250px'
    }, _imageWrapper),
    image: {
      base: {
        backgroundSize: 'cover',
        backgroundPosition: 'center',
        height: '100%',
        transform: 'scale(1)',
        transition: 'transform .1s'
      },
      hovered: {
        transform: 'scale(1.1)'
      }
    },
    post: {
      marginTop: '20px',
      boxShadow: '0 3px 3px 0 rgba(50,50,50,.15)',
      transition: 'all .1s linear',
      width: '100%',
      display: 'flex',
      flexDirection: 'column',
      ':hover': {}
    },
    text: {
      background: '#fff',
      padding: '15px',
      borderTop: '12px solid #A7CE3A',
      borderRadius: '0 0 6px 6px',
      flexGrow: 2
    },
    heading: {
      marginTop: '15px',
      marginBottom: '20px',
      fontSize: '18px',
      lineHeight: 1.3
    },
    date: {
      fontSize: '14px',
      color: '#b5b5b5'
    }
  };
};

exports.default = Other;
module.exports = exports['default'];