'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var Recent = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Recent, _StyledComponent);

  function Recent() {
    (0, _classCallCheck3.default)(this, Recent);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  // We need to shorten text and we need to do it nicely
  // This is trying to fit as much whole words (splitted by space)
  // to given max chars.
  // When text is under MAX it will print whole
  // If over max it will get shortend and ... will be added to end.
  Recent.prototype.shortenText = function shortenText(text, max) {
    if (text.length < max) return text;

    return text.substr(0, max - 1 - text.substr(0, max).split('').reverse().join('').indexOf(' ')).trim() + '...';
  };

  Recent.prototype.render = function render() {
    if (!this.props.post || !this.props.post.fields) return null;

    var _props$post$fields = this.props.post.fields,
        title = _props$post$fields.title,
        url = _props$post$fields.url,
        text = _props$post$fields.text;

    var style = this.getStyle();
    var thumbText = this.shortenText(text, 100);

    return _react2.default.createElement(
      RadiumLink,
      { style: style.wrapper, to: '/blog/' + url },
      _react2.default.createElement(
        'h4',
        { style: style.heading },
        title
      ),
      _react2.default.createElement(
        'p',
        { style: style.text },
        thumbText
      )
    );
  };

  return Recent;
}(_StyledComponent3.default)) || _class;

Recent.styleRoot = 'BlogListRecent';
Recent.propTypes = {
  post: _react.PropTypes.shape({
    fields: _react.PropTypes.shape({
      publishTime: _react.PropTypes.string,
      text: _react.PropTypes.string,
      title: _react.PropTypes.string,
      url: _react.PropTypes.string
    })
  }).isRequired
};

Recent.style = function (_ref) {
  var colors = _ref.colors;
  return {
    wrapper: {
      display: 'block',
      borderWidth: '2px',
      borderStyle: 'solid',
      borderColor: colors.monotone2,
      textDecoration: 'none',
      padding: '15px 20px',
      marginBottom: '20px',
      transition: 'border-color .1s',
      color: colors.black,
      ':hover': {
        borderColor: colors.monotone3
      }
    },
    heading: {
      fontSize: '16px',
      margin: '0 0 10px',
      lineHeight: 1.4
    },
    text: {
      fontSize: '15px',
      margin: 0
    }
  };
};

exports.default = Recent;
module.exports = exports['default'];