'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Spinner = require('../progress/Spinner.react');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Button, _StyledComponent);

  function Button() {
    (0, _classCallCheck3.default)(this, Button);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Button.prototype.render = function render() {
    var _props = this.props,
        className = _props.className,
        disabled = _props.disabled,
        inheritedStyle = _props.inheritedStyle,
        kind = _props.kind,
        size = _props.size,
        fullWidth = _props.fullWidth,
        loading = _props.loading,
        loadingText = _props.loadingText,
        name = _props.name,
        noMargin = _props.noMargin,
        onClick = _props.onClick,
        children = _props.children,
        type = _props.type,
        id = _props.id;

    var style = this.getStyle();

    return _react2.default.createElement(
      'button',
      {
        className: className,
        disabled: disabled,
        name: name,
        onClick: onClick,
        style: [style.base, style.size[size], style.kind[kind], inheritedStyle && inheritedStyle, fullWidth && style.fullWidth, disabled && style.disabled, disabled && style.disabled[kind], noMargin && style.noMargin],
        type: type,
        id: id
      },
      _react2.default.createElement(
        'span',
        null,
        loading && _react2.default.createElement(_Spinner2.default, null),
        loading && loadingText || children
      )
    );
  };

  return Button;
}(_StyledComponent3.default)) || _class;

Button.styleRoot = 'Button';
Button.propTypes = {
  children: _react.PropTypes.any.isRequired,
  className: _react.PropTypes.string,
  disabled: _react.PropTypes.bool,
  fullWidth: _react.PropTypes.bool,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  kind: _react.PropTypes.oneOf(['primary', 'primaryInverted', 'secondary', 'simple']),
  loading: _react.PropTypes.bool,
  loadingText: _react.PropTypes.string,
  name: _react.PropTypes.string,
  noMargin: _react.PropTypes.bool,
  onClick: _react.PropTypes.func,
  size: _react.PropTypes.oneOf(['small', 'large']),
  type: _react.PropTypes.string,
  id: _react.PropTypes.string
};
Button.defaultProps = {
  kind: 'primary',
  loading: false,
  type: 'button'
};

Button.style = function (_ref) {
  var _base, _primaryInverted;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    base: (_base = {
      backgroundColor: '#909090',
      borderColor: 'transparent',
      borderRadius: 0,
      borderStyle: 'solid',
      borderWidth: '1px',
      color: '#fff',
      cursor: 'pointer',
      display: 'inline-block',
      fontSize: '21px',
      lineHeight: '25px',
      margin: '15px 10px 0 0',
      outline: 'none',
      padding: '12px 34px 9px',
      textDecoration: 'none',
      transition: 'background-color .2s ease-in-out, color .2s ease-in-out, border-color .2s ease-in-out',
      verticalAlign: 'top'
    }, _base[mediaQueries.breakpointLarge] = {
      minWidth: '300px'
    }, _base[mediaQueries.breakpointSmall] = {
      display: 'block',
      width: '100%'
    }, _base),
    kind: {
      primary: {
        backgroundColor: colors.primary,
        ':hover': {
          backgroundColor: (0, _color2.default)(colors.primary).darken(0.2).hex(),
          borderColor: (0, _color2.default)(colors.primary).darken(0.2).hex()
        }
      },
      primaryInverted: (_primaryInverted = {
        color: colors.primary,
        borderStyle: 'solid',
        borderColor: colors.primary,
        padding: '8px 34px'
      }, _primaryInverted[mediaQueries.breakpointLarge] = {
        minWidth: '1px'
      }, _primaryInverted[':hover'] = {
        backgroundColor: (0, _color2.default)(colors.primary).darken(0.2).hex(),
        color: colors.white,
        borderColor: (0, _color2.default)(colors.primary).darken(0.2).hex()
      }, _primaryInverted),
      secondary: {
        backgroundColor: colors.gray,
        ':hover': {
          backgroundColor: colors.grayDark
        }
      },
      simple: {
        padding: '16px 0px 0px',
        backgroundColor: 'transparent',
        boxShadow: 'none',
        transition: 'color .2s',
        minHeight: 0
      }
    },
    size: {
      small: {
        fontSize: '14px'
      },
      large: {
        padding: '25px 30px',
        fontSize: '18px'
      }
    },
    disabled: {
      cursor: 'default',
      pointerEvents: 'none',
      userSelect: 'none',
      boxShadow: '0 1px 3px 0 rgba(0, 0, 0, 0.3)',
      primary: {
        backgroundColor: '#E0E0E0'
      },
      secondary: {
        backgroundColor: colors.grayLight
      }
    },
    fullWidth: {
      width: '100%'
    },
    noMargin: {
      margin: 0
    }
  };
};

exports.default = Button;
module.exports = exports['default'];