'use strict';

exports.__esModule = true;

exports.default = function (_ref) {
  var _base, _simple, _small;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    base: (_base = {
      fontSize: '19px',
      fontWeight: '300',
      textTransform: 'uppercase',
      borderRadius: '2px',
      boxShadow: '0 1px 2px 0 rgba(0, 0, 0, .15)'
    }, _base[mediaQueries.breakpointLarge] = {
      minWidth: '300px'
    }, _base),
    kind: {
      primary: {
        borderWidth: '1px',
        borderBottomColor: colors.primary
      },
      primaryInverted: {
        backgroundColor: colors.white,
        borderBottomColor: colors.primary,
        boxShadow: 'none'
      },
      secondary: {
        borderWidth: '1px',
        borderColor: 'transparent',
        borderBottomColor: colors.monotone4
      },
      simple: (_simple = {
        color: colors.secondary,
        borderBottom: '1px solid ' + colors.secondary,
        lineHeight: '18px',
        padding: '0px',
        ':hover': {
          borderBottom: '1px solid transparent',
          color: colors.secondary
        }
      }, _simple[mediaQueries.breakpointLarge] = {
        minWidth: 'auto'
      }, _simple)
    },
    size: {
      small: (_small = {
        padding: '0px 10px'
      }, _small[mediaQueries.breakpointLarge] = {
        minWidth: 'auto'
      }, _small)
    },
    disabled: {
      color: colors.grayLight,
      borderBottomColor: 'transparent',
      primaryInverted: {
        borderColor: colors.grayLight,
        borderBottomColor: colors.grayLight
      },
      secondary: {
        color: colors.white
      },
      simple: {
        boxShadow: 'none',
        borderBottomColor: colors.grayLight
      }
    }
  };
};

module.exports = exports['default'];