'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ButtonLink = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(ButtonLink, _StyledComponent);

  function ButtonLink() {
    (0, _classCallCheck3.default)(this, ButtonLink);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  ButtonLink.prototype.handleClick = function handleClick(event) {
    var _props = this.props,
        disabled = _props.disabled,
        onClick = _props.onClick;

    if (disabled) {
      event.preventDefault();
      return;
    }

    if (typeof onClick === 'function') onClick(event);
  };

  ButtonLink.prototype.renderLink = function renderLink() {
    var _props2 = this.props,
        children = _props2.children,
        className = _props2.className,
        disabled = _props2.disabled,
        fullWidth = _props2.fullWidth,
        inheritedStyle = _props2.inheritedStyle,
        kind = _props2.kind,
        noMargin = _props2.noMargin,
        size = _props2.size,
        to = _props2.to,
        id = _props2.id;

    var style = this.getStyle();

    return _react2.default.createElement(
      'a',
      {
        id: id,
        className: className,
        href: to,
        onClick: this.handleClick.bind(this),
        style: [style.base, style.size[size], style.kind[kind], inheritedStyle && inheritedStyle, fullWidth && style.fullWidth, disabled && style.disabled, disabled && style.disabled[kind], noMargin && style.noMargin]
      },
      children
    );
  };

  ButtonLink.prototype.renderRadiumLink = function renderRadiumLink() {
    var _props3 = this.props,
        children = _props3.children,
        className = _props3.className,
        disabled = _props3.disabled,
        fullWidth = _props3.fullWidth,
        inheritedStyle = _props3.inheritedStyle,
        kind = _props3.kind,
        noMargin = _props3.noMargin,
        size = _props3.size,
        to = _props3.to,
        id = _props3.id;

    var RadiumLink = (0, _radium2.default)(_reactRouter.Link);
    var style = this.getStyle();

    return _react2.default.createElement(
      RadiumLink,
      {
        id: id,
        className: className,
        onClick: this.handleClick.bind(this),
        style: [style.base, style.size[size], style.kind[kind], inheritedStyle && inheritedStyle, fullWidth && style.fullWidth, disabled && style.disabled, disabled && style.disabled[kind], noMargin && style.noMargin],
        to: to
      },
      children
    );
  };

  ButtonLink.prototype.render = function render() {
    var _props4 = this.props,
        centered = _props4.centered,
        external = _props4.external,
        fullWidth = _props4.fullWidth,
        wrapperStyle = _props4.wrapperStyle;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      {
        style: [style.wrapper.base, wrapperStyle && wrapperStyle, centered && style.wrapper.centered, fullWidth && style.wrapper.centered]
      },
      external ? this.renderLink() : this.renderRadiumLink()
    );
  };

  return ButtonLink;
}(_StyledComponent3.default)) || _class;

ButtonLink.styleRoot = 'ButtonLink';
ButtonLink.defaultProps = {
  to: '',
  centered: false
};
ButtonLink.propTypes = {
  centered: _react.PropTypes.bool,
  children: _react.PropTypes.any.isRequired,
  className: _react.PropTypes.string,
  disabled: _react.PropTypes.bool,
  external: _react.PropTypes.bool,
  fullWidth: _react.PropTypes.bool,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  kind: _react.PropTypes.oneOf(['primary', 'secondary', 'primaryInverted', 'simple']).isRequired,
  noMargin: _react.PropTypes.bool,
  onClick: _react.PropTypes.func,
  size: _react.PropTypes.oneOf(['small', 'large']),
  to: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object]).isRequired,
  wrapperStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  id: _react.PropTypes.string
};

ButtonLink.style = function (_ref) {
  var _primaryInverted;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    base: {
      backgroundColor: '#909090',
      borderColor: 'transparent',
      borderStyle: 'solid',
      borderWidth: '1px',
      color: '#fff',
      cursor: 'pointer',
      display: 'inline-block',
      fontSize: '21px',
      lineHeight: '28px',
      margin: '15px 10px 0 0',
      outline: 'none',
      padding: '9px 34px',
      textAlign: 'center',
      textDecoration: 'none',
      transition: 'background-color .2s ease-in-out, color .2s ease-in-out, border-color .2s ease-in-out',
      verticalAlign: 'top'
    },
    kind: {
      primary: {
        backgroundColor: colors.primary,
        ':hover': {
          backgroundColor: (0, _color2.default)(colors.primary).darken(0.2).hex()
        }
      },
      primaryInverted: (_primaryInverted = {
        color: colors.primary,
        borderStyle: 'solid',
        borderColor: colors.primary,
        boxShadow: 'none',
        padding: '8px 34px'
      }, _primaryInverted[mediaQueries.breakpointLarge] = {
        minWidth: '1px'
      }, _primaryInverted[':hover'] = {
        backgroundColor: (0, _color2.default)(colors.primary).darken(0.2).hex(),
        color: colors.white,
        borderColor: (0, _color2.default)(colors.primary).darken(0.2).hex()
      }, _primaryInverted),
      secondary: {
        backgroundColor: colors.gray,
        ':hover': {
          backgroundColor: colors.grayDark
        }
      },
      simple: {
        padding: '16px 0px 0px',
        backgroundColor: 'transparent',
        boxShadow: 'none',
        transition: 'color .2s',
        minHeight: 0
      }
    },
    size: {
      small: {
        padding: '10px 18px',
        fontSize: '14px'
      },
      large: {
        padding: '25px 30px',
        fontSize: '18px'
      }
    },
    disabled: {
      cursor: 'default',
      pointerEvents: 'none',
      userSelect: 'none',
      boxShadow: '0 1px 3px 0 rgba(0, 0, 0, 0.3)',
      primary: {
        backgroundColor: '#E0E0E0'
      },
      secondary: {
        backgroundColor: colors.grayLight
      }
    },
    wrapper: {
      base: {
        display: 'inline-block'
      },

      centered: {
        display: 'block',
        textAlign: 'center'
      }
    },
    fullWidth: {
      width: '100%'
    },
    noMargin: {
      margin: 0
    }
  };
};

exports.default = ButtonLink;
module.exports = exports['default'];