'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OfferRow = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(OfferRow, _StyledComponent);

  function OfferRow() {
    (0, _classCallCheck3.default)(this, OfferRow);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  OfferRow.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        id = _props.id,
        inverseColors = _props.inverseColors,
        last = _props.last,
        subtitle = _props.subtitle,
        title = _props.title,
        underline = _props.underline;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: [style.row, last && style.row.last, inverseColors && style.rowInverse, underline && style.row.underline] },
      _react2.default.createElement(
        'div',
        { style: style.column },
        _react2.default.createElement(
          'span',
          { style: [style.text, last && style.text.bold] },
          title
        ),
        subtitle && _react2.default.createElement(
          'div',
          { style: style.subtitle },
          subtitle
        )
      ),
      _react2.default.createElement(
        'div',
        { style: [style.column, style.column.right] },
        _react2.default.createElement(
          'span',
          { style: [style.text, last && style.text.bold], id: id },
          children
        )
      ),
      _react2.default.createElement('div', { style: style.clearfix })
    );
  };

  return OfferRow;
}(_StyledComponent3.default)) || _class;

OfferRow.styleRoot = 'OfferRow';
OfferRow.propTypes = {
  children: _react.PropTypes.node,
  id: _react.PropTypes.string,
  inverseColors: _react.PropTypes.bool,
  last: _react.PropTypes.bool,
  subtitle: _react.PropTypes.string,
  title: _react.PropTypes.string.isRequired,
  underline: _react.PropTypes.bool
};
OfferRow.defaultProps = {
  last: false
};

OfferRow.style = function (_ref) {
  var colors = _ref.colors;
  return {
    row: {
      borderWidth: '0 0 1px 0',
      borderColor: (0, _color2.default)(colors.black).fade(0.8).rgb().string(),
      borderStyle: 'solid',
      fontSize: '1.6rem',
      lineHeight: 1.2,
      last: {
        borderWidth: '0'
      },
      underline: {
        borderWidth: '0 0 1px 0'
      }
    },

    rowInverse: {
      borderColor: colors.white
    },

    column: {
      float: 'left',
      padding: '15px 0',
      width: '50%',
      right: {
        textAlign: 'right'
      }
    },

    clearfix: {
      clear: 'both'
    },

    text: {
      bold: {
        fontWeight: 700
      }
    }
  };
};

exports.default = OfferRow;
module.exports = exports['default'];