'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _Content = require('../markdown/Content.react');

var _Content2 = _interopRequireDefault(_Content);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FaqItem = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(FaqItem, _StyledComponent);

  function FaqItem() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FaqItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.state = {
      isContentVisible: false
    }, _this.showContent = function () {
      _this.setState({
        isContentVisible: !_this.state.isContentVisible
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  FaqItem.prototype.render = function render() {
    var _props = this.props,
        enabled = _props.enabled,
        content = _props.content,
        title = _props.title;
    var isContentVisible = this.state.isContentVisible;

    var isHovered = _radium2.default.getState(this.state, 'faq-item', ':hover');
    var style = this.getStyle();

    if (!title || !enabled) return null;

    return _react2.default.createElement(
      'div',
      {
        className: 'faq-item',
        key: 'faq-item',
        style: [style.wrapper.base, isHovered && style.wrapper.active, isContentVisible && style.wrapper.active]
      },
      _react2.default.createElement('span', { style: style.arrow.transparent }),
      _react2.default.createElement(_Icon2.default, {
        kind: 'chevron-right',
        size: 20,
        style: [style.arrow.visible.base, isHovered && style.arrow.visible.active, isContentVisible && style.arrow.visible.active]
      }),
      _react2.default.createElement(
        'span',
        { className: 'faq-title', onClick: this.showContent, style: style.title },
        title
      ),
      _react2.default.createElement(
        'div',
        { className: 'faq-content', style: [style.content.base, isContentVisible && style.content.visible] },
        _react2.default.createElement(_Content2.default, { text: content || '' })
      )
    );
  };

  return FaqItem;
}(_StyledComponent3.default)) || _class;

FaqItem.styleRoot = 'FaqItem';
FaqItem.propTypes = {
  content: _react.PropTypes.string.isRequired,
  enabled: _react.PropTypes.bool.isRequired,
  title: _react.PropTypes.string.isRequired
};
FaqItem.defaultProps = {
  enabled: true
};

FaqItem.style = function (_ref) {
  var _visible;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    wrapper: {
      base: {
        padding: '8px 12px 8px 32px',
        marginBottom: '4px',
        position: 'relative',
        backgroundColor: 'transparent',
        transition: 'background-color .5s',
        ':hover': {}
      },
      active: {
        backgroundColor: colors.white
      }
    },
    arrow: {
      visible: {
        base: {
          position: 'absolute',
          left: '-4px',
          top: '14px',
          opacity: 1,
          fill: colors.secondary,
          transition: 'left .3s, opacity .3s'
        },
        active: {
          left: '-20px',
          opacity: 0
        }
      },
      transparent: {
        height: 0,
        width: 0,
        left: 0,
        top: '8px',
        position: 'absolute',
        pointerEvents: 'none',
        borderStyle: 'solid',
        borderBottomColor: 'transparent',
        borderRightColor: 'transparent',
        borderTopColor: 'transparent',
        borderLeftColor: colors.background,
        borderWidth: '16px'
      }
    },
    title: {
      fontSize: '18px',
      margin: '5px 0px',
      display: 'block',
      cursor: 'pointer',
      userSelect: 'none',
      fontWeight: 'bold'
    },
    content: {
      base: {
        maxHeight: 0,
        overflow: 'hidden',
        transition: 'max-height .5s'
      },
      visible: (_visible = {
        maxHeight: '999px'
      }, _visible[mediaQueries.breakpointTablet] = {
        maxHeight: '2999px'
      }, _visible)
    }
  };
};

exports.default = FaqItem;
module.exports = exports['default'];