'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FooterLink = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(FooterLink, _StyledComponent);

  function FooterLink() {
    (0, _classCallCheck3.default)(this, FooterLink);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  FooterLink.prototype.renderIcon = function renderIcon() {
    var _props = this.props,
        color = _props.color,
        iconSize = _props.iconSize,
        kind = _props.kind,
        type = _props.type;

    var style = this.getStyle();

    return _react2.default.createElement(_Icon2.default, { kind: kind, size: iconSize || 22, color: color || style[type].icon.color, style: [style.icon, type && style[type].icon] });
  };

  FooterLink.prototype.render = function render() {
    var _props2 = this.props,
        children = _props2.children,
        disabled = _props2.disabled,
        kind = _props2.kind,
        onClick = _props2.onClick,
        to = _props2.to,
        type = _props2.type;

    var style = this.getStyle();

    return _react2.default.createElement(
      'a',
      {
        href: to,
        key: to + kind,
        style: [style[type].link, disabled && style.disabled],
        onClick: onClick
      },
      kind && this.renderIcon(),
      _react2.default.createElement(
        'span',
        { style: style[type].text, key: to },
        children
      )
    );
  };

  return FooterLink;
}(_StyledComponent3.default)) || _class;

FooterLink.styleRoot = 'FooterLink';
FooterLink.propTypes = {
  color: _react.PropTypes.string,
  children: _react.PropTypes.any,
  disabled: _react.PropTypes.bool,
  iconSize: _react.PropTypes.number,
  kind: _react.PropTypes.string,
  onClick: _react.PropTypes.func,
  to: _react.PropTypes.string,
  type: _react.PropTypes.oneOf(['base', 'contact', 'social'])
};
FooterLink.defaultProps = {
  type: 'base',
  iconSize: 22
};

FooterLink.style = function (_ref) {
  var colors = _ref.colors;
  return {
    base: {
      link: {
        marginRight: '20px',
        borderBottomStyle: 'solid',
        borderBottomWidth: '1px',
        borderBottomColor: colors.gray,
        color: colors.gray,
        textDecoration: 'none',
        lineHeight: 1,
        display: 'inline-block',
        ':hover': {
          textDecoration: 'none',
          borderBottomColor: colors.grayLight,
          color: colors.grayLight
        }
      },
      text: {},
      icon: {
        marginRight: '5px',
        color: colors.gray
      }
    },
    contact: {
      link: {
        cursor: 'pointer',
        color: colors.white,
        display: 'inline-block',
        fontSize: '18px',
        position: 'relative',
        textDecoration: 'none',
        background: 'none',
        border: 'none',
        outline: 'none',
        marginBottom: '12px',
        ':hover': {
          textDecoration: 'none'
        }
      },
      text: {
        borderBottomWidth: '1px',
        borderBottomStyle: 'solid',
        borderBottomColor: colors.white,
        ':hover': {
          borderBottomColor: 'transparent'
        }
      },
      icon: {
        marginRight: '5px',
        color: colors.white
      }
    },
    social: {
      link: {
        borderBottomStyle: 'none'
      },
      text: {},
      icon: {
        marginRight: '20px',
        color: colors.black
      }
    },
    icon: {
      display: 'inline-block',
      verticalAlign: 'middle'
    },
    disabled: {
      opacity: .5,
      cursor: 'default',
      pointerEvents: 'none'
    }
  };
};

exports.default = FooterLink;
module.exports = exports['default'];