'use strict';

exports.__esModule = true;
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _desc, _value, _class2;

var _Container = require('../grid/Container.react');

var _Container2 = _interopRequireDefault(_Container);

var _QuickContactsIcon = require('./QuickContactsIcon.react');

var _QuickContactsIcon2 = _interopRequireDefault(_QuickContactsIcon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _coreDecorators = require('core-decorators');

var _reactScroll = require('react-scroll');

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var QuickContacts = (0, _radium2.default)(_class = (_class2 = function (_StyledComponent) {
  (0, _inherits3.default)(QuickContacts, _StyledComponent);

  function QuickContacts() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, QuickContacts);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.state = {
      isQuickContactsFixed: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  QuickContacts.prototype.componentDidMount = function componentDidMount() {
    this.handleScroll = this.handleScroll.bind(this);
    window.addEventListener('scroll', this.handleScroll);
    this.handleScroll();
  };

  QuickContacts.prototype.componentWillUnmount = function componentWillUnmount() {
    window.removeEventListener('scroll', this.handleScroll);
  };

  QuickContacts.prototype.handleScroll = function handleScroll() {
    var outerContainerID = this.props.outerContainerID;


    var outerContainer = document.getElementById(outerContainerID);
    var outerContainerHeight = outerContainer.getBoundingClientRect().height;
    var documentScrollTop = document.documentElement.scrollTop || document.body.scrollTop;
    var isQuickContactsFixed = documentScrollTop + window.innerHeight < document.getElementById('footer').offsetTop;
    var isScrolledDown = Math.abs(documentScrollTop - (Math.round(outerContainerHeight) - window.innerHeight)) < 10;

    if (this.state.isQuickContactsFixed !== isQuickContactsFixed) this.setState({ isQuickContactsFixed: isQuickContactsFixed });
    if (this.state.isScrolledDown !== isScrolledDown) this.setState({ isScrolledDown: isScrolledDown });
  };

  QuickContacts.prototype.renderItem = function renderItem(item, index, list) {
    var isScrolledDown = this.state.isScrolledDown;

    var last = index === list.size - 1;

    return _react2.default.createElement(_QuickContactsIcon2.default, { key: 'quick' + index, kind: item.kind, last: last, to: item.to, isScrolledDown: isScrolledDown });
  };

  QuickContacts.prototype.render = function render() {
    var _this2 = this;

    var _state = this.state,
        isQuickContactsFixed = _state.isQuickContactsFixed,
        isScrolledDown = _state.isScrolledDown;
    var quickContacts = this.props.quickContacts;

    var style = this.getStyle();
    var Element = isScrolledDown ? 'div' : _reactScroll.Link;
    var quickContactsMap = _immutable.List.isList(quickContacts) ? quickContacts : (0, _immutable.List)(quickContacts);

    return _react2.default.createElement(
      'div',
      { style: [isQuickContactsFixed && style.fixed] },
      _react2.default.createElement(
        _Container2.default,
        { style: style.container },
        _react2.default.createElement(
          Element,
          { to: 'footer', smooth: true },
          _react2.default.createElement(
            'div',
            {
              style: [style.content, isQuickContactsFixed && style.shadow]
            },
            quickContactsMap.map(function (item, index, list) {
              return _this2.renderItem(item, index, list);
            })
          )
        )
      )
    );
  };

  return QuickContacts;
}(_StyledComponent3.default), (_applyDecoratedDescriptor(_class2.prototype, 'handleScroll', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'handleScroll'), _class2.prototype)), _class2)) || _class;

QuickContacts.styleRoot = 'QuickContacts';
QuickContacts.propTypes = {
  outerContainerID: _react.PropTypes.string.isRequired,
  quickContacts: _react.PropTypes.array
};
QuickContacts.defaultProps = {
  outerContainerID: 'app'
};

QuickContacts.style = function (_ref) {
  var colors = _ref.colors;
  return {
    fixed: {
      position: 'fixed',
      bottom: 0,
      left: 0,
      right: 0,
      zIndex: 10
    },
    container: {
      position: 'relative'
    },
    content: {
      backgroundColor: colors.primary,
      padding: '10px 0',
      borderRadius: '12px 12px 0 0',
      position: 'absolute',
      top: '-36px',
      right: '20px',
      height: '36px',
      zIndex: 99,
      cursor: 'pointer'
    },
    shadow: {
      boxShadow: '0 0 8px rgba(0, 0, 0, .1)'
    }
  };
};

exports.default = QuickContacts;
module.exports = exports['default'];