'use strict';

exports.__esModule = true;
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _desc, _value, _class2;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _coreDecorators = require('core-decorators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var QuickContactsIcon = (0, _radium2.default)(_class = (_class2 = function (_StyledComponent) {
  (0, _inherits3.default)(QuickContactsIcon, _StyledComponent);

  function QuickContactsIcon() {
    (0, _classCallCheck3.default)(this, QuickContactsIcon);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  QuickContactsIcon.prototype.renderIcon = function renderIcon() {
    var _props = this.props,
        kind = _props.kind,
        last = _props.last;

    var style = this.getStyle();

    return _react2.default.createElement(_Icon2.default, {
      color: 'white',
      kind: kind,
      size: 22,
      wrapperStyle: [style.icon, last && style.last]
    });
  };

  QuickContactsIcon.prototype.render = function render() {
    var _props2 = this.props,
        disabled = _props2.disabled,
        isScrolledDown = _props2.isScrolledDown,
        onClick = _props2.onClick,
        to = _props2.to;

    var style = this.getStyle();

    if (isScrolledDown) {
      return _react2.default.createElement(
        'a',
        {
          href: to,
          onClick: onClick,
          style: [style.link, disabled && style.disabled]
        },
        this.renderIcon()
      );
    }

    return this.renderIcon();
  };

  return QuickContactsIcon;
}(_StyledComponent3.default), (_applyDecoratedDescriptor(_class2.prototype, 'renderIcon', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'renderIcon'), _class2.prototype)), _class2)) || _class;

QuickContactsIcon.styleRoot = 'QuickContactsIcon';
QuickContactsIcon.propTypes = {
  disabled: _react.PropTypes.bool,
  isScrolledDown: _react.PropTypes.bool,
  kind: _react.PropTypes.string.isRequired,
  last: _react.PropTypes.bool,
  onClick: _react.PropTypes.func,
  to: _react.PropTypes.string
};

QuickContactsIcon.style = function (_ref) {
  var colors = _ref.colors;
  return {
    icon: {
      padding: '0 14px',
      display: 'inline-block',
      verticalAlign: 'top',
      borderRight: '1px solid ' + colors.white
    },
    link: {
      display: 'inline-block',
      verticalAlign: 'top',
      padding: 0,
      background: 0,
      border: 'none',
      outline: 'none',
      cursor: 'pointer'
    },
    disabled: {
      opacity: .5,
      cursor: 'default'
    },
    last: {
      borderRight: 'none'
    }
  };
};

exports.default = QuickContactsIcon;
module.exports = exports['default'];