'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Button = require('../buttons/Button.react');

var _Button2 = _interopRequireDefault(_Button);

var _ErrorMessage = require('./ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('./wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ButtonWithError = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(ButtonWithError, _StyledComponent);

  function ButtonWithError() {
    (0, _classCallCheck3.default)(this, ButtonWithError);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  ButtonWithError.prototype.render = function render() {
    var _props = this.props,
        className = _props.className,
        disabled = _props.disabled,
        error = _props.error,
        inheritedStyle = _props.inheritedStyle,
        kind = _props.kind,
        size = _props.size,
        fullWidth = _props.fullWidth,
        loading = _props.loading,
        loadingText = _props.loadingText,
        name = _props.name,
        onClick = _props.onClick,
        children = _props.children,
        type = _props.type,
        id = _props.id;

    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, inheritedStyle: style.wrapper },
      _react2.default.createElement(
        _Button2.default,
        {
          className: className,
          disabled: disabled,
          fullWidth: fullWidth,
          inheritedStyle: [inheritedStyle, style.button],
          kind: kind,
          loading: loading,
          loadingText: loadingText,
          name: name,
          onClick: onClick,
          size: size,
          type: type,
          id: id
        },
        children
      ),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        { inheritedStyle: style.errorMessage },
        error
      )
    );
  };

  return ButtonWithError;
}(_StyledComponent3.default)) || _class;

ButtonWithError.styleRoot = 'ButtonWithError';
ButtonWithError.propTypes = {
  children: _react.PropTypes.any.isRequired,
  className: _react.PropTypes.string,
  disabled: _react.PropTypes.bool,
  error: _react.PropTypes.string,
  fullWidth: _react.PropTypes.bool,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  kind: _react.PropTypes.oneOf(['primary', 'primaryInverted', 'secondary', 'simple']),
  loading: _react.PropTypes.bool,
  loadingText: _react.PropTypes.string,
  name: _react.PropTypes.string,
  noMargin: _react.PropTypes.bool,
  onClick: _react.PropTypes.func,
  size: _react.PropTypes.oneOf(['small', 'large']),
  type: _react.PropTypes.string,
  id: _react.PropTypes.string
};

ButtonWithError.style = function (_ref) {
  var _wrapper;

  var mediaQueries = _ref.mediaQueries;
  return {
    button: {
      margin: '15px 10px 15px 0px'
    },
    errorMessage: {
      marginTop: 0,
      marginLeft: '5px'
    },
    wrapper: (_wrapper = {
      display: 'flex',
      alignItems: 'center'
    }, _wrapper[mediaQueries.breakpointSmall] = {
      flexDirection: 'column',
      alignItems: 'flex-start'
    }, _wrapper)
  };
};

exports.default = ButtonWithError;
module.exports = exports['default'];