'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('./ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('./wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _handleEvent = require('./handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _Label = require('./Label.react');

var _Label2 = _interopRequireDefault(_Label);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _Tooltip = require('./Tooltip.react');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _WarningMessage = require('./WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Checkbox = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Checkbox, _StyledComponent);

  function Checkbox() {
    (0, _classCallCheck3.default)(this, Checkbox);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Checkbox.prototype.renderHint = function renderHint() {
    var hint = this.props.hint;

    var style = this.getStyle();

    if (!hint) return null;

    return _react2.default.createElement(
      'div',
      { style: style.hint },
      hint
    );
  };

  Checkbox.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        error = _props.error,
        label = _props.label,
        name = _props.name,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        tooltip = _props.tooltip,
        value = _props.value,
        warning = _props.warning;

    var focused = _radium2.default.getState(this.state, 'input', ':focus');
    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      _react2.default.createElement(
        _Label2.default,
        { name: name, inheritedStyle: style.label },
        _react2.default.createElement(
          'div',
          { style: [style.base, focused && style.baseFocused] },
          _react2.default.createElement(
            'div',
            { style: [style.unchecked, value && style.checked] },
            _react2.default.createElement(_Icon2.default, {
              color: style.check.color,
              kind: 'check',
              size: style.check.fontSize
            })
          )
        ),
        _react2.default.createElement('input', {
          checked: value,
          id: name,
          key: 'input',
          name: name,
          onBlur: _handleEvent2.default.bind(null, name, onBlur),
          onChange: _handleEvent2.default.bind(null, name, onChange),
          onFocus: _handleEvent2.default.bind(null, name, onFocus),
          style: style.input,
          type: 'checkbox'
        }),
        _react2.default.createElement(
          'span',
          { style: style.checkboxLabel },
          children || label
        ),
        _react2.default.createElement(_Tooltip2.default, { tooltip: tooltip })
      ),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      ),
      this.renderHint()
    );
  };

  return Checkbox;
}(_StyledComponent3.default)) || _class;

Checkbox.styleRoot = 'Checkbox';
Checkbox.propTypes = {
  children: _react.PropTypes.any,
  error: _react.PropTypes.string,
  hint: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  tooltip: _react.PropTypes.string,
  value: _react.PropTypes.bool,
  warning: _react.PropTypes.string
};

Checkbox.style = function (_ref) {
  var colors = _ref.colors;
  return {
    label: {
      position: 'relative',
      paddingLeft: '25px',
      paddingRight: '20px',
      userSelect: 'none',
      cursor: 'pointer',
      display: 'inline-block'
    },

    check: {
      color: colors.primary,
      fontSize: '18px'
    },

    checkboxLabel: {
      fontWeight: 'normal',
      paddingLeft: '12px',
      marginTop: '3px',
      display: 'inline-block',
      verticalAlign: 'top'
    },

    hint: {
      fontSize: '13px',
      color: 'hsl(0, 0%, 58%)',
      marginTop: '5px',
      maxWidth: '400px'
    },

    input: {
      position: 'absolute',
      left: '-9999px',
      ':focus': {}
    },

    base: {
      width: '24px',
      height: '24px',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: colors.grayLighter,
      position: 'absolute',
      backgroundColor: colors.white,
      left: 0,
      top: 0
    },

    baseFocused: {
      borderColor: colors.primary
    },

    unchecked: {
      width: '16px',
      height: '16px',
      color: colors.primary,
      position: 'absolute',
      top: '2px',
      left: '2px',
      transform: 'scale(0, 0)',
      transition: 'all .2s'
    },

    checked: {
      transform: 'scale(1, 1)'
    }
  };
};

exports.default = Checkbox;
module.exports = exports['default'];