'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Active = require('./EditableTextField/Active.react');

var _Active2 = _interopRequireDefault(_Active);

var _Inactive = require('./EditableTextField/Inactive.react');

var _Inactive2 = _interopRequireDefault(_Inactive);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EditableTextField = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(EditableTextField, _StyledComponent);

  function EditableTextField() {
    (0, _classCallCheck3.default)(this, EditableTextField);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  EditableTextField.extendBluekitProps = function extendBluekitProps(props, setAtomProp) {
    return (0, _extends3.default)({}, props, {
      onEditingModeChange: function onEditingModeChange(_ref) {
        var editing = _ref.editing;
        return setAtomProp('editing', editing);
      }
    });
  };

  EditableTextField.prototype.toggleEditingMode = function toggleEditingMode() {
    var _props = this.props,
        editing = _props.editing,
        onEditingModeChange = _props.onEditingModeChange;

    onEditingModeChange({ editing: !editing });
  };

  EditableTextField.prototype.render = function render() {
    var editing = this.props.editing;

    var FieldVariant = editing ? _Active2.default : _Inactive2.default;
    return _react2.default.createElement(FieldVariant, (0, _extends3.default)({ toggleEditingMode: this.toggleEditingMode.bind(this) }, this.props));
  };

  return EditableTextField;
}(_StyledComponent3.default)) || _class;

EditableTextField.styleRoot = 'EditableTextField';
EditableTextField.propTypes = {
  editing: _react.PropTypes.bool.isRequired,
  error: _react.PropTypes.string,
  fieldName: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onEditingModeChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func
};
EditableTextField.defaultProps = {
  editing: false,
  label: 'Value to show'
};
exports.default = EditableTextField;
module.exports = exports['default'];