'use strict';

exports.__esModule = true;
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _desc, _value, _class2;

var _ErrorMessage = require('../ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('../wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _handleEvent = require('../handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _Icon = require('../../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _WarningMessage = require('../WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

var _coreDecorators = require('core-decorators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var Active = (0, _radium2.default)(_class = (_class2 = function (_StyledComponent) {
  (0, _inherits3.default)(Active, _StyledComponent);

  function Active() {
    (0, _classCallCheck3.default)(this, Active);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Active.prototype.discardChanges = function discardChanges() {
    var onEditingModeChange = this.props.onEditingModeChange;

    onEditingModeChange({ editing: false, discardChanges: true });
  };

  Active.prototype.render = function render() {
    var _props = this.props,
        error = _props.error,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        label = _props.label,
        toggleEditingMode = _props.toggleEditingMode,
        warning = _props.warning;

    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      _react2.default.createElement(
        'div',
        { style: style.wrapper },
        _react2.default.createElement(
          'div',
          { style: style.inputWrapper },
          _react2.default.createElement('input', {
            id: name,
            key: 'input',
            name: name,
            onBlur: _handleEvent2.default.bind(null, name, onBlur),
            onChange: _handleEvent2.default.bind(null, name, onChange),
            onFocus: _handleEvent2.default.bind(null, name, onFocus),
            style: [style.inputBase, error && style.errorInput],
            type: 'text',
            value: label
          }),
          _react2.default.createElement(
            'div',
            { onClick: this.discardChanges, style: style.inputIcon.wrapper },
            _react2.default.createElement(_Icon2.default, {
              color: style.inputIcon.icon.color,
              kind: 'close-thin',
              size: 20,
              height: 40,
              wrapperStyle: style.inputIcon.icon
            })
          ),
          _react2.default.createElement('div', { style: style.clearfix }),
          !!error && _react2.default.createElement(
            _ErrorMessage2.default,
            null,
            error
          ) || !!warning && _react2.default.createElement(
            _WarningMessage2.default,
            null,
            warning
          )
        ),
        _react2.default.createElement(
          'div',
          { onClick: toggleEditingMode, style: [style.button.wrapper, style.button.editing] },
          _react2.default.createElement(_Icon2.default, {
            color: style.button.icon.color,
            kind: 'check',
            size: 25,
            wrapperStyle: [style.button.icon, style.button.iconEditing]
          })
        )
      ),
      _react2.default.createElement('div', { style: [style.overlay] })
    );
  };

  return Active;
}(_StyledComponent3.default), (_applyDecoratedDescriptor(_class2.prototype, 'discardChanges', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'discardChanges'), _class2.prototype)), _class2)) || _class;

Active.styleRoot = 'EditableTextFieldActive';
Active.propTypes = {
  error: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onEditingModeChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  toggleEditingMode: _react.PropTypes.func.isRequired,
  warning: _react.PropTypes.string
};

Active.style = function (_ref) {
  var colors = _ref.colors,
      sizes = _ref.sizes;
  return {
    wrapper: {
      borderTop: '1px solid ' + colors.grayLighter,
      padding: '12px 0px',
      position: 'relative',
      minHeight: '50px',
      boxSizing: 'content-box',
      zIndex: '3'
    },

    clearfix: {
      clear: 'both'
    },

    overlay: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 1,
      transition: 'background-color .2s',
      backgroundColor: 'hsla(0, 0%, 100%, 0.9)'
    },

    inputBase: {
      boxSizing: 'border-box',
      color: colors.inputColor,
      fontWeight: '300',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: colors.inputBorder,
      outline: 'none',
      WebkitAppearance: 'none',
      borderRadius: 0,
      transition: 'border-color .2s',
      height: sizes.inputHeight,
      padding: '0 0 0 10px',
      fontSize: '14px',
      width: '100%',
      float: 'left',
      ':focus': {
        borderColor: colors.primary
      }
    },

    errorInput: {
      borderColor: colors.error,
      transition: 'box-shadow 0.2s',
      ':focus': {
        borderColor: '#a60017',
        boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 6px #ff405a'
      }
    },

    inputWrapper: {
      position: 'relative',
      padding: '5px 60px 5px 0px'
    },

    inputIcon: {
      wrapper: {
        position: 'absolute',
        right: '70px',
        top: '5px'
      },

      icon: {
        display: 'inline-block',
        cursor: 'pointer',
        transition: 'color .2s',
        color: colors.gray,
        ':hover': {
          color: colors.grayDarker
        }
      }
    },

    error: {
      marginLeft: '-24px',
      padding: '5px 60px 5px 20px'
    },

    button: {
      wrapper: {
        cursor: 'pointer',
        position: 'absolute',
        right: 0,
        top: '12px',
        height: '50px',
        width: '50px',
        backgroundColor: colors.secondary,
        textAlign: 'center',
        boxShadow: '0 1px 3px rgba(0,0,0,.2)',
        transition: 'background-color .2s',
        ':hover': {
          backgroundColor: colors.secondaryDarker
        }
      },

      editing: {
        backgroundColor: colors.primary,
        ':hover': {
          backgroundColor: colors.primaryDarker
        }
      },

      icon: {
        color: colors.white,
        display: 'inline-block',
        padding: '12px 0',
        width: '50px',
        transition: 'color .2s',
        ':hover': {
          color: colors.black
        }
      },

      iconEditing: {
        ':hover': {
          color: colors.white
        }
      }
    }
  };
};

exports.default = Active;
module.exports = exports['default'];