'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Inactive = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Inactive, _StyledComponent);

  function Inactive() {
    (0, _classCallCheck3.default)(this, Inactive);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Inactive.prototype.render = function render() {
    var _props = this.props,
        fieldName = _props.fieldName,
        label = _props.label,
        toggleEditingMode = _props.toggleEditingMode;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.wrapper },
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: style.fieldName },
          fieldName
        ),
        _react2.default.createElement(
          'span',
          { className: name + 'Label', style: style.label },
          label
        )
      ),
      _react2.default.createElement(
        'div',
        { onClick: toggleEditingMode, style: style.button.wrapper },
        _react2.default.createElement(_Icon2.default, {
          color: style.button.icon.color,
          kind: 'edit',
          size: 25,
          wrapperStyle: style.button.icon
        })
      )
    );
  };

  return Inactive;
}(_StyledComponent3.default)) || _class;

Inactive.styleRoot = 'EditableTextFieldInactive';
Inactive.propTypes = {
  fieldName: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  toggleEditingMode: _react.PropTypes.func.isRequired
};

Inactive.style = function (_ref) {
  var colors = _ref.colors;
  return {
    wrapper: {
      borderTop: '1px solid ' + colors.grayLighter,
      padding: '12px 0px',
      position: 'relative',
      minHeight: '50px',
      boxSizing: 'content-box'
    },

    overlay: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 1,
      transition: 'background-color .2s',
      backgroundColor: 'hsla(0, 0%, 100%, 0.9)'
    },

    fieldName: {
      fontSize: '16px',
      lineHeight: '1.3',
      color: colors.gray
    },

    label: {
      fontSize: '22px',
      lineHeight: '1.4',
      color: colors.grayDarker,
      marginRight: '50px',
      display: 'inline-block',
      wordBreak: 'break-all'
    },

    button: {
      wrapper: {
        cursor: 'pointer',
        position: 'absolute',
        right: 0,
        top: '12px',
        height: '50px',
        width: '50px',
        backgroundColor: colors.gray,
        textAlign: 'center',
        boxShadow: '0 1px 3px rgba(0,0,0,.2)',
        transition: 'background-color .2s',
        ':hover': {
          backgroundColor: colors.grayDarker
        }
      },

      icon: {
        color: colors.white,
        display: 'inline-block',
        padding: '12px 0',
        width: '50px',
        transition: 'color .2s',
        ':hover': {
          color: colors.black
        }
      }
    }
  };
};

exports.default = Inactive;
module.exports = exports['default'];