'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Label = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Label, _StyledComponent);

  function Label() {
    (0, _classCallCheck3.default)(this, Label);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Label.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        inheritedStyle = _props.inheritedStyle,
        name = _props.name,
        optional = _props.optional;

    var style = this.getStyle();

    return _react2.default.createElement(
      'label',
      {
        htmlFor: name,
        style: [style.base, inheritedStyle]
      },
      children,
      !!optional && _react2.default.createElement(
        'span',
        { style: style.optional },
        ' (' + optional + ')'
      )
    );
  };

  return Label;
}(_StyledComponent3.default)) || _class;

Label.styleRoot = 'Label';
Label.propTypes = {
  children: _react.PropTypes.any.isRequired,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  name: _react.PropTypes.string,
  optional: _react.PropTypes.string
};

Label.style = function () {
  return {
    base: {
      display: 'block',
      fontSize: '16px',
      fontWeight: 'bold',
      color: 'hsl(0, 0%, 30%)',
      marginBottom: '3px'
    },
    optional: {
      fontWeight: '300',
      fontSize: '13px',
      color: 'hsl(0, 0%, 50%)'
    }
  };
};

exports.default = Label;
module.exports = exports['default'];