'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('./ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('./wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _handleEvent = require('./handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _Label = require('./Label.react');

var _Label2 = _interopRequireDefault(_Label);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _WarningMessage = require('./WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PasswordField = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(PasswordField, _StyledComponent);

  function PasswordField() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PasswordField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.state = { showPassword: false }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  PasswordField.prototype.getType = function getType() {
    var showPassword = this.state.showPassword;


    return showPassword ? 'text' : 'password';
  };

  PasswordField.prototype.toggleVisibility = function toggleVisibility() {
    var _props = this.props,
        onHidePassword = _props.onHidePassword,
        onShowPassword = _props.onShowPassword;
    var showPassword = this.state.showPassword;


    if (showPassword && !!onHidePassword) onHidePassword();

    if (!showPassword && !!onShowPassword) onShowPassword();

    this.setState({ showPassword: !showPassword });
  };

  PasswordField.prototype.renderStyles = function renderStyles() {
    return _react2.default.createElement(_radium.Style, { rules: {
        '.passwordHidden::-webkit-input-placeholder': {
          color: 'white'
        },
        '.passwordHidden::-moz-placeholder': {
          color: 'white'
        },
        '.passwordHidden:-ms-input-placeholder': {
          color: 'white'
        }
      }
    });
  };

  PasswordField.prototype.renderPasswordTogglerIcon = function renderPasswordTogglerIcon() {
    var showPassword = this.state.showPassword;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { onClick: this.toggleVisibility.bind(this), style: style.passwordShowIcon },
      _react2.default.createElement(_Icon2.default, {
        color: showPassword ? '#fff' : '#363636',
        kind: showPassword ? 'eye' : 'eye-hidden',
        size: 18,
        style: { height: '40px' }
      })
    );
  };

  PasswordField.prototype.renderPasswordTogglerText = function renderPasswordTogglerText() {
    var _props2 = this.props,
        hidePasswordText = _props2.hidePasswordText,
        showPasswordText = _props2.showPasswordText;
    var showPassword = this.state.showPassword;

    var style = this.getStyle();

    return _react2.default.createElement(
      'a',
      { onClick: this.toggleVisibility.bind(this), style: style.passwordShowText },
      showPassword ? hidePasswordText : showPasswordText
    );
  };

  PasswordField.prototype.render = function render() {
    var showPassword = this.state.showPassword;
    var _props3 = this.props,
        hidePasswordToggle = _props3.hidePasswordToggle,
        error = _props3.error,
        label = _props3.label,
        name = _props3.name,
        onBlur = _props3.onBlur,
        onChange = _props3.onChange,
        onFocus = _props3.onFocus,
        placeholder = _props3.placeholder,
        tooltip = _props3.tooltip,
        value = _props3.value,
        warning = _props3.warning;

    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      this.renderStyles(),
      !!label && _react2.default.createElement(
        _Label2.default,
        { name: name },
        label
      ),
      _react2.default.createElement(
        'div',
        { style: style.inputWrapper },
        _react2.default.createElement(
          'div',
          { style: [style.passwordWrapper.base, hidePasswordToggle && style.passwordWrapper.togglerHidden] },
          _react2.default.createElement('input', {
            className: showPassword && 'passwordHidden',
            id: name,
            key: 'input',
            name: name,
            onBlur: _handleEvent2.default.bind(null, name, onBlur),
            onChange: _handleEvent2.default.bind(null, name, onChange),
            onFocus: _handleEvent2.default.bind(null, name, onFocus),
            placeholder: placeholder,
            style: [style.inputBase, error && style.errorInput, showPassword && style.passwordShown],
            type: this.getType(),
            value: value
          }),
          hidePasswordToggle ? null : this.renderPasswordTogglerIcon.bind(this)()
        ),
        hidePasswordToggle ? null : this.renderPasswordTogglerText.bind(this)(),
        _react2.default.createElement('div', { style: style.clearfix })
      ),
      !!tooltip && _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: tooltip }, style: style.hint }),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      )
    );
  };

  return PasswordField;
}(_StyledComponent3.default)) || _class;

PasswordField.styleRoot = 'PasswordField';
PasswordField.propTypes = {
  error: _react.PropTypes.string,
  hidePasswordToggle: _react.PropTypes.bool,
  label: _react.PropTypes.string,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  onHidePassword: _react.PropTypes.func,
  onShowPassword: _react.PropTypes.func,
  placeholder: _react.PropTypes.string,
  tooltip: _react.PropTypes.string,
  value: _react.PropTypes.string,
  warning: _react.PropTypes.string,
  hidePasswordText: _react.PropTypes.string,
  showPasswordText: _react.PropTypes.string
};
PasswordField.defaultProps = {
  hidePasswordText: 'Hide password',
  hidePasswordToggle: false,
  showPasswordText: 'Show password',
  type: 'password'
};

PasswordField.style = function (_ref) {
  var _inputWrapper, _base, _passwordShowText;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries,
      sizes = _ref.sizes;
  return {
    inputWrapper: (_inputWrapper = {
      marginTop: '5px',
      position: 'relative',
      height: sizes.inputHeight,
      maxWidth: '400px'
    }, _inputWrapper[mediaQueries.breakpointSmall] = {
      maxWidth: '100%'
    }, _inputWrapper),
    clearfix: {
      clear: 'both'
    },
    hint: {
      fontSize: '13px',
      color: 'hsl(0, 0%, 58%)',
      marginTop: '5px',
      maxWidth: '400px'
    },
    inputBase: {
      boxSizing: 'border-box',
      color: colors.inputColor,
      fontWeight: '300',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: colors.inputBorder,
      outline: 'none',
      WebkitAppearance: 'none',
      transition: 'border-color .2s',
      height: sizes.inputHeight,
      fontSize: '14px',
      width: '100%',
      float: 'left',
      ':focus': {
        borderColor: colors.primary
      }
    },
    passwordWrapper: {
      base: (_base = {
        height: '40px',
        display: 'inline-block',
        position: 'relative',
        width: 'calc(100% - 105px)',
        verticalAlign: 'middle'
      }, _base[mediaQueries.breakpointSmall] = {
        width: '100%'
      }, _base),
      togglerHidden: {
        width: '100%'
      }
    },
    errorInput: {
      borderColor: colors.error,
      transition: 'box-shadow 0.2s',
      ':focus': {
        borderColor: '#a60017',
        boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 6px #ff405a'
      }
    },
    passwordShowIcon: {
      position: 'absolute',
      top: '0px',
      right: '0px',
      height: '40px',
      width: '40px',
      textAlign: 'center',
      cursor: 'pointer'
    },
    passwordShowText: (_passwordShowText = {
      display: 'inline-block',
      color: colors.grayDarker,
      cursor: 'pointer',
      fontSize: '10px',
      marginLeft: '10px',
      textTransform: 'uppercase',
      verticalAlign: 'middle',
      borderBottom: '1px solid #B3B5B6',
      userSelect: 'none',
      transition: 'border-bottom .2s'
    }, _passwordShowText[mediaQueries.breakpointSmall] = {
      display: 'none'
    }, _passwordShowText[':hover'] = {
      color: '#8c0013',
      borderBottom: '1px solid #8c0013'
    }, _passwordShowText),
    passwordShown: {
      backgroundColor: colors.grayLight,
      color: colors.white
    },
    ErrorWrapper: {
      base: {
        margin: '10px 0 40px 0',
        clear: 'both'
      }
    }
  };
};

exports.default = PasswordField;
module.exports = exports['default'];