'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _handleEvent = require('./handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _Label = require('./Label.react');

var _Label2 = _interopRequireDefault(_Label);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PureSelect = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(PureSelect, _StyledComponent);

  function PureSelect() {
    (0, _classCallCheck3.default)(this, PureSelect);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  PureSelect.prototype.getSelectedValue = function getSelectedValue(value) {
    if (typeof value === 'boolean') return value.toString();

    if (typeof value === 'number' && !isNaN(value)) return value;

    return value || '';
  };

  PureSelect.prototype.renderOption = function renderOption(option) {
    var text = option.text,
        value = option.value;

    var optionText = text && text || value;
    return _react2.default.createElement(
      'option',
      { key: value, value: typeof value === 'boolean' ? value.toString() : value },
      optionText
    );
  };

  PureSelect.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        error = _props.error,
        iconName = _props.iconName,
        iconSize = _props.iconSize,
        iconStyle = _props.iconStyle,
        iconWrapperStyle = _props.iconWrapperStyle,
        label = _props.label,
        name = _props.name,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        optional = _props.optional,
        options = _props.options,
        placeholder = _props.placeholder,
        selectSize = _props.selectSize,
        value = _props.value;

    var selectedValue = this.getSelectedValue(value);
    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      null,
      !!label && _react2.default.createElement(
        _Label2.default,
        { name: name, optional: optional },
        label
      ),
      _react2.default.createElement(
        'div',
        { style: [style.selectWrapper, selectSize && style.selectWrapper.size[selectSize]] },
        _react2.default.createElement(
          'select',
          {
            key: 'select',
            name: name,
            onBlur: _handleEvent2.default.bind(null, name, onBlur),
            onChange: _handleEvent2.default.bind(null, name, onChange),
            onFocus: _handleEvent2.default.bind(null, name, onFocus),
            style: [style.select, error && style.errorSelect],
            value: selectedValue
          },
          !!placeholder && _react2.default.createElement(
            'option',
            { disabled: true, key: 'blank', value: '' },
            placeholder
          ),
          children || options.map(this.renderOption)
        ),
        _react2.default.createElement(_Icon2.default, {
          color: style.icon.color,
          kind: iconName,
          size: iconSize,
          style: iconStyle,
          wrapperStyle: [style.icon, iconWrapperStyle]
        })
      )
    );
  };

  return PureSelect;
}(_StyledComponent3.default)) || _class;

PureSelect.styleRoot = 'PureSelect';
PureSelect.propTypes = {
  children: _react.PropTypes.arrayOf(_react.PropTypes.node),
  error: _react.PropTypes.string,
  iconName: _react.PropTypes.string,
  iconSize: _react.PropTypes.number,
  iconStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  iconWrapperStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  optional: _react.PropTypes.string,
  options: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    text: _react.PropTypes.string,
    tooltip: _react.PropTypes.string
  })),
  placeholder: _react.PropTypes.string,
  selectSize: _react.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
  value: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string, _react.PropTypes.number])
};
PureSelect.defaultProps = {
  iconName: 'select',
  iconSize: 12,
  options: [{ value: 'test value 1', text: 'Test Value 1' }, { value: 'test value 2', text: 'Test Value 2' }]
};

PureSelect.style = function (_ref) {
  var colors = _ref.colors,
      sizes = _ref.sizes;
  return {
    select: {
      appearance: 'none',
      backgroundColor: colors.white,
      borderColor: 'hsl(0, 0%, 80%)',
      borderRadius: '2px',
      borderStyle: 'solid',
      borderWidth: '1px',
      color: 'hsl(0, 0%, 30%)',
      cursor: 'pointer',
      fontSize: '14px',
      fontWeight: '300',
      height: sizes.inputHeight,
      outline: 'none',
      padding: '4px 20px',
      position: 'relative',
      transition: 'border-color .2s',
      WebkitAppearance: 'none',
      width: '100%',
      ':focus': {
        borderColor: colors.primary
      },
      '@media screen and (-ms-high-contrast: active), (-ms-high-contrast: none)': {
        padding: '4px 4px 4px 20px'
      }
    },

    errorSelect: {
      borderColor: colors.error,
      transition: 'box-shadow 0.2s',
      ':focus': {
        borderColor: '#a60017',
        boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 6px #ff405a'
      }
    },

    selectWrapper: {
      position: 'relative',
      size: {
        1: {
          maxWidth: 80
        },
        2: {
          maxWidth: 110
        },
        3: {
          maxWidth: 140
        },
        4: {
          maxWidth: 170
        },
        5: {
          maxWidth: 200
        },
        6: {
          maxWidth: 230
        },
        7: {
          maxWidth: 260
        },
        8: {
          maxWidth: 290
        },
        9: {
          maxWidth: 320
        },
        10: {
          maxWidth: 350
        }
      }
    },

    icon: {
      color: colors.black,
      height: sizes.inputHeight,
      lineHeight: sizes.inputHeight,
      pointerEvents: 'none',
      position: 'absolute',
      right: 0,
      top: '1px',
      userSelect: 'none',
      width: '24px',
      '@media screen and (-ms-high-contrast: active), (-ms-high-contrast: none)': {
        display: 'none'
      }
    }
  };
};

exports.default = PureSelect;
module.exports = exports['default'];