'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _handleEvent = require('./handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _Tooltip = require('./Tooltip.react');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadioInput = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(RadioInput, _StyledComponent);

  function RadioInput() {
    (0, _classCallCheck3.default)(this, RadioInput);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  RadioInput.prototype.render = function render() {
    var _props = this.props,
        name = _props.name,
        onChange = _props.onChange,
        selected = _props.selected,
        value = _props.value,
        tooltip = _props.tooltip,
        horizontal = _props.horizontal,
        label = _props.label;

    var focused = _radium2.default.getState(this.state, 'input', ':focus');
    var optionText = label || value;
    var style = this.getStyle();

    return _react2.default.createElement(
      'label',
      { style: [style.wrapper, horizontal && style.horizontal] },
      _react2.default.createElement(
        'div',
        { style: [style.base, selected && style.baseChecked, focused && style.baseFocused]
        },
        _react2.default.createElement('div', { style: [style.unchecked, selected && style.checked] })
      ),
      _react2.default.createElement('input', {
        checked: selected,
        key: 'input',
        name: name,
        onChange: _handleEvent2.default.bind(null, name, onChange),
        style: style.input,
        type: 'radio',
        value: value
      }),
      _react2.default.createElement(
        'div',
        { style: style.text },
        optionText
      ),
      _react2.default.createElement(_Tooltip2.default, { tooltip: tooltip })
    );
  };

  return RadioInput;
}(_StyledComponent3.default)) || _class;

RadioInput.styleRoot = 'RadioInput';
RadioInput.propTypes = {
  horizontal: _react.PropTypes.bool,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  selected: _react.PropTypes.bool.isRequired,
  label: _react.PropTypes.string,
  tooltip: _react.PropTypes.string,
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]).isRequired
};
RadioInput.defaultProps = {
  value: ''
};

RadioInput.style = function (_ref) {
  var _wrapper;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    wrapper: (_wrapper = {
      position: 'relative',
      display: 'inline-block',
      padding: '0 30px 0 25px',
      userSelect: 'none',
      cursor: 'pointer',
      fontWeight: 'normal'
    }, _wrapper[mediaQueries.breakpointLaptopSmall] = {
      display: 'block',
      margin: '10px 0'
    }, _wrapper),

    horizontal: {
      display: 'block'
    },

    input: {
      position: 'absolute',
      left: '-9999px',
      ':focus': {}
    },

    text: {
      padding: '4px 12px',
      display: 'inline-block',
      verticalAlign: 'top'
    },

    base: {
      width: '28px',
      height: '28px',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: 'hsl(0, 0%, 80%)',
      borderRadius: '100%',
      position: 'absolute',
      top: 0,
      left: 0,
      transition: 'border-color .2s ease-in-out'
    },

    baseFocused: {
      borderColor: 'hsl(0, 0%, 50%)',
      backgroundColor: 'hsl(0, 0%, 95%)'
    },

    baseChecked: {
      borderColor: 'hsl(0, 0%, 50%)'
    },

    unchecked: {
      backgroundColor: colors.primary,
      width: '14px',
      height: '14px',
      borderRadius: '100%',
      position: 'absolute',
      top: '6px',
      left: '6px',
      transform: 'scale(0, 0)'
    },

    checked: {
      transform: 'scale(1, 1)',
      transition: 'transform .2s'
    }
  };
};

exports.default = RadioInput;
module.exports = exports['default'];