'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('./ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('./wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _Label = require('./Label.react');

var _Label2 = _interopRequireDefault(_Label);

var _RadioInput = require('./RadioInput.react');

var _RadioInput2 = _interopRequireDefault(_RadioInput);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _WarningMessage = require('./WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadioSelect = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(RadioSelect, _StyledComponent);

  function RadioSelect() {
    (0, _classCallCheck3.default)(this, RadioSelect);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  RadioSelect.prototype.render = function render() {
    var _props = this.props,
        error = _props.error,
        horizontal = _props.horizontal,
        label = _props.label,
        name = _props.name,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        options = _props.options,
        tooltip = _props.tooltip,
        value = _props.value,
        warning = _props.warning;

    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      _react2.default.createElement(
        _Label2.default,
        { name: name },
        label
      ),
      !!tooltip && _react2.default.createElement(
        'div',
        { style: style.hint },
        tooltip
      ),
      options.map(function (option) {
        return _react2.default.createElement(_RadioInput2.default, (0, _extends3.default)({
          horizontal: horizontal,
          key: option.value,
          name: name,
          onBlur: onBlur,
          onChange: onChange,
          onFocus: onFocus,
          selected: value === option.value
        }, option));
      }),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      )
    );
  };

  return RadioSelect;
}(_StyledComponent3.default)) || _class;

RadioSelect.styleRoot = 'RadioSelect';
RadioSelect.propTypes = {
  error: _react.PropTypes.string,
  horizontal: _react.PropTypes.bool,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  options: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    value: _react.PropTypes.string.isRequired,
    text: _react.PropTypes.string,
    tooltip: _react.PropTypes.string
  }).isRequired).isRequired,
  tooltip: _react.PropTypes.string,
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  warning: _react.PropTypes.string
};
RadioSelect.defaultProps = {
  options: [{ value: 'test value 1', text: 'Test Value 1', tooltip: 'tooltip 1' }, { value: 'test value 2', text: 'Test Value 2', tooltip: 'tooltip 2' }]
};
RadioSelect.style = {
  hint: {
    paddingBottom: '10px',
    fontSize: '13px',
    color: 'hsl(0, 0%, 58%)',
    marginTop: '5px',
    maxWidth: '400px'
  }
};
exports.default = RadioSelect;
module.exports = exports['default'];