'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('./ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('./wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _PureSelect = require('./PureSelect.react');

var _PureSelect2 = _interopRequireDefault(_PureSelect);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _WarningMessage = require('./WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Select = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Select, _StyledComponent);

  function Select() {
    (0, _classCallCheck3.default)(this, Select);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Select.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        error = _props.error,
        label = _props.label,
        name = _props.name,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        optional = _props.optional,
        options = _props.options,
        placeholder = _props.placeholder,
        size = _props.size,
        hint = _props.hint,
        value = _props.value,
        warning = _props.warning;

    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      _react2.default.createElement(
        _PureSelect2.default,
        {
          error: error,
          label: label,
          name: name,
          optional: optional,
          options: options,
          onBlur: onBlur,
          onChange: onChange,
          onFocus: onFocus,
          placeholder: placeholder,
          selectSize: size,
          value: value
        },
        children
      ),
      !!hint && _react2.default.createElement(
        'div',
        { style: style.hint },
        hint
      ),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      )
    );
  };

  return Select;
}(_StyledComponent3.default)) || _class;

Select.styleRoot = 'Select';
Select.propTypes = {
  children: _react.PropTypes.arrayOf(_react.PropTypes.node),
  error: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  optional: _react.PropTypes.string,
  options: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    tooltip: _react.PropTypes.string
  })),
  placeholder: _react.PropTypes.string,
  size: _react.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
  hint: _react.PropTypes.string,
  value: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string, _react.PropTypes.number]),
  warning: _react.PropTypes.string
};
Select.defaultProps = {
  size: 4
};
Select.style = {
  hint: {
    color: 'hsl(0, 0%, 58%)',
    fontSize: '13px',
    marginTop: '5px'
  }
};
exports.default = Select;
module.exports = exports['default'];