'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('../ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('../wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _handleEvent = require('../handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _WarningMessage = require('../WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OtherInput = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(OtherInput, _StyledComponent);

  function OtherInput() {
    (0, _classCallCheck3.default)(this, OtherInput);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  OtherInput.prototype.render = function render() {
    var _props = this.props,
        error = _props.error,
        name = _props.name,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        placeholder = _props.placeholder,
        value = _props.value,
        wrapperStyle = _props.wrapperStyle,
        warning = _props.warning;

    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, inheritedStyle: style.errorWrapper, warning: !!warning },
      _react2.default.createElement(
        'div',
        { style: [style.inputWrapper, wrapperStyle] },
        _react2.default.createElement('div', { style: style.arrow }),
        _react2.default.createElement('input', {
          name: name,
          onBlur: _handleEvent2.default.bind(null, name, onBlur),
          onChange: _handleEvent2.default.bind(null, name, onChange),
          onFocus: _handleEvent2.default.bind(null, name, onFocus),
          placeholder: placeholder,
          style: [style.input, error && style.errorInput],
          type: 'text',
          value: value || ''
        })
      ),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      )
    );
  };

  return OtherInput;
}(_StyledComponent3.default)) || _class;

OtherInput.styleRoot = 'OtherInput';
OtherInput.propTypes = {
  error: _react.PropTypes.string,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  placeholder: _react.PropTypes.string,
  value: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string, _react.PropTypes.number]),
  warning: _react.PropTypes.string,
  wrapperStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object])
};

OtherInput.style = function (_ref) {
  var colors = _ref.colors,
      sizes = _ref.sizes;
  return {
    arrow: {
      width: 0,
      height: 0,
      borderLeft: '8px solid transparent',
      borderRight: '8px solid transparent',
      borderBottom: '8px solid white',
      position: 'absolute',
      bottom: '100%',
      left: '15px'
    },

    inputWrapper: {
      position: 'relative',
      padding: '15px',
      marginTop: '20px',
      backgroundColor: 'white',
      borderRadius: '2px',
      boxShadow: '1px 1px 2px 0px rgba(50, 50, 50, 0.1)',
      border: '1px solid #f3f3f3',
      maxWidth: '375px'
    },

    input: {
      boxSizing: 'border-box',
      backgroundColor: '#F2F2F2',
      color: colors.inputColor,
      fontWeight: '300',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderRadius: '2px',
      borderColor: colors.inputBorder,
      outline: 'none',
      WebkitAppearance: 'none',
      transition: 'border-color .2s',
      height: sizes.inputHeight,
      padding: '0 0 0 10px',
      fontSize: '14px',
      width: '100%',
      ':focus': {
        borderColor: colors.primary
      }
    },

    errorInput: {
      borderColor: colors.error,
      transition: 'box-shadow 0.2s',
      ':focus': {
        borderColor: '#a60017',
        boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 6px #ff405a'
      }
    },

    errorWrapper: {
      marginTop: 0,
      marginBottom: 0
    }
  };
};

exports.default = OtherInput;
module.exports = exports['default'];