'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('../ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('../wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _PureSelect = require('../PureSelect.react');

var _PureSelect2 = _interopRequireDefault(_PureSelect);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _WarningMessage = require('../WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectWithOther = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(SelectWithOther, _StyledComponent);

  function SelectWithOther() {
    (0, _classCallCheck3.default)(this, SelectWithOther);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  SelectWithOther.prototype.render = function render() {
    var _React$createElement;

    var _props = this.props,
        children = _props.children,
        error = _props.error,
        label = _props.label,
        name = _props.name,
        onBlur = _props.onBlur,
        onChange = _props.onChange,
        onFocus = _props.onFocus,
        options = _props.options,
        placeholder = _props.placeholder,
        size = _props.size,
        showInputOn = _props.showInputOn,
        tooltip = _props.tooltip,
        value = _props.value,
        warning = _props.warning;

    var style = this.getStyle();
    var inputVisible = showInputOn.indexOf(value) !== -1;

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      _react2.default.createElement(_PureSelect2.default, (_React$createElement = {
        error: error,
        label: label,
        name: name,
        options: options,
        onBlur: onBlur
      }, _React$createElement['onBlur'] = onBlur, _React$createElement.onChange = onChange, _React$createElement.onFocus = onFocus, _React$createElement['onFocus'] = onFocus, _React$createElement.placeholder = placeholder, _React$createElement.selectSize = size, _React$createElement.value = value, _React$createElement)),
      inputVisible && children,
      !!tooltip && _react2.default.createElement(
        'div',
        { style: style.hint },
        tooltip
      ),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      )
    );
  };

  return SelectWithOther;
}(_StyledComponent3.default)) || _class;

SelectWithOther.styleRoot = 'SelectWithOther';
SelectWithOther.propTypes = {
  children: _react.PropTypes.any,
  error: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  options: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    tooltip: _react.PropTypes.string
  }).isRequired),
  placeholder: _react.PropTypes.string,
  showInputOn: _react.PropTypes.array,
  size: _react.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
  tooltip: _react.PropTypes.string,
  value: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string, _react.PropTypes.number]),
  warning: _react.PropTypes.string
};
SelectWithOther.defaultProps = {
  children: 'Insert your component here',
  showInputOn: ['test value 2'],
  size: 4
};

SelectWithOther.style = function (_ref) {
  var colors = _ref.colors;
  return {
    hint: {
      color: colors.textSecondary,
      fontSize: '0.8em'
    }
  };
};

exports.default = SelectWithOther;
module.exports = exports['default'];