'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ErrorMessage = require('./ErrorMessage.react');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _FieldWrapper = require('./wrappers/FieldWrapper.react');

var _FieldWrapper2 = _interopRequireDefault(_FieldWrapper);

var _handleEvent = require('./handle-event');

var _handleEvent2 = _interopRequireDefault(_handleEvent);

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _Label = require('./Label.react');

var _Label2 = _interopRequireDefault(_Label);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _Tooltip = require('./Tooltip.react');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _WarningMessage = require('./WarningMessage.react');

var _WarningMessage2 = _interopRequireDefault(_WarningMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextField = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(TextField, _StyledComponent);

  function TextField() {
    (0, _classCallCheck3.default)(this, TextField);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  TextField.prototype.renderHint = function renderHint() {
    var hint = this.props.hint;

    var style = this.getStyle();

    if (!hint) return null;

    return _react2.default.createElement(
      'div',
      { style: style.hint },
      hint
    );
  };

  TextField.prototype.renderLabel = function renderLabel() {
    var _props = this.props,
        name = _props.name,
        label = _props.label,
        optional = _props.optional;


    if (!label) return null;

    return _react2.default.createElement(
      _Label2.default,
      { name: name, optional: optional },
      label
    );
  };

  TextField.prototype.renderUnit = function renderUnit() {
    var unit = this.props.unit;

    var style = this.getStyle();

    if (!unit) return null;

    return _react2.default.createElement(
      'div',
      { key: 'unit', style: style.unit },
      unit
    );
  };

  TextField.prototype.renderPrependBlock = function renderPrependBlock() {
    var _props2 = this.props,
        icon = _props2.icon,
        iconSize = _props2.iconSize,
        error = _props2.error;

    var size = iconSize || '24px';
    var prependFocused = _radium2.default.getState(this.state, 'input', ':focus');
    var style = this.getStyle();

    if (!icon) return null;

    return _react2.default.createElement(
      'div',
      { style: [style.prepend, prependFocused && style.prependFocus, error && style.errorInput]
      },
      _react2.default.createElement(_Icon2.default, {
        color: style.icon.color,
        kind: icon,
        size: size,
        wrapperStyle: style.icon
      })
    );
  };

  TextField.prototype.renderTooltip = function renderTooltip() {
    var tooltip = this.props.tooltip;

    var style = this.getStyle();

    if (!tooltip) return null;

    return _react2.default.createElement(
      'div',
      { style: style.tooltipWrapper },
      _react2.default.createElement(
        'div',
        { style: style.tooltip },
        _react2.default.createElement(_Tooltip2.default, { tooltip: tooltip })
      )
    );
  };

  TextField.prototype.renderHelp = function renderHelp() {
    var help = this.props.help;

    var style = this.getStyle();

    if (!help) return null;

    return _react2.default.createElement('div', { style: style.help, dangerouslySetInnerHTML: { __html: help } });
  };

  TextField.prototype.render = function render() {
    var _props3 = this.props,
        icon = _props3.icon,
        inheritedStyle = _props3.inheritedStyle,
        name = _props3.name,
        onChange = _props3.onChange,
        unit = _props3.unit,
        value = _props3.value,
        type = _props3.type,
        tooltip = _props3.tooltip,
        error = _props3.error,
        warning = _props3.warning,
        onBlur = _props3.onBlur,
        onFocus = _props3.onFocus,
        placeholder = _props3.placeholder,
        help = _props3.help,
        width = _props3.width;

    var prepend = !!icon;
    var tooltipOrUnit = tooltip || unit;
    var tooltipAndUnit = tooltip && unit;
    var isHelp = !!help;
    var style = this.getStyle();

    return _react2.default.createElement(
      _FieldWrapper2.default,
      { error: !!error, warning: !!warning },
      this.renderLabel(),
      _react2.default.createElement(
        'div',
        { style: style.inputWrapper },
        this.renderPrependBlock(),
        _react2.default.createElement('input', {
          id: name,
          key: 'input',
          name: name,
          onBlur: _handleEvent2.default.bind(null, name, onBlur),
          onChange: _handleEvent2.default.bind(null, name, onChange),
          onFocus: _handleEvent2.default.bind(null, name, onFocus),
          placeholder: placeholder,
          style: [style.inputBase, style.input.width[width], prepend && style.input.prepend, tooltipOrUnit && style.input.tooltipOrUnit, tooltipAndUnit && style.input.tooltipAndUnit, isHelp && style.input.help, error && style.errorInput, warning && style.warningInput, inheritedStyle],
          type: type,
          value: value
        }),
        this.renderUnit(),
        this.renderTooltip(),
        this.renderHelp(),
        _react2.default.createElement('div', { style: style.clearfix })
      ),
      !!error && _react2.default.createElement(
        _ErrorMessage2.default,
        null,
        error
      ) || !!warning && _react2.default.createElement(
        _WarningMessage2.default,
        null,
        warning
      ),
      this.renderHint()
    );
  };

  return TextField;
}(_StyledComponent3.default)) || _class;

TextField.styleRoot = 'TextField';
TextField.propTypes = {
  error: _react.PropTypes.string,
  help: _react.PropTypes.string,
  hint: _react.PropTypes.string,
  icon: _react.PropTypes.string,
  iconSize: _react.PropTypes.string,
  inheritedStyle: _react.PropTypes.object,
  label: _react.PropTypes.string,
  name: _react.PropTypes.string.isRequired,
  onBlur: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onFocus: _react.PropTypes.func,
  optional: _react.PropTypes.string,
  placeholder: _react.PropTypes.string,
  tooltip: _react.PropTypes.string,
  type: _react.PropTypes.string.isRequired,
  unit: _react.PropTypes.string,
  value: _react2.default.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  warning: _react.PropTypes.string,
  width: _react.PropTypes.oneOf(['default', 'full', 'long', 'medium', 'small'])
};
TextField.defaultProps = {
  type: 'text',
  width: 'default'
};

TextField.style = function (_ref) {
  var _inputWrapper, _icon, _help, _base, _unit;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries,
      sizes = _ref.sizes;
  return {
    wrapper: {
      margin: '10px 0 25px 0',
      clear: 'both',
      boxSizing: 'border-box'
    },
    clearfix: {
      clear: 'both'
    },
    prepend: {
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: '#d4d4d4',
      borderRightWidth: '0',
      width: '58px',
      height: sizes.inputHeight,
      transition: 'border-color .2s',
      float: 'left',
      '@media (maxWidth: 480px)?': {
        height: '40px'
      }
    },
    inputWrapper: (_inputWrapper = {
      position: 'relative',
      height: '40px'
    }, _inputWrapper[mediaQueries.breakpointSmall] = {
      maxWidth: '100%'
    }, _inputWrapper),
    errorInput: {
      borderColor: colors.error,
      transition: 'box-shadow 0.2s',
      ':focus': {
        borderColor: '#a60017',
        boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 6px #ff405a'
      }
    },
    warningInput: {
      borderColor: colors.yellowLight,
      transition: 'box-shadow 0.2s',
      ':focus': {
        boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 6px #ff405a'
      }
    },
    hint: {
      fontSize: '13px',
      color: 'hsl(0, 0%, 58%)',
      marginTop: '5px',
      maxWidth: '400px'
    },
    prependFocus: {
      borderColor: colors.primary
    },
    tooltip: {
      position: 'absolute',
      top: '50%',
      transform: 'translateY(-50%)'
    },
    inputBase: {
      boxSizing: 'border-box',
      color: colors.inputColor,
      fontWeight: '300',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: colors.inputBorder,
      outline: 'none',
      WebkitAppearance: 'none',
      transition: 'border-color .2s',
      height: sizes.inputHeight,
      padding: '0 0 0 10px',
      fontSize: '14px',
      width: '100%',
      float: 'left',
      ':focus': {
        borderColor: colors.primary
      }
    },
    icon: (_icon = {
      color: colors.primary,
      lineHeight: sizes.inputHeight,
      textAlign: 'center',
      fontSize: '58px'
    }, _icon[mediaQueries.breakpointSmall] = {
      lineHeight: sizes.inputHeight,
      fontSize: '20px'
    }, _icon),
    help: (_help = {
      height: '100%',
      display: 'inline-block',
      lineHeight: sizes.inputHeight,
      fontSize: '12px',
      marginLeft: '16px'
    }, _help[mediaQueries.breakpointSmall] = {
      fontSize: '10px',
      marginLeft: '10px'
    }, _help),
    tooltipWrapper: {
      display: 'inline-block',
      float: 'left',
      position: 'relative',
      height: '100%'
    },
    input: {
      base: (_base = {
        width: '100%',
        height: '100%',
        float: 'left'
      }, _base[mediaQueries.breakpointSmall] = {
        maxWidth: '100%'
      }, _base),
      width: {
        full: {
          maxWidth: '100%'
        },
        default: {
          maxWidth: '300px'
        },
        long: {
          maxWidth: '400px'
        },
        medium: {
          maxWidth: '170px'
        },
        small: {
          maxWidth: '100px'
        }
      },
      prepend: {
        width: 'calc(100% - 58px)'
      },
      tooltipOrUnit: {
        width: 'calc(100% - 40px)'
      },
      tooltipAndUnit: {
        width: 'calc(100% - 65px)'
      },
      help: {
        width: '50%'
      }
    },
    unit: (_unit = {
      display: 'inline-block',
      float: 'left',
      fontWeight: '300',
      color: colors.grayLight,
      height: sizes.inputHeight,
      lineHeight: sizes.inputHeight,
      padding: '0 5px 0 10px',
      userSelect: 'none'
    }, _unit[mediaQueries.breakpointSmall] = {
      height: sizes.inputHeight,
      lineHeight: sizes.inputHeight
    }, _unit)
  };
};

exports.default = TextField;
module.exports = exports['default'];