'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tooltip = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Tooltip, _StyledComponent);

  function Tooltip() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.state = {
      hovered: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  Tooltip.prototype.handleMouseOver = function handleMouseOver() {
    this.setState({ hovered: true });
  };

  Tooltip.prototype.handleMouseOut = function handleMouseOut() {
    this.setState({ hovered: false });
  };

  Tooltip.prototype.render = function render() {
    var _this2 = this;

    var tooltip = this.props.tooltip;
    var hovered = this.state.hovered;

    var style = this.getStyle();
    var iconColor = hovered ? style.iconActive.color : style.iconInactive.color;

    if (!tooltip) return null;

    return _react2.default.createElement(
      'div',
      { style: style.wrapper },
      _react2.default.createElement(
        'div',
        { style: [style.tooltip, hovered && style.tooltip.hovered] },
        _react2.default.createElement(
          'div',
          { className: 'tooltip-content' },
          tooltip
        ),
        _react2.default.createElement('div', { style: style.arrow })
      ),
      _react2.default.createElement(
        'div',
        {
          style: style.icon,
          onMouseOver: function onMouseOver() {
            return _this2.handleMouseOver();
          },
          onMouseOut: function onMouseOut() {
            return _this2.handleMouseOut();
          }
        },
        _react2.default.createElement(_Icon2.default, { color: iconColor, kind: 'info', size: '26px' })
      )
    );
  };

  return Tooltip;
}(_StyledComponent3.default)) || _class;

Tooltip.styleRoot = 'Tooltip';
Tooltip.propTypes = {
  tooltip: _react.PropTypes.any.isRequired
};

Tooltip.style = function (_ref) {
  var colors = _ref.colors;
  return {
    wrapper: {
      position: 'relative',
      width: '36px',
      padding: '0 5px',
      display: 'inline-block'
    },

    icon: {
      display: 'inline-block',
      ':hover': {
        cursor: 'pointer'
      }
    },

    iconActive: {
      color: colors.primary
    },

    iconInactive: {
      color: colors.gray
    },

    tooltip: {
      fontSize: '13px',
      borderRadius: '3px',
      display: 'none',
      padding: '10px',
      backgroundColor: 'rgba(0,0,0,.75)',
      color: 'white',
      position: 'absolute',
      zIndex: 2,
      bottom: 'calc(100% + 8px)',
      right: '50%',
      transform: 'translateX(50%)',
      minWidth: '150px',
      hovered: {
        display: 'block'
      }
    },

    arrow: {
      left: '50%',
      borderStyle: 'solid',
      borderTopColor: 'rgba(0,0,0,.75)',
      top: '100%',
      height: 0,
      width: 0,
      position: 'absolute',
      pointerEvents: 'none',
      borderColor: 'rgba(136, 183, 213, 0)',
      borderWidth: '5px',
      transition: 'all .1s ease',
      transform: 'translateX(-50%)',
      zIndex: 3
    }
  };
};

exports.default = Tooltip;
module.exports = exports['default'];