'use strict';

exports.__esModule = true;

exports.default = function (name, eventHandler, event) {
  event.preventDefault();
  if (!eventHandler) return;

  var payload = {
    name: name,
    value: valueTransform(event.target),
    type: event.target.type
  };
  eventHandler(payload);
};

/**
 * Transforms value based on target element type
 * @param  {object} target Event target
 * @return {mixed}         Transformed value
 */
function valueTransform(target) {
  switch (String(target.type).toLowerCase()) {
    case 'checkbox':
      return target.checked;
    default:
      return target.value;
  }
} /**
   * Handles event on form fields
   * @param  {string} name                 Element name
   * @param  {object} eventHandler         Handler to process fired event
   * @param  {SyntheticEvent} event        React wrapper around browser native events
   * @return {void}
   */
module.exports = exports['default'];