'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldWrapper = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(FieldWrapper, _StyledComponent);

  function FieldWrapper() {
    (0, _classCallCheck3.default)(this, FieldWrapper);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  FieldWrapper.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        error = _props.error,
        inheritedStyle = _props.inheritedStyle,
        name = _props.name,
        warning = _props.warning;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      {
        name: name,
        style: [style.base, inheritedStyle, error && style.hasError, !error && warning && style.hasWarning]
      },
      children
    );
  };

  return FieldWrapper;
}(_StyledComponent3.default)) || _class;

FieldWrapper.styleRoot = 'FormsFieldWrapper';
FieldWrapper.propTypes = {
  children: _react.PropTypes.any.isRequired,
  error: _react.PropTypes.bool.isRequired,
  warning: _react.PropTypes.bool.isRequired,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  name: _react.PropTypes.string
};

FieldWrapper.style = function (_ref) {
  var colors = _ref.colors;
  return {
    base: {
      borderLeft: '4px solid transparent',
      display: 'block',
      paddingLeft: '16px',
      marginTop: '10px',
      marginRight: 0,
      marginBottom: '25px',
      marginLeft: '-20px',
      transition: 'border-left 0.2s'
    },
    hasError: {
      borderLeft: '4px solid ' + colors.error
    },
    hasWarning: {
      borderLeft: '4px solid ' + colors.yellowLight
    }
  };
};

exports.default = FieldWrapper;
module.exports = exports['default'];