'use strict';

exports.__esModule = true;
exports.default = exports.iconList = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class; /* eslint-disable */
// Generated by gulp svg-icon - do not modify manually

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iconList = exports.iconList = ['alarm-clock', 'arrow-right', 'calendar', 'chat-info', 'check', 'chevron', 'chevron-right', 'close-thin', 'conversation', 'dashboard', 'edit', 'envelope', 'eye', 'eye-hidden', 'facebook', 'google_plus', 'handler', 'info', 'instantor', 'linkedin', 'lock', 'menu', 'money-kr', 'pdf-file', 'phone', 'plus-circle', 'security', 'select', 'star', 'twitter', 'wallet'];

var Icon = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Icon, _StyledComponent);

  function Icon() {
    (0, _classCallCheck3.default)(this, Icon);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Icon.prototype.render = function render() {
    var _props = this.props,
        kind = _props.kind,
        preview = _props.preview;


    return preview ? this.renderPreview() : this.renderIcon(kind);
  };

  Icon.prototype.renderPreview = function renderPreview() {
    var _this2 = this;

    return _react2.default.createElement(
      'div',
      null,
      iconList.map(function (kind) {
        return _this2.renderPreviewKind(kind);
      })
    );
  };

  Icon.prototype.renderIcon = function renderIcon(kind) {
    var wrapperStyle = this.props.wrapperStyle;


    if (wrapperStyle) return _react2.default.createElement(
      'div',
      { style: wrapperStyle },
      this.getIcon(kind)
    );

    return this.getIcon(kind);
  };

  Icon.prototype.renderPreviewKind = function renderPreviewKind(kind) {
    return _react2.default.createElement(
      'div',
      { key: kind },
      _react2.default.createElement(
        'h3',
        null,
        '<Icon kind="',
        kind,
        '" />'
      ),
      this.renderIcon(kind)
    );
  };

  Icon.prototype.getIcon = function getIcon(kind) {
    var _React$createElement;

    var _props2 = this.props,
        color = _props2.color,
        height = _props2.height,
        onClick = _props2.onClick,
        size = _props2.size,
        style = _props2.style,
        width = _props2.width;


    switch (kind) {
      default:
        return null;
      case 'alarm-clock':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 90.341 612 612' },
          _react2.default.createElement('path', { d: 'M306.004 170.943c-143.886 0-260.621 115.781-260.621 258.482 0 142.704 116.395 258.48 260.621 258.48 143.876 0 260.612-115.776 260.612-258.48 0-142.7-116.735-258.482-260.612-258.482zm119.939 373.116c-6.806 0-12.893-3.09-16.933-7.943L276.36 457.35l-.005-170.608c0-12.158 9.861-22.015 22.026-22.015 12.167 0 22.027 9.856 22.027 22.015l-.004 148.761 111.897 65.465c9.066 2.727 15.673 11.13 15.673 21.078 0 12.157-9.864 22.013-22.031 22.013zM595.34 215.98L462.207 104.775l-37.306 43.943 133.142 111.211zM186.76 148.718l-36.957-43.943L16.66 215.53l37.298 43.94z' })
        );
      case 'arrow-right':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 29.985 23.003' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M29.985 11.51c0-.017-.005-.033-.005-.05a1.55 1.55 0 0 0-.455-1.108L19.628.455a1.555 1.555 0 0 0-2.199 2.2l7.352 7.352H1.635C.732 10.007 0 10.68 0 11.51s.732 1.503 1.635 1.503h23.129l-7.335 7.335a1.555 1.555 0 0 0 2.199 2.199l9.897-9.897c.299-.299.449-.689.454-1.08.001-.02.006-.039.006-.06z' })
        );
      case 'calendar':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 22 22' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M20.653 22H1.347C.604 22 0 21.382 0 20.625V3.666c0-.758.604-1.375 1.347-1.375h4.041V.458c0-.253.201-.458.449-.458s.449.205.449.458v1.833h4.041V.458A.452.452 0 0 1 10.775 0c.248 0 .449.205.449.458v1.833h4.041V.458c0-.253.201-.458.449-.458s.449.205.449.458v1.833h4.49c.743 0 1.347.617 1.347 1.375v16.959c0 .757-.604 1.375-1.347 1.375zm.449-18.334a.454.454 0 0 0-.449-.458h-4.49v1.375a.454.454 0 0 1-.449.458.454.454 0 0 1-.449-.458V3.208h-4.041v1.375a.454.454 0 0 1-.449.458.454.454 0 0 1-.449-.458V3.208h-4.04v1.375a.454.454 0 0 1-.449.458.454.454 0 0 1-.449-.458V3.208H1.347a.454.454 0 0 0-.449.458v16.959c0 .253.201.458.449.458h19.306a.454.454 0 0 0 .449-.458V3.666zm-4.939 12.376h2.694v2.75h-2.694v-2.75zm.898 1.832h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75h-2.694v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75h-2.694v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-5.388 7.334h2.694v2.75h-2.694v-2.75zm.898 1.832h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75h-2.694v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75h-2.694v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-5.387 7.334h2.694v2.75H7.184v-2.75zm.898 1.832h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75H7.184v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75H7.184v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-5.388 7.334h2.694v2.75H2.694v-2.75zm.898 1.832h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75H2.694v-2.75zm.898 1.833h.898v-.917h-.898v.917zm-.898-6.416h2.694v2.75H2.694v-2.75zm.898 1.833h.898v-.917h-.898v.917z' })
        );
      case 'chat-info':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M255.998 507.5c-43.55 0-86.345-11.318-124.074-32.77L11.247 507.068l31.549-117.736C17.732 349.351 4.503 303.358 4.503 256c0-138.674 112.82-251.5 251.494-251.5 138.673 0 251.5 112.826 251.5 251.5S394.671 507.5 255.998 507.5zm0-481.321C129.283 26.179 26.195 129.273 26.195 256c0 44.759 12.929 88.2 37.387 125.583l2.653 4.06-24.326 90.764 93.166-24.972 3.929 2.358c35.333 20.925 75.798 32.016 116.995 32.016 126.72 0 229.796-103.089 229.796-229.809-.001-126.727-103.077-229.821-229.797-229.821zM245.2 332.451h21.685v32.878H245.2v-32.878zm0-196.632h21.685v163.754H245.2V135.819z' })
        );
      case 'check':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M433.998 71.678L174.594 331.089l-96.327-96.925-65.785 65.782 160.669 160.672 324.817-324.817z' })
        );
      case 'chevron':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M256 302.395L65.076 119.145c-4.713-4.603-12.494-4.493-17.316.219l-33.537 32.771c-4.822 4.712-4.932 12.384-.219 16.987l233.119 223.803c2.41 2.411 5.697 3.507 8.877 3.288 3.288.109 6.466-.986 8.878-3.288l233.118-223.803c4.713-4.604 4.604-12.275-.219-16.987l-33.537-32.771c-4.822-4.712-12.604-4.821-17.317-.219L256 302.395z' })
        );
      case 'chevron-right':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 90.845 177.474' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M89.875 91.259L5.759 176.474c-.659.664-1.522 1-2.385 1a3.354 3.354 0 0 1-2.385-1 3.45 3.45 0 0 1 0-4.835l81.839-82.901L.988 5.832a3.443 3.443 0 0 1 0-4.829 3.338 3.338 0 0 1 4.77 0l84.117 85.214c.686.695.996 1.612.968 2.522.028.909-.281 1.826-.968 2.52z' })
        );
      case 'close-thin':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M448.864 399.824L305.04 256l143.823-143.824-49.04-49.041L256 206.959 112.176 63.135l-49.041 49.042L206.958 256 63.135 399.823l49.04 49.04L255.999 305.04l143.824 143.825z' })
        );
      case 'conversation':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 131.513 131.516' },
          _react2.default.createElement('path', { d: 'M124.937 26.303h-13.151v59.185H26.303v13.151c0 3.596 2.954 6.575 6.576 6.575h72.332l26.302 26.303v-98.64c0-3.698-2.954-6.574-6.576-6.574zM98.634 65.756V6.576C98.634 2.877 95.681 0 92.059 0H6.576C2.954 0 0 2.877 0 6.576v92.062l26.303-26.303h65.756c3.622.001 6.575-2.979 6.575-6.579z' })
        );
      case 'dashboard':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 25.005 20.989' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M22.112 20.674a.864.864 0 0 1-.668.315H3.56a.867.867 0 0 1-.668-.315A12.69 12.69 0 0 1 0 12.609C0 5.657 5.608 0 12.502 0c6.894 0 12.503 5.657 12.503 12.609 0 2.943-1.027 5.806-2.893 8.065zm-9.61-18.921c-5.936 0-10.764 4.87-10.764 10.856 0 2.398.793 4.735 2.239 6.627h17.051a10.931 10.931 0 0 0 2.24-6.627c-.001-5.986-4.83-10.856-10.766-10.856zm9.111 11.52h-.938a.523.523 0 0 1-.521-.526c0-.29.233-.525.521-.525h.938c.288 0 .521.235.521.525a.523.523 0 0 1-.521.526zm-2.584-5.974a.516.516 0 0 1-.737 0 .53.53 0 0 1 0-.744l.667-.672a.519.519 0 0 1 .738 0 .528.528 0 0 1 0 .743l-.668.673zm-6.488 9.765c-.453 0-.863-.188-1.159-.489l-.014-.017a1.653 1.653 0 0 1-.201-.26l-4.651-5.656.002-.001a.922.922 0 0 1 .718-1.497c.226 0 .429.085.589.221l.002-.002 5.63 4.697h-.001c.431.296.715.794.715 1.36 0 .908-.731 1.644-1.63 1.644zm.075-12.318a.524.524 0 0 1-.522-.526v-.87c0-.291.234-.526.522-.526.288 0 .521.235.521.526v.87c0 .29-.233.526-.521.526zm-6.12 2.707a.516.516 0 0 1-.369-.154l-.678-.684a.529.529 0 0 1 0-.744.517.517 0 0 1 .737 0l.678.684a.529.529 0 0 1 0 .744.516.516 0 0 1-.368.154zm-2.222 5.819h-.9a.523.523 0 0 1-.521-.526c0-.291.233-.526.521-.526h.9c.288 0 .522.235.522.526a.525.525 0 0 1-.522.526z' })
        );
      case 'edit':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M491.519 126.535l-71.86 71.689L313.966 92.678l22.002-21.953 28.124-28.076 21.71-21.661s42.467-43.174 95.716 10.001c53.249 53.177 10.001 95.546 10.001 95.546zm-99.986 99.766L140.926 476.372h-.025L3.913 507.547 35.208 370.85V370.778h.024L285.84 120.754l105.693 105.547z' })
        );
      case 'envelope':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 117.5 111.626' },
          _react2.default.createElement('path', { d: 'M117.437 41.126c0-4.229-2.174-7.929-5.518-9.989L58.75 0 5.577 31.137A11.697 11.697 0 0 0 0 41.126v58.75c0 6.466 5.284 11.75 11.751 11.75h93.999c6.461 0 11.75-5.284 11.75-11.75l-.063-58.75zM58.75 70.502L10.224 40.186 58.75 11.75l48.526 28.436L58.75 70.502z' })
        );
      case 'eye':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M256.598 401.331c-100.737 0-192.297-69.299-249.788-153.566 58.011-81.315 149.558-137.096 249.788-137.096 100.441 0 192.294 54.81 248.593 136.58-53.382 88.965-144.763 154.082-248.593 154.082M59.555 248.467c48.125 59.44 119.186 110.52 197.044 110.52 106.058 0 174.706-79.477 197.19-110.058-47.83-56.273-118.205-95.916-197.19-95.916-102.597-.001-172.52 67.528-197.044 95.454m199.239-76.379c-46.344 0-83.912 37.568-83.912 83.911 0 46.344 37.569 83.911 83.912 83.911 46.344 0 83.913-37.567 83.913-83.911 0-46.343-37.569-83.911-83.913-83.911m-.077 83.883c-11.845 11.844-31.047 11.844-42.892 0-11.845-11.845-11.845-31.049 0-42.893 11.845-11.845 31.047-11.845 42.892 0 11.846 11.845 11.846 31.049 0 42.893' })
        );
      case 'eye-hidden':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M88.443 336.543l38.4-23.817c-25.379-18.308-48.149-40.619-67.288-64.259 24.524-27.926 94.447-95.454 197.044-95.454 33.79 0 66.001 7.26 95.548 19.969l42.392-26.293c-41.833-22.926-88.859-36.019-137.94-36.019-100.23 0-191.777 55.78-249.788 137.096 22.491 32.967 50.2 63.644 81.632 88.777z' }),
          _react2.default.createElement('path', { d: 'M258.717 213.079a30.174 30.174 0 0 1 7.705 13.072l50.065-31.052c-15.04-14.252-35.338-23.011-57.693-23.011-46.344 0-83.912 37.568-83.912 83.911a83.864 83.864 0 0 0 3.685 24.645l38.252-23.727c-.336-.308-.669-.62-.995-.945-11.845-11.845-11.845-31.049 0-42.893 11.846-11.845 31.048-11.845 42.893 0zM431.536 170.509l-39.02 24.202c23.014 15.057 43.671 33.509 61.272 54.218-22.484 30.581-91.133 110.058-197.19 110.058-32.112 0-63.066-8.695-91.733-23.076l-41.079 25.479c40.563 24.771 85.683 39.941 132.812 39.941 103.83 0 195.211-65.117 248.593-154.082-20.336-29.536-45.312-55.552-73.655-76.74z' }),
          _react2.default.createElement('path', { d: 'M258.794 339.91c46.344 0 83.913-37.567 83.913-83.911a83.735 83.735 0 0 0-4.64-27.516L198.932 314.78c15.226 15.504 36.416 25.13 59.862 25.13zM503.548 104.562l-1.884-3.038c-2.511-4.049-6.976-6.466-11.94-6.466-2.849 0-5.66.81-8.132 2.342L13.677 387.622c-3.395 2.105-5.803 5.338-6.782 9.102-.97 3.728-.417 7.532 1.557 10.712l1.884 3.039c2.512 4.05 6.977 6.468 11.943 6.468h.001c2.847 0 5.657-.81 8.127-2.342l467.917-290.224c6.974-4.327 9.317-13.216 5.224-19.815z' })
        );
      case 'facebook':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M331.893 198.265H280.2v-33.909c0-12.722 8.438-15.694 14.374-15.694h36.485V92.693l-50.237-.196c-55.771 0-68.459 41.743-68.459 68.453v37.314h-32.256v57.67h32.256V419.13H280.2V255.935h45.765l5.928-57.67z' })
        );
      case 'google_plus':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M266.192 280.238c-9.13-6.461-26.581-22.175-26.581-31.427 0-10.837 3.089-16.154 19.385-28.893 16.704-13.065 28.534-31.406 28.534-52.738 0-25.421-11.317-50.168-32.562-58.355h32.02l22.605-16.333h-101.02c-45.261 0-87.893 34.309-87.893 74.039 0 40.608 30.875 73.396 76.952 73.396 3.211 0 6.309-.071 9.355-.276-2.985 5.704-5.143 12.166-5.143 18.831 0 11.309 6.083 20.469 13.761 27.932-5.808 0-11.41.163-17.502.163-56.098 0-99.271 35.721-99.271 72.771 0 36.488 47.331 59.298 103.411 59.298 63.948 0 99.271-36.274 99.271-72.762.002-29.261-8.627-46.783-35.322-65.646m-53.96-50.607c-26.009-.787-50.754-29.116-55.243-63.29-4.492-34.172 12.97-60.323 38.979-59.556 26.018.788 50.76 28.191 55.258 62.375 4.477 34.177-12.964 61.248-38.994 60.471m-10.181 172.882c-38.779 0-66.785-24.527-66.785-54.022 0-28.891 34.738-52.947 73.512-52.528 9.048.102 17.481 1.555 25.14 4.029 21.029 14.639 36.13 22.899 40.383 39.596a44.45 44.45 0 0 1 1.248 10.407c-.001 29.494-18.986 52.518-73.498 52.518' }),
          _react2.default.createElement('path', { d: 'M373.826 232.597v-39.31h-31.64v39.31h-39.321v31.651h39.321v39.331h31.64v-39.331h39.341v-31.651z' })
        );
      case 'handler':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 18.027 8.001' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M4.667.336a1.15 1.15 0 0 0-1.624 0L.336 3.043a1.128 1.128 0 0 0-.308.958c-.044.341.046.696.308.958l2.707 2.707a1.15 1.15 0 0 0 1.624-1.624l-2.04-2.04 2.04-2.04a1.152 1.152 0 0 0 0-1.626zM17.691 3.043L14.984.336A1.15 1.15 0 0 0 13.36 1.96L15.4 4l-2.04 2.04a1.15 1.15 0 0 0 1.624 1.624l2.707-2.707c.262-.262.352-.616.308-.958a1.126 1.126 0 0 0-.308-.956z' })
        );
      case 'info':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M256 51.5C143.058 51.5 51.5 143.061 51.5 256S143.058 460.5 256 460.5c112.944 0 204.5-91.55 204.5-204.5 0-112.945-91.556-204.5-204.5-204.5zm-1.02 318.859s-9.49 6.311-15.977 6.282l-.918.419.014-.419a20.915 20.915 0 0 1-4.114-.601l-2.048-.508c-11.327-2.81-17.324-14.041-14.504-25.361l15.77-63.567 7.116-28.711c6.622-26.66-20.995 5.668-26.657-6.613-3.741-8.118 21.479-25.152 39.904-37.994 0 0 9.477-6.3 15.967-6.273.582-.27.926-.421.926-.421l-.023.421c1.372.061 2.744.253 4.125.595l2.049.509c11.325 2.81 18.224 14.269 15.413 25.591l-15.761 63.573-7.133 28.711c-6.607 26.657 20.549-5.795 26.206 6.503 3.741 8.106-21.935 25.026-40.355 37.864zm39.964-198.694c-3.937 15.854-19.979 25.523-35.825 21.584-15.86-3.935-25.529-19.972-21.59-35.831 3.935-15.862 19.974-25.522 35.829-21.587 15.854 3.932 25.521 19.975 21.586 35.834z' })
        );
      case 'instantor':
        return _react2.default.createElement(
          'svg',
          (_React$createElement = { xmlns: 'http://www.w3.org/2000/svg', height: '256.587', fill: color }, _React$createElement['height'] = height || size, _React$createElement.width = width || size, _React$createElement.onClick = onClick, _React$createElement.style = style, _React$createElement.viewBox = '0 163.913 1002 256.587', _React$createElement),
          _react2.default.createElement('path', { d: 'M830.82 262.281c-18.057-6.532-36.061-5.586-53.625 1.555-7.286 2.961-13.997 7.334-21.729 11.473.652-2.639 1.102-4.961 1.81-7.202 1.246-3.946.449-5.933-4.228-5.715-5.93.274-11.882.065-18.443.065 2.622-10.272 4.954-19.583 7.387-28.868 1.403-5.361.557-6.867-5.062-6.526-10.131.615-20.266 1.455-30.319 2.792-1.932.256-4.28 2.93-5.078 5.009-1.841 4.792-2.926 9.885-4.168 14.893-1.548 6.229-4.919 10.962-11.011 13.272-5.026 1.908-6.789 5.959-7.925 10.652-.637 2.635.35 3.744 2.976 3.801 2.688.059 5.375.264 8.251.414l-21.624 84.315c-1.553-4.666-3.603-2.708-6.706-.395-2.516 1.873-6.188 2.193-9.346 3.201-.225-2.99-.487-5.979-.642-8.974-.032-.628.361-1.271.529-1.916 5.627-21.567 11.425-43.094 16.803-64.725 2.872-11.554-1.587-21.171-12.106-26.869-12.509-6.778-25.453-5.271-38.221-.854-5.702 1.974-11.08 4.881-17.46 7.748.446-2.183.846-3.558.983-4.957.169-1.728.806-4.439.015-5.002-1.357-.967-3.862-1.218-5.545-.688-13.983 4.4-28.396 5.565-42.895 5.665-4.508.03-5.641 2.271-6.525 5.75-.936 3.676.572 5.87 3.954 6.832 4.946 1.407 5.97 4.416 4.7 9.156-6.062 22.652-11.933 45.355-17.93 68.024-1.01 3.812-2.312 7.547-3.48 11.316-3.155-5.622-6.444-5.7-10.611-2.479-1.154.893-2.62 1.485-4.033 1.92-6.473 1.99-9.557-.799-7.836-7.287 4.35-16.396 8.903-32.738 13.286-49.127 3.825-14.3 7.568-28.624 11.224-42.968.375-1.469-.104-3.152-.187-4.737-1.731.121-3.599-.134-5.17.429a423.844 423.844 0 0 0-19.085 7.342c-3.543 1.465-6.346 1.228-9.629-1.158-12.77-9.276-26.984-11.336-42.247-7.747-17.029 4.006-30.854 13.313-42.188 26.176-13.933 15.811-22.74 34.012-22.352 55.657.095 5.224 1.121 10.429 1.735 15.789-4.661 2.138-9.172 4.688-13.997 6.291-5.27 1.751-8.172-.778-7.632-6.252.307-3.11 1.261-6.17 2.066-9.215 5.839-22.041 11.746-44.063 17.542-66.119.852-3.235 2.413-4.69 5.943-4.522 5.32.254 10.686.278 15.982-.172 1.613-.138 3.431-1.899 4.488-3.392 1.001-1.41 1.155-3.434 1.633-5.199 1.59-5.875 1.304-6.266-4.771-6.295-5.725-.029-11.449-.006-17.686-.006 2.564-10.158 4.716-19.185 7.147-28.136 1.683-6.191.947-7.62-5.62-7.261-9.135.5-18.229 1.723-27.364 2.221-4.678.255-6.824 2.442-7.796 6.748-1.06 4.698-2.649 9.276-3.716 13.973-1.45 6.385-5.212 10.732-11.15 13.141-4.53 1.836-6.427 5.396-7.56 9.805-.766 2.982-.075 4.479 3.18 4.535 2.55.043 5.097.293 8 .475-1.667 6.513-3.124 12.297-4.628 18.071-4.988 19.152-10.17 38.257-14.926 57.466-2.865 11.571.817 21.296 9.656 26.091 8.166 4.432 16.889 5.729 26.114 3.538 11.496-2.728 21.473-7.854 29.288-17.833 8.13 12.914 19.566 18.825 33.885 18.787 13.994-.037 26.125-5.615 37.137-14.467 6.484 11.25 16.452 15.238 28.415 14.352 11.3-.839 21.522-5.122 30.799-12.093.268 1.024.523 1.499.488 1.948-.496 6.091-.508 6.109 5.795 6.125 9.5.021 19-.055 28.499.05 3.227.036 5.109-.769 6.042-4.337 6.002-22.999 12.219-45.942 18.438-68.885 1.604-5.916 2.14-12.728 5.533-17.415 5.306-7.328 13.454-11.938 22.673-13.453 6.806-1.119 11.007 3.45 9.668 10.209-1.098 5.541-2.584 11.011-4 16.487-4.791 18.519-9.678 37.012-14.417 55.543-1.652 6.461-.229 12.271 4.787 16.871 8.277 7.59 18.17 10.324 29.092 8.541 10.232-1.672 19.262-6.031 25.063-13.387 4.852 3.891 8.803 8.473 13.804 10.795 13.181 6.125 26.128 3.168 38.218-3.668 4.26-2.408 7.959-5.957 11.54-9.377 3.21-3.066 1.111-6.469-1.11-8.804-.807-.849-3.954.149-5.854.813-2.644.926-5.022 2.645-7.685 3.473-6.659 2.072-9.757-.553-8.499-7.5 1.031-5.707 2.779-11.287 4.28-16.906 5.111-19.127 10.22-38.256 15.451-57.351.395-1.436 1.707-3.682 2.679-3.727 6.864-.326 13.75-.174 19.971-.174-5.113 7.784-10.88 14.976-14.905 23.036-7.713 15.441-9.962 31.943-3.752 48.41 7.425 19.688 22.752 29.929 43.101 33.604 39.072 7.06 83.683-18.25 88.577-63.688 2.998-27.827-12.251-48.893-34.153-56.817zm-341.155 22.467c-5.318 20.75-10.793 41.466-16.675 62.062-2.351 8.231-8.527 13.869-16.098 17.549-8.604 4.183-16.405-.244-18.521-10.246-.615-2.908-.68-5.934-1.099-9.863 2.643-23.208 8.935-45.875 26.251-63.878 3.49-3.627 8.663-6.307 13.555-7.768 8.556-2.559 14.774 3.603 12.587 12.144zm332.332 23.442c-3.042 16.941-7.61 33.365-16.561 48.244-2.034 3.385-4.608 6.52-7.321 9.404-4.458 4.744-10.015 7.65-16.565 5.535-6.377-2.059-7.95-8.139-9.109-13.869-.78-3.863-.64-7.916-.866-11.24 2.799-22.67 8.002-43.881 20.028-62.75 3.016-4.729 7.462-9.108 12.243-12.021 7.863-4.785 15.33-.771 18.028 8.088 2.922 9.596 1.839 19.053.123 28.609zM303.669 304.205c-7.58-4.399-15.297-8.786-22.085-14.258-5.325-4.293-4.17-11.43 1.406-15.402 6.059-4.318 12.825-4.508 19.575-2.293 4.662 1.531 5.275 4.576 4.604 9.438-.46 3.328-.192 7.627 1.594 10.224 4.189 6.092 10.768 8.015 18.092 6.926 6.872-1.021 11.592-4.846 13.926-11.352 3.05-8.498-1.573-17.919-11.531-22.72-15.931-7.68-32.869-7.849-49.869-5.333-11.004 1.628-21.15 5.811-29.747 13.221-12.869 11.094-19.679 35.012-.05 49.799 4.51 3.397 9.368 6.337 14.09 9.448 6.521 4.301 13.492 8.045 19.495 12.973 7.879 6.469 7.467 16.713-.417 21.57-7.052 4.345-14.662 6.105-22.932 3.35-7.093-2.363-7.406-2.8-4.506-9.805 3.222-7.781 2.04-14.855-3.301-19.76-5.867-5.387-15.054-6.799-21.871-3.34-9.004 4.568-11.412 12.348-10.415 21.039-3.295 2.368-6.008 4.762-9.124 6.381-1.689.877-4.642 1.264-5.958.344-1.176-.821-1.592-3.92-1.136-5.705 4.819-18.85 10.008-37.605 14.807-56.461 1.715-6.742 3.876-13.721 3.68-20.528-.416-14.449-12.571-21.969-24.982-23.498-12.725-1.567-24.818 1.368-36.091 7.531-1.981 1.082-4 2.096-7.076 3.703.395-2.709.546-4.277.862-5.812 1.008-4.905-.721-6.716-5.476-5.192-13.796 4.423-28.045 5.482-42.371 5.804-3.855.086-6.279.86-7.13 5.076-.869 4.303.588 6.674 4.686 7.834 3.992 1.129 5.049 3.899 4.057 7.737-.542 2.093-.883 4.237-1.437 6.326a26229.546 26229.546 0 0 1-16.05 60.293c-1.139 4.252-2.443 8.461-3.907 13.502-1.976-2.459-3.284-4.088-4.684-5.828-2.724 1.321-5.131 2.959-7.785 3.647-2.676.694-7.076 1.608-8.069.345-1.549-1.973-1.723-5.937-.987-8.65 8.224-30.338 16.743-60.594 25.16-90.878 1.304-4.691-.728-6.854-5.483-5.354-14.619 4.61-29.657 5.874-44.844 5.989-3.502.025-5.021 1.369-5.609 4.818-.596 3.492-.712 6.541 3.281 7.664 5.447 1.533 5.875 5.398 4.789 9.809-2.185 8.876-4.654 17.681-6.941 26.53-3.62 14.011-7.463 27.97-10.687 42.068-2.513 10.994 1.921 20.057 11.744 25.043 10.317 5.238 20.994 4.731 31.437.516 5.595-2.258 10.809-5.459 16.383-8.332 0 .58.187 1.291-.029 1.845-1.709 4.377.105 5.578 4.35 5.506 9.996-.172 19.997-.094 29.995-.017 3.237.025 5.178-.945 6.099-4.432 6.759-25.586 13.75-51.108 20.551-76.683 3.037-11.42 14.23-21.547 25.852-23.035 6.265-.801 10.423 2.918 9.617 9.285-.665 5.256-2.024 10.448-3.359 15.594-4.971 19.16-10.132 38.273-15.06 57.445-1.603 6.233-.248 11.993 4.549 16.506 8.61 8.103 18.971 10.92 30.422 8.683 10.294-2.012 19.555-6.256 25.372-15.133 3.903 2.776 7.192 6.266 11.219 7.739 8.203 3 16.668 5.896 25.268 7.078 19.598 2.694 38.654.685 55.312-11.356 16.736-12.097 21.143-34.689 9.959-50.392-5.438-7.634-13.247-12.444-21.234-17.08z' }),
          _react2.default.createElement('path', { d: 'M974.251 266.063c-5.627-7.378-15.625-9.934-24.765-6.562-10.423 3.845-17.182 11.773-23.059 20.584-3.922 5.882-7.358 12.084-11.014 18.144-.299-.146-.599-.291-.897-.438.34-1.938.935-3.871.973-5.815.175-9.128.649-18.285.109-27.379-.345-5.801-3.306-7.653-7.354-5.6-12.475 6.33-25.734 9.817-39.482 11.818-1.124.164-2.759.912-3.085 1.788-1.698 4.562 2.169 10.453 7.06 11.138 5.03.702 7.103 3.092 6.684 8.381-.394 4.972-.696 10.03-1.884 14.84-5.57 22.58-11.38 45.103-17.243 67.608-.941 3.617-.422 5.367 3.711 5.333 9.99-.082 19.983-.037 29.975.088 3.326.043 4.934-1.25 6.06-4.519 6.706-19.463 13.26-39 20.758-58.164 3.479-8.891 8.883-17.043 13.593-25.431 1.943-3.459 4.451-3.807 7.634-.938 2.427 2.19 5.215 4.351 8.232 5.441 8.574 3.098 18.036-.337 23.35-7.899 4.893-6.966 5.168-16.487.644-22.418zM77.297 246.996c12.932-.044 23.505-10.755 23.322-23.625-.181-12.738-10.794-23.318-23.324-23.251-12.565.066-23.597 11.257-23.444 23.782.153 12.585 10.866 23.136 23.446 23.094z' })
        );
      case 'linkedin':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M156.367 419.42H86.956V197.334h69.411V419.42zm-36.479-249.876h-.505c-25.118 0-41.392-16.969-41.392-38.484 0-21.938 16.768-38.563 42.379-38.563 25.595 0 41.352 16.59 41.846 38.506 0 21.51-16.251 38.541-42.328 38.541m314.12 249.876h-78.689V304.492c0-30.087-12.287-50.614-39.363-50.614-20.723 0-32.215 13.86-37.582 27.215-2 4.781-1.689 11.446-1.689 18.159V419.42H198.73s1.01-203.583 0-222.086h77.955v34.845c4.607-15.237 29.502-36.995 69.277-36.995 49.305 0 88.047 31.962 88.047 100.734V419.42z' })
        );
      case 'lock':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M397.159 225.595v-78.67c0-72.116-62.34-130.58-139.249-130.58-.955 0-1.648-.056-2.584-.037-.787 0-1.76.056-2.547.056-76.928 0-139.25 58.464-139.25 130.579v78.651H64.241v270.1h383.518v-270.1h-50.6zm-97.62 220.588h-86.984l21.311-87.34c-12.734-7.117-21.311-20.113-21.311-35.02 0-22.546 19.476-40.785 43.482-40.785 24.026 0 43.502 18.239 43.502 40.785 0 14.982-8.633 28.016-21.461 35.131l21.461 87.229zm27.959-220.588H183.192v-78.651c0-35.973 31.217-65.243 69.587-65.243 1.086 0 3.39-.056 3.39-.056s1.162.056 1.742.056c38.352 0 69.588 29.25 69.588 65.224v78.67z' })
        );
      case 'menu':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 48 48' },
          _react2.default.createElement('path', { d: 'M6 36h36v-4H6v4zm0-10h36v-4H6v4zm0-14v4h36v-4H6z' })
        );
      case 'money-kr':
        return _react2.default.createElement(
          'svg',
          { fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 502 326', xmlns: 'http://www.w3.org/2000/svg' },
          _react2.default.createElement(
            'title',
            null,
            'money-kr'
          ),
          _react2.default.createElement(
            'g',
            { 'fill-rule': 'evenodd' },
            _react2.default.createElement('path', { d: 'M494.9 69.5h-67.3V.5H.2V256h73.3v69.5h428.3v-256h-6.9zm-420.4 0h-1V246H10.2V11.5h407.3v58h-343zm417.3 245H84.5v-234h407.3v234z' }),
            _react2.default.createElement('path', { d: 'M216 85h8v239h-8z' }),
            _react2.default.createElement('path', { d: 'M403.862 274.66c.537.544.67 1.307.403 1.96-.403.653-1.207.98-2.012.98h-12.336c-.67 0-1.207-.218-1.609-.544l-27.086-22.977h-.938v21.779c0 .98-.939 1.742-2.28 1.742H347.68c-1.206 0-2.279-.762-2.279-1.742v-87.116c0-.98.939-1.742 2.28-1.742h10.324c1.207 0 2.28.762 2.28 1.742v49.983l24.672-25.481c.402-.436 1.073-.654 1.743-.654h12.873c.804 0 1.609.327 2.01.98.403.654.27 1.416-.267 1.96l-29.902 30.382 32.45 28.748zm47.065-62.179c-14.883 0-22.124 5.445-25.074 8.494v-7.405c0-.544-.537-.871-1.073-.871h-12.202c-.67 0-1.073.436-1.073.871v63.159c0 .218.134.435.269.653.268.218.536.218.804.218h13.945c.67 0 1.073-.436 1.073-.871V243.08c0-1.852.268-3.703.67-5.227 1.878-8.385 8.582-13.503 17.834-13.721h4.827c.268 0 .537-.109.805-.218.268-.218.268-.435.268-.653v-9.91c0-.435-.402-.87-1.073-.87z' })
          )
        );
      case 'pdf-file':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M483.74 414.332H161.893c-12.107 0-21.935-9.618-21.935-21.54V250.401c0-11.909 9.828-21.564 21.935-21.564H483.74c12.13 0 21.958 9.655 21.958 21.564v142.391c0 11.922-9.828 21.54-21.958 21.54zM267.317 293.921a26.726 26.726 0 0 0-5.949-9.945c-2.719-2.904-6.229-5.228-10.55-6.971-4.322-1.766-9.573-2.647-15.731-2.647h-44.428v96.734h21.657v-34.695h22.771c6.158 0 11.409-.881 15.731-2.646 4.322-1.744 7.832-4.091 10.55-6.972a26.808 26.808 0 0 0 5.949-9.876c1.229-3.717 1.834-7.553 1.834-11.524a36.63 36.63 0 0 0-1.834-11.458zm99.195 7.252c-2.254-5.949-5.389-10.921-9.387-14.896-3.998-3.974-8.737-6.947-14.219-8.946-5.461-1.999-11.389-2.974-17.707-2.974h-42.524v96.734h42.524c7.528 0 14.08-1.256 19.634-3.743 5.578-2.461 10.224-5.878 13.94-10.224 3.743-4.322 6.507-9.48 8.367-15.43 1.835-5.971 2.74-12.478 2.74-19.518.001-8.037-1.114-15.032-3.368-21.003zm87.695-26.816h-69.269v96.734h21.634v-39.968h41.269v-16.522h-41.269v-22.354h47.635v-17.89zm-113.579 72.404c-2.277 2.302-4.903 3.95-7.855 4.951a28.262 28.262 0 0 1-9.108 1.486h-19.332v-60.95h15.475c5.32 0 9.807.722 13.455 2.232 3.626 1.486 6.552 3.624 8.76 6.411 2.186 2.812 3.786 6.183 4.763 10.109.953 3.927 1.442 8.342 1.442 13.221 0 5.323-.698 9.831-2.068 13.523-1.375 3.721-3.232 6.718-5.532 9.017zm-98.22-29.534c-1.767 1.049-3.789 1.744-6.066 2.116a48.17 48.17 0 0 1-7.179.533h-16.847v-28.998h16.847c2.485 0 4.855.187 7.179.534 2.277.371 4.299 1.069 6.066 2.115 1.742 1.022 3.135 2.509 4.205 4.392 1.046 1.905 1.58 4.391 1.58 7.459 0 3.066-.534 5.554-1.58 7.458-1.07 1.882-2.464 3.348-4.205 4.391zm104.796-153.498l-.815-.836H248.24c-4.091 0-7.414-3.253-7.414-7.274V50.672l-1.859-1.975H54.471c-9.271 0-16.823 7.4-16.823 16.509v381.565c0 9.108 7.552 16.521 16.823 16.521h275.91c9.271 0 16.823-7.412 16.823-16.521v-22.167h31.345v22.167c0 26.094-21.609 47.311-48.168 47.311H54.471c-26.559 0-48.169-21.217-48.169-47.311V65.206c0-26.07 21.61-47.287 48.169-47.287h191.352c4.369 0 8.551 1.79 11.526 4.951l117.04 124.395c2.674 2.847 4.16 6.564 4.16 10.445v60.867h-31.345v-54.848zm-91.552-97.291v81.908h77.075l-77.075-81.908z' })
        );
      case 'phone':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 178.501 178.501' },
          _react2.default.createElement('path', { d: 'M168.013 124.735a111.44 111.44 0 0 1-34.992-6.221c-3.46-1.121-7.24-.42-9.93 2.132l-21.153 21.193c-27.91-14.501-50.963-37.473-65.48-65.355l21.167-21.345c2.691-2.397 3.406-6.356 2.285-9.733a112.403 112.403 0 0 1-6.138-34.92C53.686 4.989 49.204.64 43.838.554L9.619.001C4.237-.086-.083 4.12.001 9.619 1.485 101.276 77.08 177.021 168.883 178.5a9.442 9.442 0 0 0 9.617-9.618l-.554-34.213c-.085-5.498-4.548-9.849-9.933-9.934z' })
        );
      case 'plus-circle':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 23.006 23.007' },
          _react2.default.createElement('path', { 'fill-rule': 'evenodd', 'clip-rule': 'evenodd', d: 'M11.503 23.006C4.975 23.006 0 17.91 0 11.503S5.16 0 11.503 0s11.503 5.161 11.503 11.503c0 6.343-4.975 11.503-11.503 11.503zm0-22.013C5.707.993.992 5.538.992 11.503s4.581 10.512 10.511 10.512 10.511-4.716 10.511-10.512S17.299.993 11.503.993zm.498 14.507h-.992v-3.503H7.506v-.991h3.503V7.502h.992v3.503h3.503v.991h-3.503V15.5z' })
        );
      case 'security':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 41.006 46.998' },
          _react2.default.createElement('path', { d: 'M29.879 6.105C25.216 5.26 20.784.005 20.552 0l-.143.001c-.188.005-4.618 5.259-9.282 6.103C6.386 6.962.218 4.808 0 4.908V15.89l.004.12c.02.285.508 7.03 2.184 11.825 1.653 4.725 4.874 8.735 5.787 9.622.564.624 5.122 5.552 11.683 9.097l.845.445.845-.445c6.561-3.545 11.118-8.472 11.683-9.097.914-.887 4.135-4.897 5.787-9.622 1.677-4.795 2.164-11.541 2.185-11.825l.004-11.053v-.049c-.219-.1-6.387 2.055-11.128 1.197zM16.811 35L6.998 24.893l4.178-4.303 5.634 5.803L29.818 13l4.18 4.301L16.811 35z' })
        );
      case 'select':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M108.378 311.074l1.69 1.973 127.797 147.061c4.321 4.979 10.806 8.08 18.042 8.08 7.235 0 13.719-3.195 18.041-8.08l127.7-146.778 2.162-2.441c1.598-2.352 2.537-5.17 2.537-8.178 0-8.176-6.953-14.846-15.6-14.846H121.251c-8.645 0-15.599 6.672-15.599 14.846 0 3.1 1.035 6.014 2.726 8.363zM105.652 209.288c0 8.176 6.954 14.847 15.598 14.847h269.499c8.646 0 15.6-6.671 15.6-14.847 0-3.006-.939-5.827-2.535-8.176l-2.162-2.442L273.947 51.893c-4.32-4.884-10.806-8.081-18.042-8.081-7.234 0-13.72 3.102-18.042 8.081l-127.794 147.06-1.693 1.974c-1.689 2.347-2.724 5.261-2.724 8.361z' })
        );
      case 'star':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M503.747 201.027c0-8.946-9.542-12.524-16.698-13.717l-149.69-21.768-67.092-135.675c-2.684-5.666-7.753-12.226-14.611-12.226s-11.928 6.56-14.611 12.226l-67.092 135.675L24.262 187.31c-7.455 1.193-16.698 4.771-16.698 13.717 0 5.367 3.876 10.437 7.455 14.313l108.54 105.559-25.645 149.092c-.298 2.088-.596 3.877-.596 5.964 0 7.753 3.876 14.91 12.524 14.91 4.174 0 8.051-1.491 11.927-3.579l133.886-70.372 133.886 70.372c3.578 2.088 7.753 3.579 11.928 3.579 8.647 0 12.226-7.157 12.226-14.91 0-2.087 0-3.876-.298-5.964l-25.645-149.093L495.994 215.34c3.877-3.877 7.753-8.946 7.753-14.313z' })
        );
      case 'twitter':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 512 512' },
          _react2.default.createElement('path', { d: 'M442.896 130.755c-13.818 6.68-28.529 11.008-44.111 13 15.879-10.224 28.061-26.314 33.83-45.6-14.848 9.411-31.287 16.142-48.793 20.07-13.943-16.109-33.945-26.166-55.938-26.166-42.359 0-76.683 36.926-76.683 82.577 0 6.412.654 12.755 1.924 18.719-63.608-3.274-120.204-36.279-158.047-86.138-6.578 12.169-10.337 26.314-10.337 41.501 0 28.586 13.516 54.001 34.14 68.586-12.606-.502-24.432-4.019-34.747-10.257v1.122c0 39.932 26.424 73.247 61.495 80.963-6.423 1.866-13.212 2.726-20.258 2.726-4.923 0-9.599-.344-14.334-1.466 9.715 32.914 38.066 56.83 71.612 57.312-26.247 22.268-59.304 35.342-95.235 35.342-6.2 0-12.336-.366-18.312-1.156 33.929 23.525 74.163 37.241 117.553 37.241 141.045 0 218.221-125.841 218.221-234.936 0-3.479-.08-7.029-.254-10.555 14.978-11.808 27.993-26.365 38.274-42.885' })
        );
      case 'wallet':
        return _react2.default.createElement(
          'svg',
          { xmlns: 'http://www.w3.org/2000/svg', fill: color, height: height || size, width: width || size, onClick: onClick, style: style, viewBox: '0 0 612 612' },
          _react2.default.createElement(
            'g',
            null,
            _react2.default.createElement('path', { d: 'M500.484 158.845v-.061l-16.028-63.27c-2.45-9.729-11.198-16.151-20.743-16.151-1.715 0-3.49.182-5.262.672l-98.209 24.902-212.565 53.908h352.807zM357.184 429.967V322.275c0-22.455 18.233-40.688 40.689-40.688h162.023v-83.03c0-11.811-9.604-21.415-21.414-21.415H44.085c-7.893 0-14.747 4.282-18.479 10.585-1.835 3.182-2.937 6.851-2.937 10.83v355.194c0 11.812 9.605 21.415 21.416 21.415h494.337c11.812 0 21.415-9.604 21.415-21.415V470.72H397.873c-22.456 0-40.689-18.296-40.689-40.753z' }),
            _react2.default.createElement('path', { d: 'M578.254 303.92c-2.751-1.651-5.873-2.628-9.178-2.938-.609-.06-1.162-.06-1.775-.06H397.873c-11.808 0-21.417 9.604-21.417 21.415v107.688c0 11.81 9.609 21.417 21.417 21.417h169.428c.613 0 1.166-.062 1.775-.062a20.772 20.772 0 0 0 9.178-2.938c6.242-3.73 10.464-10.586 10.464-18.419V322.339c0-7.833-4.222-14.687-10.464-18.419zM451.289 410.877c-19.15 0-34.752-15.543-34.752-34.754 0-19.152 15.542-34.755 34.752-34.755 19.154 0 34.757 15.543 34.757 34.755 0 19.211-15.542 34.754-34.757 34.754zM350.638 87.193l-21.416-39.527c-5.629-10.462-18.664-14.316-29.062-8.688L88.692 153.583l9.3-2.323 252.646-64.067z' })
          )
        );
    }
  };

  return Icon;
}(_StyledComponent3.default)) || _class;

Icon.styleRoot = 'Icon';
Icon.propTypes = {
  color: _react2.default.PropTypes.string,
  height: _react2.default.PropTypes.number,
  kind: _react2.default.PropTypes.oneOf(['alarm-clock', 'arrow-right', 'calendar', 'chat-info', 'check', 'chevron', 'chevron-right', 'close-thin', 'conversation', 'dashboard', 'edit', 'envelope', 'eye', 'eye-hidden', 'facebook', 'google_plus', 'handler', 'info', 'instantor', 'linkedin', 'lock', 'menu', 'money-kr', 'pdf-file', 'phone', 'plus-circle', 'security', 'select', 'star', 'twitter', 'wallet']).isRequired,
  onClick: _react2.default.PropTypes.func,
  preview: _react2.default.PropTypes.bool,
  size: _react2.default.PropTypes.number,
  style: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.object]),
  width: _react2.default.PropTypes.number,
  wrapperStyle: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.object])
};
Icon.defaultProps = {
  color: '#000',
  size: 32
};
exports.default = Icon;