'use strict';

exports.__esModule = true;

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getActiveSortedBlogPosts = function getActiveSortedBlogPosts(posts) {
  if (!_immutable.Map.isMap(posts)) return [];

  return posts.valueSeq().toJS().filter(function (post) {
    return (0, _moment2.default)(post.fields.publishTime) < (0, _moment2.default)();
  }).sort(function (a, b) {
    return (0, _moment2.default)(b.fields.publishTime) - (0, _moment2.default)(a.fields.publishTime);
  });
};

exports.default = getActiveSortedBlogPosts;
module.exports = exports['default'];