'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FaqItem = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(FaqItem, _StyledComponent);

  function FaqItem() {
    (0, _classCallCheck3.default)(this, FaqItem);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  FaqItem.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        last = _props.last,
        number = _props.number;

    var style = this.getStyle();

    return _react2.default.createElement(
      'li',
      { style: style.base },
      _react2.default.createElement(
        'div',
        { style: style.number.wrapper },
        _react2.default.createElement(
          'span',
          { style: style.number.text },
          number
        )
      ),
      last || _react2.default.createElement('div', { style: style.line }),
      _react2.default.createElement(
        'div',
        null,
        children
      )
    );
  };

  return FaqItem;
}(_StyledComponent3.default)) || _class;

FaqItem.styleRoot = 'FaqItem';
FaqItem.propTypes = {
  children: _react.PropTypes.string.isRequired,
  last: _react.PropTypes.bool,
  number: _react.PropTypes.number.isRequired
};

FaqItem.style = function (_ref) {
  var _base;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;

  var CIRCLE_SIZE = 42;
  var CIRCLE_OFFSET = 22;
  var LINE_WIDTH = 2;

  return {
    base: (_base = {
      padding: '20px 0 20px 86px',
      display: 'block',
      position: 'relative'
    }, _base[mediaQueries.breakpointTablet] = {
      padding: '20px 0 20px 55px'
    }, _base),
    number: {
      wrapper: {
        width: CIRCLE_SIZE + 'px',
        height: CIRCLE_SIZE + 'px',
        borderRadius: '50%',
        border: LINE_WIDTH + 'px solid ' + colors.primary,
        textAlign: 'center',
        position: 'absolute',
        left: 0,
        top: CIRCLE_OFFSET + 'px'
      },
      text: {
        fontSize: '21px',
        color: colors.primary,
        fontWeight: 700,
        lineHeight: CIRCLE_SIZE - 2 * LINE_WIDTH + 'px'
      }
    },
    line: {
      width: LINE_WIDTH + 'px',
      top: CIRCLE_SIZE + CIRCLE_OFFSET + 'px',
      left: CIRCLE_SIZE / 2 - LINE_WIDTH + 'px',
      bottom: '-' + CIRCLE_OFFSET + 'px',
      position: 'absolute',
      backgroundColor: colors.primary
    }
  };
};

exports.default = FaqItem;
module.exports = exports['default'];