'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var MenuButton = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(MenuButton, _StyledComponent);

  function MenuButton() {
    (0, _classCallCheck3.default)(this, MenuButton);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  MenuButton.prototype.render = function render() {
    var _props = this.props,
        inverseColors = _props.inverseColors,
        label = _props.label,
        onClick = _props.onClick,
        pathname = _props.pathname,
        to = _props.to;

    var activeLink = pathname === to;
    var style = this.getStyle();

    return _react2.default.createElement(
      'li',
      { style: style.item },
      _react2.default.createElement(
        'span',
        { style: [style.linkWrapper.base, inverseColors && style.linkWrapper.inverse, activeLink && style.linkWrapper.active]
        },
        _react2.default.createElement(
          RadiumLink,
          {
            onClick: onClick,
            style: [style.link.base, inverseColors && style.link.inverse, activeLink && style.link.active],
            to: to
          },
          label
        )
      )
    );
  };

  return MenuButton;
}(_StyledComponent3.default)) || _class;

MenuButton.styleRoot = 'MenuButton';
MenuButton.propTypes = {
  inverseColors: _react.PropTypes.bool,
  label: _react.PropTypes.string.isRequired,
  onClick: _react.PropTypes.func,
  pathname: _react.PropTypes.string,
  to: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object])
};

MenuButton.style = function (_ref) {
  var _base;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    item: {
      display: 'inline-block'
    },
    linkWrapper: {
      base: {
        marginLeft: '30px',
        height: '80px',
        lineHeight: '80px',
        display: 'block',
        textDecoration: 'none',
        borderBottomWidth: '5px',
        borderBottomColor: 'transparent',
        borderBottomStyle: 'solid',
        transition: 'border-bottom-color .2s, color .2s'
      },
      inverse: {
        borderBottomColor: 'transparent'
      },
      active: {
        borderBottomColor: colors.primary,
        fontWeight: '700'
      }
    },
    link: {
      base: (_base = {
        cursor: 'pointer',
        color: colors.grayDarker,
        textDecoration: 'none',
        padding: '5px 20px',
        backgroundColor: 'transparent',
        borderColor: colors.inputBorder,
        borderRadius: '3px',
        borderStyle: 'solid',
        borderWidth: '1px',
        transition: 'border-color .2s',
        ':hover': {
          borderColor: colors.grayDarker
        }
      }, _base[mediaQueries.breakpointLaptop] = {
        fontSize: '14px',
        marginLeft: '15px'
      }, _base),
      inverse: {
        borderColor: colors.grayDarker,
        color: colors.white,
        backgroundColor: colors.grayDarker
      },
      active: {
        borderColor: colors.grayDarker
      }
    }
  };
};

exports.default = MenuButton;
module.exports = exports['default'];