'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var MenuItem = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(MenuItem, _StyledComponent);

  function MenuItem() {
    (0, _classCallCheck3.default)(this, MenuItem);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  MenuItem.prototype.render = function render() {
    var _props = this.props,
        inverseColors = _props.inverseColors,
        label = _props.label,
        onClick = _props.onClick,
        to = _props.to,
        pathname = _props.pathname;

    var activeLink = pathname === to;
    var style = this.getStyle();

    return _react2.default.createElement(
      'li',
      { style: style.item },
      _react2.default.createElement(
        RadiumLink,
        {
          onClick: onClick,
          style: [style.link, inverseColors && style.linkInverse, activeLink && style.activeLink],
          to: to
        },
        label
      )
    );
  };

  return MenuItem;
}(_StyledComponent3.default)) || _class;

MenuItem.styleRoot = 'MenuItem';
MenuItem.propTypes = {
  inverseColors: _react.PropTypes.bool,
  label: _react.PropTypes.string.isRequired,
  onClick: _react.PropTypes.func,
  pathname: _react.PropTypes.string,
  to: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object]).isRequired
};

MenuItem.style = function (_ref) {
  var _link;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    item: {
      display: 'inline-block'
    },
    link: (_link = {
      color: colors.grayDarker,
      marginLeft: '35px',
      height: '80px',
      lineHeight: '80px',
      display: 'block',
      textDecoration: 'none',
      borderBottomWidth: '5px',
      borderBottomColor: 'transparent',
      borderBottomStyle: 'solid',
      transition: 'border-bottom-color .2s, color .2s'
    }, _link[mediaQueries.breakpointLaptop] = {
      fontSize: '14px',
      marginLeft: '15px'
    }, _link),
    linkInverse: {
      color: colors.grayDarker,
      borderBottomWidth: '3px',
      fontWeight: 'bold',
      height: '55px'
    },
    activeLink: {
      color: colors.grayDarker,
      position: 'relative',
      fontWeight: 'bold',
      ':hover': {
        color: colors.grayDarker
      }
    }
  };
};

exports.default = MenuItem;
module.exports = exports['default'];