'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumLink = (0, _radium2.default)(_reactRouter.Link);

var VerticalMenuItem = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(VerticalMenuItem, _StyledComponent);

  function VerticalMenuItem() {
    (0, _classCallCheck3.default)(this, VerticalMenuItem);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  VerticalMenuItem.prototype.handleClick = function handleClick() {
    var _props = this.props,
        toggleSideMenuAction = _props.toggleSideMenuAction,
        onClick = _props.onClick;


    if (!!onClick) onClick();

    toggleSideMenuAction();
  };

  VerticalMenuItem.prototype.render = function render() {
    var _this2 = this;

    var _props2 = this.props,
        label = _props2.label,
        to = _props2.to,
        pathname = _props2.pathname;

    var activeLink = pathname === to;
    var style = this.getStyle();

    return _react2.default.createElement(
      'li',
      { style: style.item },
      _react2.default.createElement(
        RadiumLink,
        {
          onClick: function onClick() {
            return _this2.handleClick();
          },
          style: [style.link, activeLink && style.activeLink],
          to: to
        },
        label
      )
    );
  };

  return VerticalMenuItem;
}(_StyledComponent3.default)) || _class;

VerticalMenuItem.styleRoot = 'VerticalMenuItem';
VerticalMenuItem.propTypes = {
  label: _react.PropTypes.string.isRequired,
  onClick: _react.PropTypes.func,
  pathname: _react.PropTypes.string,
  to: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object]).isRequired,
  toggleSideMenuAction: _react.PropTypes.func.isRequired
};

VerticalMenuItem.style = function (_ref) {
  var colors = _ref.colors;
  return {
    item: {
      borderTop: '1px solid ' + colors.secondary
    },

    link: {
      display: 'block',
      width: '100%',
      color: colors.white,
      fontSize: '20px',
      padding: '20px 10px 20px 20px',
      textDecoration: 'none'
    },

    activeLink: {
      backgroundColor: colors.secondary
    }
  };
};

exports.default = VerticalMenuItem;
module.exports = exports['default'];