'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Modal = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Modal, _StyledComponent);

  function Modal() {
    (0, _classCallCheck3.default)(this, Modal);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Modal.extendBluekitProps = function extendBluekitProps(props, setAtomProp) {
    return (0, _extends3.default)({}, props, {
      onClose: function onClose() {
        setAtomProp('isModalOpen', false);
      }
    });
  };

  Modal.prototype.handleClose = function handleClose() {
    var onClose = this.props.onClose;


    onClose();
  };

  Modal.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        isScreenWidthUnderTablet = _props.isScreenWidthUnderTablet,
        isModalOpen = _props.isModalOpen;

    var style = this.getStyle();

    return _react2.default.createElement(
      _reactModal2.default,
      {
        isOpen: isModalOpen,
        onRequestClose: this.handleClose.bind(this),
        style: isScreenWidthUnderTablet ? style.modalResponsiveStyles : style.modalStyles
      },
      isModalOpen && _react2.default.createElement(_radium.Style, { rules: { body: { overflow: 'hidden' } } }),
      _react2.default.createElement(
        'div',
        { style: style.innerWrapper },
        _react2.default.createElement(
          'span',
          { onClick: this.handleClose.bind(this), style: style.closeButton },
          _react2.default.createElement(_Icon2.default, { kind: 'close-thin', size: 15 })
        ),
        children
      )
    );
  };

  return Modal;
}(_StyledComponent3.default)) || _class;

Modal.styleRoot = 'Modal';
Modal.propTypes = {
  children: _react.PropTypes.any.isRequired,
  isModalOpen: _react.PropTypes.bool.isRequired,
  isScreenWidthUnderTablet: _react.PropTypes.bool.isRequired,
  onClose: _react.PropTypes.func.isRequired
};
Modal.defaultProps = {
  isModalOpen: false,
  isScreenWidthUnderTablet: false
};

Modal.style = function (_ref) {
  var _innerWrapper, _closeButton;

  var mediaQueries = _ref.mediaQueries;

  var modalStyles = {
    content: {
      top: '50%',
      left: '50%',
      right: 'auto',
      bottom: 'auto',
      padding: '0',
      transform: 'translate(-50%,-50%)',
      borderRadius: '7px',
      border: 'none'
    },

    overlay: {
      zIndex: '101',
      backgroundColor: 'rgba(100,100,100,.5)'
    }
  };

  var styles = {
    innerWrapper: (_innerWrapper = {
      position: 'relative',
      margin: '0px',
      padding: '30px 40px',
      maxHeight: '90vh',
      minWidth: '390px',
      overflow: 'auto'
    }, _innerWrapper[mediaQueries.breakpointTablet] = {
      maxHeight: '80vh',
      width: '75vw',
      minWidth: 0
    }, _innerWrapper[mediaQueries.breakpointSmall] = {
      padding: '15px 23px',
      maxHeight: '90vh',
      width: '85vw'
    }, _innerWrapper),

    closeButton: (_closeButton = {
      position: 'fixed',
      right: '20px',
      top: '20px',
      cursor: 'pointer'
    }, _closeButton[mediaQueries.breakpointSmall] = {
      right: '8px',
      top: '8px'
    }, _closeButton),

    modalStyles: modalStyles,

    modalResponsiveStyles: (0, _extends3.default)({}, modalStyles, { content: (0, _extends3.default)({}, modalStyles.content, { marginTop: '30px' }) })
  };

  return styles;
};

exports.default = Modal;
module.exports = exports['default'];