'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Clearfix = require('../layout/Clearfix.react');

var _Clearfix2 = _interopRequireDefault(_Clearfix);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Panel = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Panel, _StyledComponent);

  function Panel() {
    (0, _classCallCheck3.default)(this, Panel);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Panel.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        noBorder = _props.noBorder,
        inheritedStyle = _props.inheritedStyle;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      {
        style: [style.base, inheritedStyle && inheritedStyle, noBorder && style.noBorder]
      },
      children,
      _react2.default.createElement(_Clearfix2.default, null)
    );
  };

  return Panel;
}(_StyledComponent3.default)) || _class;

Panel.styleRoot = 'Panel';
Panel.propTypes = {
  children: _react.PropTypes.any.isRequired,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  noBorder: _react.PropTypes.bool
};

Panel.style = function (_ref) {
  var _base;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    base: (_base = {
      border: '1px solid ' + colors.grayLighter,
      display: 'flex',
      margin: '0 auto',
      flex: '1 0 auto'
    }, _base[mediaQueries.breakpointTablet] = {
      display: 'block'
    }, _base[mediaQueries.breakpointSmall] = {
      border: 0,
      width: 'auto',
      margin: '0 -15px'
    }, _base),

    noBorder: {
      border: 'none'
    }
  };
};

exports.default = Panel;
module.exports = exports['default'];