'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Spinner = require('../progress/Spinner.react');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PanelBlock = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(PanelBlock, _StyledComponent);

  function PanelBlock() {
    (0, _classCallCheck3.default)(this, PanelBlock);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  PanelBlock.prototype.render = function render() {
    var _props = this.props,
        background = _props.background,
        backgroundImage = _props.backgroundImage,
        children = _props.children,
        className = _props.className,
        invertColors = _props.invertColors,
        loading = _props.loading,
        loadingText = _props.loadingText,
        verticalAlign = _props.verticalAlign;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      {
        className: className,
        style: [style.block, verticalAlign && style.verticalAlign, { backgroundColor: background }, backgroundImage && { backgroundImage: 'url(' + backgroundImage + ')' }, invertColors && { color: 'white' }]
      },
      loading && _react2.default.createElement(_Spinner2.default, null),
      loading && loadingText || children
    );
  };

  return PanelBlock;
}(_StyledComponent3.default)) || _class;

PanelBlock.styleRoot = 'PanelBlock';
PanelBlock.propTypes = {
  background: _react.PropTypes.string,
  backgroundImage: _react.PropTypes.string,
  className: _react.PropTypes.string,
  children: _react.PropTypes.any.isRequired,
  invertColors: _react.PropTypes.bool,
  loading: _react.PropTypes.bool,
  loadingText: _react.PropTypes.string,
  verticalAlign: _react.PropTypes.bool
};
PanelBlock.defaultProps = {
  background: '#fff',
  invertColors: false,
  loading: false
};

PanelBlock.style = function (_ref) {
  var _block;

  var mediaQueries = _ref.mediaQueries;
  return {
    block: (_block = {
      backgroundPosition: 'center',
      backgroundSize: 'cover',
      flex: '1 1 auto',
      display: 'flex',
      width: '100%',
      flexDirection: 'column',
      padding: '30px',
      position: 'relative'
    }, _block[mediaQueries.breakpointSmall] = {
      padding: '15px'
    }, _block),

    verticalAlign: {
      justifyContent: 'center'
    }
  };
};

exports.default = PanelBlock;
module.exports = exports['default'];