'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Loader = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Loader, _StyledComponent);

  function Loader() {
    (0, _classCallCheck3.default)(this, Loader);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Loader.prototype.renderFluidSpinner = function renderFluidSpinner() {
    var spinnerSteps = 5;
    var spinner = [];
    var style = this.getStyle();

    for (var i = 0; i < spinnerSteps; i++) {
      spinner.push(_react2.default.createElement('span', { key: i, style: [style.fluid.bar.base, style.fluid.bar['bar' + (i + 1)]] }));
    }return _react2.default.createElement(
      'div',
      { style: style.fluid.base },
      _react2.default.createElement(
        'div',
        { style: style.fluid.wrapper },
        spinner
      )
    );
  };

  Loader.prototype.renderSectionsSpinner = function renderSectionsSpinner() {
    var style = this.getStyle();
    var bars = (0, _immutable.Range)(0, 9).map(function (i) {
      return _react2.default.createElement('div', {
        key: i,
        style: [style.section.bars.base, { transform: 'rotate(-' + 40 * i + 'deg)' }, style.section.bars['bar' + (i + 1)]]
      });
    });

    return _react2.default.createElement(
      'div',
      { style: style.section.base },
      bars,
      _react2.default.createElement('div', { style: style.section.static }),
      _react2.default.createElement('div', { style: [style.section.spinning, style.section.spinningA] }),
      _react2.default.createElement('div', { style: [style.section.spinning, style.section.spinningB] })
    );
  };

  Loader.prototype.render = function render() {
    var variant = this.props.variant;


    switch (variant) {
      case 'fluid':
        return this.renderFluidSpinner();

      case 'sections':
        return this.renderSectionsSpinner();
    }

    throw new Error('Unknown loading component variant: ' + variant);
  };

  return Loader;
}(_StyledComponent3.default)) || _class;

Loader.styleRoot = 'Loader';
Loader.propTypes = {
  variant: _react.PropTypes.oneOf(['fluid', 'sections'])
};
Loader.defaultProps = {
  variant: 'fluid'
};

Loader.style = function (_ref) {
  var colors = _ref.colors;
  return {
    fluid: {
      base: {
        clear: 'both',
        minHeight: '32px',
        padding: '32px 0',
        textAlign: 'center',
        width: '100%'
      },
      wrapper: {
        height: '32px',
        margin: '0 auto',
        position: 'relative',
        width: '53px'
      },
      bar: {
        base: {
          animation: 'fluidWaves 1.5s infinite ease-in-out',
          animationName: _radium2.default.keyframes({
            '0%': {
              backgroundColor: colors.secondary,
              height: '6px',
              top: '13px'
            },
            '25%': {
              backgroundColor: colors.primary,
              height: '32px',
              top: 0
            },
            '50%': {
              backgroundColor: colors.secondary,
              height: '6px',
              top: '13px'
            },
            '100%': {
              backgroundColor: colors.secondary,
              height: '6px',
              top: '13px'
            }
          }),
          backgroundColor: colors.secondary,
          display: 'block',
          height: '6px',
          position: 'absolute',
          top: '13px',
          width: '9px'
        },
        bar1: {
          animationDelay: 0,
          left: 0
        },
        bar2: {
          animationDelay: '.2s',
          left: '11px'
        },
        bar3: {
          animationDelay: '.4s',
          left: '22px'
        },
        bar4: {
          animationDelay: '.6s',
          left: '33px'
        },
        bar5: {
          animationDelay: '.8s',
          left: '44px'
        }
      }
    },

    section: {
      base: {
        position: 'relative',
        width: SPINNER_SIZE,
        height: SPINNER_SIZE,
        margin: '50px auto'
      },
      static: {
        width: '100%',
        height: '100%',
        position: 'absolute',
        borderRadius: '50%',
        border: SPINNER_THICKNESS + ' solid ' + colors.grayLighter
      },
      spinning: {
        borderRadius: '50%',
        width: '100%',
        height: '100%',
        position: 'absolute',
        borderTop: SPINNER_THICKNESS + ' solid ' + colors.primary,
        borderRight: SPINNER_THICKNESS + ' solid ' + colors.primary,
        borderBottom: SPINNER_THICKNESS + ' solid ' + colors.primary,
        borderLeft: SPINNER_THICKNESS + ' solid transparent',
        animation: 'x 5s ease infinite'
      },
      spinningA: {
        animationName: sectionSpinning
      },
      spinningB: {
        animationName: sectionSpinningB
      },
      bars: {
        base: {
          position: 'absolute',
          backgroundColor: colors.white,
          height: SPINNER_THICKNESS,
          transformOrigin: '0px 0px',
          width: '2px',
          zIndex: 5
        },
        bar1: {
          left: '90px',
          top: 0
        },
        bar2: {
          left: '32px',
          top: '21px'
        },
        bar3: {
          left: '1px',
          top: '75px'
        },
        bar4: {
          left: '12px',
          top: '135px'
        },
        bar5: {
          left: '60px',
          top: '175px'
        },
        bar6: {
          left: '120px',
          top: '175px'
        },
        bar7: {
          left: '168px',
          top: '135px'
        },
        bar8: {
          left: '179px',
          top: '75px'
        },
        bar9: {
          left: '148px',
          top: '21px'
        }
      }
    }
  };
};

exports.default = Loader;


var SPINNER_SIZE = '180px';
var SPINNER_THICKNESS = '25px';

var sectionSpinning = _radium2.default.keyframes({
  '0%': { transform: 'rotate(0deg)' },
  '35%': { transform: 'rotate(90deg)' },
  '50%': { transform: 'rotate(180deg)' },
  '65%': { transform: 'rotate(270deg)' },
  '100%': { transform: 'rotate(360deg)' }
});

var sectionSpinningB = _radium2.default.keyframes({
  '0%': { transform: 'rotate(0deg)' },
  '15%': { transform: 'rotate(90deg)' },
  '50%': { transform: 'rotate(180deg)' },
  '85%': { transform: 'rotate(270deg)' },
  '100%': { transform: 'rotate(360deg)' }
});
module.exports = exports['default'];