'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _ProgressBarStep = require('./ProgressBarStep.react');

var _ProgressBarStep2 = _interopRequireDefault(_ProgressBarStep);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _grid = require('../grid');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ProgressBar = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(ProgressBar, _StyledComponent);

  function ProgressBar() {
    (0, _classCallCheck3.default)(this, ProgressBar);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  ProgressBar.prototype.isDone = function isDone(stepName) {
    var _props = this.props,
        activeStep = _props.activeStep,
        steps = _props.steps;

    return steps.indexOf(stepName) < steps.indexOf(activeStep);
  };

  ProgressBar.prototype.renderStep = function renderStep(stepName, key, _ref) {
    var length = _ref.length;
    var _props2 = this.props,
        activeStep = _props2.activeStep,
        numbered = _props2.numbered,
        sharp = _props2.sharp;

    var isActive = stepName === activeStep;
    return _react2.default.createElement(_ProgressBarStep2.default, {
      index: key,
      isActive: isActive,
      isDone: this.isDone(stepName),
      key: key,
      name: stepName,
      numbered: numbered,
      sharp: sharp,
      stepsCount: length
    });
  };

  ProgressBar.prototype.render = function render() {
    var steps = this.props.steps;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.background.base },
      _react2.default.createElement('div', { style: style.background.right }),
      _react2.default.createElement(
        _grid.Container,
        { style: style.container },
        _react2.default.createElement(
          'ul',
          { style: style.list },
          steps.map(this.renderStep, this)
        )
      )
    );
  };

  return ProgressBar;
}(_StyledComponent3.default)) || _class;

ProgressBar.styleRoot = 'ProgressBar';
ProgressBar.propTypes = {
  activeStep: _react.PropTypes.string.isRequired,
  numbered: _react.PropTypes.bool,
  sharp: _react.PropTypes.bool,
  steps: _react.PropTypes.arrayOf(_react.PropTypes.string).isRequired
};
ProgressBar.defaultProps = {
  activeStep: 'First Step',
  items: ['First Step', 'Second Step', 'Last Step', 'Ultimate Step']
};

ProgressBar.style = function (_ref2) {
  var colors = _ref2.colors;
  return {
    list: {
      marginTop: 0,
      marginBottom: 0,
      paddingLeft: 0,
      width: '100%',
      display: 'flex',
      flexWrap: 'nowrap',
      listStyle: 'none',
      zIndex: '2'
    },
    background: {
      base: {
        position: 'relative',
        overflow: 'hidden',
        backgroundColor: colors.primary
      },
      right: {
        position: 'absolute',
        right: 0,
        left: '50%',
        top: 0,
        bottom: 0,
        backgroundColor: colors.backgroundDarker
      }
    },
    container: {
      display: 'flex'
    }
  };
};

exports.default = ProgressBar;
module.exports = exports['default'];