'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ProgressBarStep = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(ProgressBarStep, _StyledComponent);

  function ProgressBarStep() {
    (0, _classCallCheck3.default)(this, ProgressBarStep);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  ProgressBarStep.prototype.render = function render() {
    var _props = this.props,
        index = _props.index,
        isActive = _props.isActive,
        isDone = _props.isDone,
        name = _props.name,
        numbered = _props.numbered,
        sharp = _props.sharp,
        stepsCount = _props.stepsCount;

    var stepIndex = index + 1;
    var lastStep = stepIndex === stepsCount;
    var firstStep = stepIndex === 1;
    var doneOrActive = isDone || isActive;
    var style = this.getStyle();

    return _react2.default.createElement(
      'li',
      { style: [style.item.base, sharp && style.item.sharp, firstStep && style.item.first, lastStep && style.item.last, doneOrActive && style.item.active]
      },
      _react2.default.createElement(
        'span',
        { style: [style.text.base, doneOrActive && style.text.active] },
        _react2.default.createElement(
          'span',
          { style: [style.text.badge.base, numbered && style.text.badge.visible, doneOrActive && style.text.badge.doneOrActive, isActive && style.text.badge.active]
          },
          stepIndex
        ),
        _react2.default.createElement(
          'span',
          { style: style.text.dot },
          '.'
        ),
        _react2.default.createElement(
          'span',
          { style: [style.text.name, sharp && style.text.sharp, isActive && style.text.name.active] },
          name
        )
      ),
      sharp ? _react2.default.createElement(
        'svg',
        { xmlns: 'http://www.w3.org/2000/svg', viewBox: '0 0 35 52', style: [style.arrow.base, lastStep && style.arrow.hidden] },
        _react2.default.createElement('path', {
          style: [style.arrow.background, isActive && style.arrow.backgroundActive, isDone && style.arrow.backgroundDone],
          d: 'M0-29H35V81H0V-29Z'
        }),
        _react2.default.createElement('path', {
          style: [style.arrow.stroke, style.arrow.strokeSharp, doneOrActive && style.arrow.strokeActive],
          d: 'M-21.33-29.61L30.15,24.9-21.33,80.39'
        })
      ) : _react2.default.createElement(
        'svg',
        { viewBox: '0 0 35 52', style: [style.arrow.base, lastStep && style.arrow.hidden] },
        _react2.default.createElement('path', {
          style: [style.arrow.background, isActive && style.arrow.backgroundActive, isDone && style.arrow.backgroundDone],
          d: 'M0-29h35V81H0z'
        }),
        _react2.default.createElement('path', {
          style: [style.arrow.stroke, doneOrActive && style.arrow.strokeActive],
          d: 'm -0.5,-29 31.371,49.899939 c 1.9,3.1 1.9,7.1 -0.1,10.2 L -0.5,81'
        })
      )
    );
  };

  return ProgressBarStep;
}(_StyledComponent3.default)) || _class;

ProgressBarStep.styleRoot = 'ProgressBarStep';
ProgressBarStep.propTypes = {
  index: _react.PropTypes.number.isRequired,
  isActive: _react.PropTypes.bool,
  isDone: _react.PropTypes.any,
  name: _react.PropTypes.string.isRequired,
  numbered: _react.PropTypes.bool,
  sharp: _react.PropTypes.bool,
  stepsCount: _react.PropTypes.number.isRequired
};

ProgressBarStep.style = function (_ref) {
  var _base, _sharp, _first, _sharp2, _base2, _active;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    item: {
      base: (_base = {
        padding: '0px 15px',
        flex: '1 1 auto',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        position: 'relative',
        backgroundColor: colors.backgroundDarker
      }, _base[mediaQueries.breakpointSmall] = {
        fontSize: '13px'
      }, _base),

      sharp: (_sharp = {}, _sharp[mediaQueries.breakpointSmall] = {
        padding: '0px 10px'
      }, _sharp),

      first: (_first = {}, _first[mediaQueries.breakpointSmall] = {
        padding: '0px 15px 0px 0px'
      }, _first),

      last: {
        padding: '0px 10px 0px 15px',
        marginRight: '-15px'
      },

      active: {
        backgroundColor: colors.primary
      }
    },

    text: {
      base: {
        display: 'block',
        position: 'relative',
        zIndex: 3,
        textAlign: 'center',
        color: colors.grayDark
      },

      active: {
        color: colors.white
      },

      sharp: (_sharp2 = {
        fontSize: '14px'
      }, _sharp2[mediaQueries.breakpointTablet] = {
        fontSize: '13px'
      }, _sharp2),

      badge: {
        base: (_base2 = {
          display: 'none',
          marginRight: '10px',
          fontWeight: 'bold',
          padding: '3px 6px',
          borderStyle: 'solid',
          borderWidth: '1px',
          borderRadius: '5px',
          color: colors.grayLight,
          borderColor: colors.grayLight
        }, _base2[mediaQueries.breakpointSmall] = {
          display: 'inline-block',
          marginRight: '5px'
        }, _base2),
        visible: {
          display: 'inline-block'
        },
        doneOrActive: {
          color: colors.white,
          borderColor: colors.white
        },
        active: (_active = {}, _active[mediaQueries.breakpointSmall] = {
          display: 'none'
        }, _active)
      },

      name: {
        display: 'inline-block'
      },

      icon: {
        fill: colors.secondary
      },

      iconWrapper: {
        display: 'inline-block',
        verticalAlign: 'middle'
      }
    },

    arrow: {
      base: {
        position: 'absolute',
        right: '0',
        bottom: '0',
        width: 'auto',
        height: '100%',
        transform: 'translateX(10px)',
        zIndex: 2
      },

      background: {
        fill: colors.backgroundDarker
      },

      hidden: {
        display: 'none'
      },

      backgroundDone: {
        fill: colors.primary
      },

      stroke: {
        fill: colors.backgroundDarker,
        stroke: colors.white,
        strokeWidth: '5px'
      },

      strokeSharp: {
        stroke: colors.white,
        strokeWidth: '2px'
      },

      strokeActive: {
        fill: colors.primary
      }
    }
  };
};

exports.default = ProgressBarStep;
module.exports = exports['default'];