'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Spinner = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Spinner, _StyledComponent);

  function Spinner() {
    (0, _classCallCheck3.default)(this, Spinner);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Spinner.prototype.render = function render() {
    var style = this.getStyle();
    var spinner = (0, _immutable.Range)(1, 13).toArray().map(function (i) {
      return _react2.default.createElement(
        'div',
        { key: i, style: [style.circle, style['circle' + i]], className: 'spinnerStep' },
        _react2.default.createElement('div', { style: [style.circleBefore, style['fading' + i]] })
      );
    });

    return _react2.default.createElement(
      'div',
      { style: style.wrapper },
      spinner
    );
  };

  return Spinner;
}(_StyledComponent3.default)) || _class;

Spinner.styleRoot = 'Spinner';
Spinner.style = getStyles();
exports.default = Spinner;


function getStyles() {
  // eslint-disable-line
  var circleFadeDelay = _radium2.default.keyframes({
    '0%, 39%, 100%': {
      opacity: 0
    },
    '40%': {
      opacity: 1
    }
  }, 'fade');

  var otherStyles = {
    wrapper: {
      width: '24px',
      height: '24px',
      position: 'relative',
      display: 'inline-block',
      verticalAlign: 'middle',
      marginRight: '10px'
    },

    circle: {
      width: '100%',
      height: '100%',
      position: 'absolute',
      left: 0,
      top: 0
    },

    circleBefore: {
      margin: '0 auto',
      width: '15%',
      height: '15%',
      backgroundColor: 'white',
      borderRadius: '100%',
      animation: 'circleFadeDelay 1.2s infinite ease-in-out both',
      animationName: circleFadeDelay
    }
  };

  return (0, _immutable.Range)(1, 13).reduce(function (styles, number) {
    var delay = (number * 0.1 - 1.1).toFixed(2);
    styles['circle' + number] = { transform: 'rotate(' + number * 30 + 'deg)' }; // eslint-disable-line no-param-reassign
    styles['fading' + number] = { animationDelay: delay + 's' }; // eslint-disable-line no-param-reassign

    return styles;
  }, otherStyles);
}
module.exports = exports['default'];