'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSlider = require('react-slider');

var _reactSlider2 = _interopRequireDefault(_reactSlider);

var _SliderSteps = require('./SliderSteps.react');

var _SliderSteps2 = _interopRequireDefault(_SliderSteps);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadiumSlider = (0, _radium2.default)(_reactSlider2.default);

var Slider = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Slider, _StyledComponent);

  function Slider() {
    (0, _classCallCheck3.default)(this, Slider);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Slider.prototype.onSliderChange = function onSliderChange(value) {
    var onChange = this.props.onChange;

    onChange(value);
  };

  Slider.prototype.render = function render() {
    var _props = this.props,
        barHeight = _props.barHeight,
        blackVersion = _props.blackVersion,
        defaultValue = _props.defaultValue,
        formater = _props.formater,
        height = _props.height,
        kind = _props.kind,
        max = _props.max,
        min = _props.min,
        shakySteps = _props.shakySteps,
        step = _props.step,
        stepHeight = _props.stepHeight,
        unit = _props.unit,
        value = _props.value;

    var style = this.getStyle();
    var sliderColor = blackVersion ? style.sliderBarInactiveBlack : style.sliderBarInactive;
    var sliderValue = value === null || value === undefined ? defaultValue : value;

    return _react2.default.createElement(
      'div',
      { className: 'slider-' + kind },
      _react2.default.createElement(_radium.Style, { rules: {
          '.slider': style.slider,
          '.handle': style.handle,
          '.handle-bars': style.sliderHandleBars.base,
          '.handle.active .handle-bars': style.handleActive,
          '.bar': style.sliderBar,
          '.bar.bar-0': style.sliderBarActive,
          '.bar.bar-1': sliderColor
        }
      }),
      _react2.default.createElement(_SliderSteps2.default, {
        barHeight: barHeight,
        blackVersion: blackVersion,
        defaultValue: defaultValue,
        formater: formater,
        height: height,
        max: max,
        min: min,
        shakySteps: shakySteps,
        step: step,
        stepHeight: stepHeight,
        unit: unit
      }),
      _react2.default.createElement(
        RadiumSlider,
        {
          defaultValue: defaultValue,
          max: max,
          min: min,
          onChange: this.onSliderChange.bind(this),
          step: step,
          style: style.slider,
          value: sliderValue,
          withBars: true
        },
        _react2.default.createElement(
          'div',
          { className: 'handle-bars' },
          _react2.default.createElement(_Icon2.default, {
            color: '#fff',
            kind: 'handler',
            size: 18,
            wrapperStyle: style.sliderHandleBars.icon
          })
        )
      )
    );
  };

  Slider.style = function style(_ref, props) {
    var colors = _ref.colors;
    var barHeight = props.barHeight,
        height = props.height;

    return {
      slider: {
        height: height + 'px',
        paddingTop: (height - barHeight) / 2 + 'px',
        width: '100%'
      },

      sliderBar: {
        height: barHeight + 'px',
        position: 'relative'
      },

      sliderBarActive: {
        backgroundColor: colors.primary,
        transition: 'right .2s ease-in-out'
      },

      sliderBarInactiveBlack: {
        backgroundColor: colors.yellowDark,
        transition: 'right .2s ease-in-out'
      },

      sliderBarInactive: {
        backgroundColor: '#e4e4e4',
        transition: 'left .2s ease-in-out'
      },

      handle: {
        width: '1px',
        position: 'relative'
      },

      handleActive: {
        backgroundColor: colors.primaryDarker
      },

      sliderHandleBars: {
        base: {
          backgroundColor: colors.primary,
          borderRadius: '50%',
          boxShadow: '0 1px 3px rgba(0,0,0,.25)',
          position: 'absolute',
          left: height / 2 * -1 + 'px',
          top: height / 2 * -1 + 'px',
          marginTop: barHeight / 2 + 'px',
          width: height + 'px',
          height: height + 'px',
          cursor: 'pointer'
        },

        icon: {
          paddingTop: height / 4.5 + 'px',
          width: height + 'px',
          textAlign: 'center'
        }
      }
    };
  };

  return Slider;
}(_StyledComponent3.default)) || _class;

Slider.styleRoot = 'Slider';
Slider.propTypes = {
  barHeight: _react.PropTypes.number.isRequired,
  blackVersion: _react.PropTypes.bool,
  defaultValue: _react.PropTypes.number.isRequired,
  formater: _react.PropTypes.func.isRequired,
  height: _react.PropTypes.number.isRequired,
  kind: _react.PropTypes.oneOf(['amount', 'monthlyPayment', 'term']).isRequired,
  max: _react.PropTypes.number.isRequired,
  min: _react.PropTypes.number.isRequired,
  onChange: _react.PropTypes.func,
  shakySteps: _react.PropTypes.bool,
  step: _react.PropTypes.number.isRequired,
  stepHeight: _react.PropTypes.number.isRequired,
  unit: _react.PropTypes.string.isRequired,
  value: _react.PropTypes.number
};
Slider.defaultProps = {
  barHeight: 4,
  defaultValue: 5,
  formater: function formater(value, unit) {
    return unit + ' ' + value;
  },
  height: 32,
  max: 10,
  min: 1,
  step: 1,
  stepHeight: 10
};
exports.default = Slider;
module.exports = exports['default'];