'use strict';

exports.__esModule = true;
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _desc, _value, _class2;

var _fitInRangeAndStep = require('../lib/fitInRangeAndStep');

var _fitInRangeAndStep2 = _interopRequireDefault(_fitInRangeAndStep);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _coreDecorators = require('core-decorators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var SliderInput = (0, _radium2.default)(_class = (_class2 = function (_StyledComponent) {
  (0, _inherits3.default)(SliderInput, _StyledComponent);

  function SliderInput() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, SliderInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _StyledComponent.call.apply(_StyledComponent, [this].concat(args))), _this), _this.state = {
      editing: false,
      intermediateValue: _this.props.value,
      randomShit: 0
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  SliderInput.prototype.getInputValue = function getInputValue() {
    var value = this.props.value;
    var _state = this.state,
        editing = _state.editing,
        intermediateValue = _state.intermediateValue;


    if (editing) return intermediateValue;

    return value;
  };

  SliderInput.prototype.handleOnKeyPress = function handleOnKeyPress(event) {
    var ENTER_KEY_CODE = 13;

    if (event.keyCode === ENTER_KEY_CODE) {
      var value = this.props.value;


      this.setState({
        intermediateValue: value
      });
    }
  };

  SliderInput.prototype.handleChange = function handleChange(_ref) {
    var monthlyPayment = _ref.target.value;
    var _props = this.props,
        defaultValue = _props.defaultValue,
        onChange = _props.onChange,
        max = _props.max,
        min = _props.min,
        step = _props.step;

    var numbersOnly = monthlyPayment.replace(/\D/g, '');
    var roundedInRange = (0, _fitInRangeAndStep2.default)(parseInt(numbersOnly, 10), { defaultValue: defaultValue, max: max, min: min, step: step });

    this.setState({
      intermediateValue: numbersOnly
    });

    onChange(roundedInRange);
  };

  SliderInput.prototype.handleFocus = function handleFocus() {
    var value = this.props.value;


    this.setState({ editing: true, intermediateValue: value });
  };

  SliderInput.prototype.handleBlur = function handleBlur() {
    var value = this.props.value;


    this.setState({ editing: false, intermediateValue: value });
  };

  SliderInput.prototype.renderOption = function renderOption(option) {
    var text = option.text,
        value = option.value;

    var optionText = text && text || value;

    return _react2.default.createElement(
      'option',
      { key: value, value: value },
      optionText
    );
  };

  SliderInput.prototype.renderStyles = function renderStyles() {
    return _react2.default.createElement(_radium.Style, { rules: {
        "input[type='number']::-webkit-outer-spin-button, input[type='number']::-webkit-inner-spin-button": {
          WebkitAppearance: 'none',
          margin: 0
        }
      }
    });
  };

  SliderInput.prototype.render = function render() {
    var _props2 = this.props,
        blackVersion = _props2.blackVersion,
        kind = _props2.kind,
        label = _props2.label,
        unit = _props2.unit,
        unitAlign = _props2.unitAlign;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      null,
      this.renderStyles(),
      _react2.default.createElement(
        'label',
        { htmlFor: kind, style: style.label },
        label
      ),
      _react2.default.createElement(
        'div',
        { style: style.inputWrapper },
        _react2.default.createElement('input', {
          id: kind,
          key: 'select',
          name: 'sliderSelect',
          onBlur: this.handleBlur.bind(this),
          onChange: this.handleChange.bind(this),
          onFocus: this.handleFocus.bind(this),
          onKeyDown: this.handleOnKeyPress.bind(this),
          style: [style.inputBase, style.input, unit && style.input.unit, unitAlign === 'left' && style.input.unitLeft, blackVersion && style.blackVersion],
          type: 'number',
          value: this.getInputValue()
        }),
        _react2.default.createElement(
          'div',
          { style: [style.unit, style.unit[unitAlign]] },
          unit
        )
      )
    );
  };

  return SliderInput;
}(_StyledComponent3.default), (_applyDecoratedDescriptor(_class2.prototype, 'getInputValue', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'getInputValue'), _class2.prototype)), _class2)) || _class;

SliderInput.styleRoot = 'SliderInput';
SliderInput.propTypes = {
  blackVersion: _react.PropTypes.bool,
  defaultValue: _react.PropTypes.number.isRequired,
  kind: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  max: _react.PropTypes.number.isRequired,
  min: _react.PropTypes.number.isRequired,
  onChange: _react.PropTypes.func.isRequired,
  scale: _react.PropTypes.any,
  step: _react.PropTypes.number.isRequired,
  unit: _react.PropTypes.string.isRequired,
  unitAlign: _react.PropTypes.oneOf(['left', 'right']),
  value: _react.PropTypes.number
};

SliderInput.style = function (_ref2) {
  var colors = _ref2.colors;
  return {
    inputWrapper: {
      height: '40px',
      position: 'relative',
      backgroundColor: colors.white,
      marginBottom: '12px',
      float: 'right',
      width: '100px'
    },

    inputBase: {
      color: 'hsl(0, 0%, 30%)',
      fontWeight: '300',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: 'hsl(0, 0%, 80%)',
      outline: 'none',
      WebkitAppearance: 'none',
      borderRadius: 0,
      transition: 'border-color .2s',
      ':focus': {
        borderColor: colors.primary
      }
    },

    input: {
      width: '100%',
      height: '100%',
      float: 'left',
      background: 'none',
      padding: '4px 10px',
      outline: 'none',
      position: 'relative',
      zIndex: '2',
      appearance: 'textfield',
      unit: {
        padding: '4px 28px 4px 10px'
      },
      unitLeft: {
        padding: '4px 10px 4px 28px'
      }
    },

    blackVersion: {
      borderColor: 'rgba(135, 113, 3, 0.8)'
    },

    label: {
      display: 'block',
      float: 'left',
      fontSize: '21px',
      fontWeight: 'bold',
      color: colors.textPrimary,
      lineHeight: '40px'
    },

    unit: {
      height: '40px',
      lineHeight: '40px',
      color: 'gray',
      padding: '0 10px',
      textAlign: 'center',
      position: 'absolute',
      top: 0,
      right: 0,
      pointerEvents: 'none',
      left: {
        right: 'auto',
        left: 0
      }
    }
  };
};

exports.default = SliderInput;
module.exports = exports['default'];