'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Icon = require('../layout/Icon.react');

var _Icon2 = _interopRequireDefault(_Icon);

var _Label = require('../forms/Label.react');

var _Label2 = _interopRequireDefault(_Label);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Option = require('./Option.react');

var _Option2 = _interopRequireDefault(_Option);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SliderSelect = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(SliderSelect, _StyledComponent);

  function SliderSelect() {
    (0, _classCallCheck3.default)(this, SliderSelect);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  SliderSelect.prototype.onChange = function onChange(event) {
    var onChange = this.props.onChange;

    var unformatedValue = parseInt(event.target.value.replace(/\D/g, ''), 10);

    onChange(unformatedValue);
  };

  SliderSelect.prototype.render = function render() {
    var _props = this.props,
        formater = _props.formater,
        label = _props.label,
        max = _props.max,
        min = _props.min,
        step = _props.step,
        unit = _props.unit,
        value = _props.value;

    var options = (0, _immutable.Range)(min, max + 1, step).toJS();
    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _Label2.default,
        { inheritedStyle: style.label },
        label
      ),
      _react2.default.createElement(
        'div',
        { style: style.selectWrapper },
        _react2.default.createElement(
          'select',
          {
            key: 'select',
            name: 'sliderSelect',
            onChange: this.onChange.bind(this),
            style: style.select,
            value: value || ''
          },
          options.map(function (value) {
            return _react2.default.createElement(_Option2.default, { formater: formater, key: value, value: value, unit: unit });
          })
        ),
        _react2.default.createElement(_Icon2.default, {
          color: style.icon.color,
          kind: 'chevron',
          size: 18,
          wrapperStyle: style.icon
        })
      )
    );
  };

  return SliderSelect;
}(_StyledComponent3.default)) || _class;

SliderSelect.styleRoot = 'SliderSelect';
SliderSelect.propTypes = {
  defaultValue: _react.PropTypes.number.isRequired,
  formater: _react.PropTypes.func.isRequired,
  label: _react.PropTypes.string.isRequired,
  max: _react.PropTypes.number.isRequired,
  min: _react.PropTypes.number.isRequired,
  onChange: _react.PropTypes.func.isRequired,
  step: _react.PropTypes.number.isRequired,
  unit: _react.PropTypes.string.isRequired,
  value: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string])
};
SliderSelect.defaultProps = {
  defaultValue: 5,
  formater: function formater(value, unit) {
    return value + ' ' + unit;
  },
  max: 10,
  min: 1,
  step: 1,
  unit: '€'
};

SliderSelect.style = function (_ref) {
  var colors = _ref.colors,
      sizes = _ref.sizes;
  return {
    selectWrapper: {
      height: sizes.inputHeight,
      position: 'relative',
      backgroundColor: colors.white,
      marginBottom: '12px',
      float: 'right',
      width: '120px'
    },

    select: {
      width: '100%',
      height: '100%',
      float: 'left',
      background: 'none',
      appearance: 'none',
      padding: '4px 10px',
      outline: 'none',
      cursor: 'pointer',
      position: 'relative',
      zIndex: '2',
      color: 'hsl(0, 0%, 30%)',
      fontWeight: '300',
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: 'hsl(0, 0%, 80%)',
      WebkitAppearance: 'none',
      borderRadius: 0,
      transition: 'border-color .2s',
      ':focus': {
        borderColor: colors.primary
      }
    },

    icon: {
      color: colors.grayLight,
      padding: '12px',
      position: 'absolute',
      top: 0,
      right: 0,
      userSelect: 'none',
      zIndex: '1'
    },

    label: {
      float: 'left',
      fontSize: '18px',
      fontWeight: 'bold',
      color: colors.textPrimary,
      lineHeight: sizes.inputHeight
    }
  };
};

exports.default = SliderSelect;
module.exports = exports['default'];