'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SliderStep = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(SliderStep, _StyledComponent);

  function SliderStep() {
    (0, _classCallCheck3.default)(this, SliderStep);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  SliderStep.prototype.render = function render() {
    var _props = this.props,
        blackVersion = _props.blackVersion,
        index = _props.index,
        steps = _props.steps;

    var lastStep = index === steps;
    var style = this.getStyle();

    return _react2.default.createElement('div', { className: 'step', style: [this.stepStyle(), style.step, blackVersion && style.blackStep, lastStep && style.lastStep] });
  };

  SliderStep.prototype.stepStyle = function stepStyle() {
    var _props2 = this.props,
        stepHeight = _props2.stepHeight,
        shakySteps = _props2.shakySteps,
        steps = _props2.steps,
        index = _props2.index;

    var smallStep = index % 2 === 1 && index !== 0 && shakySteps;

    if (smallStep) return {
      height: stepHeight / 2 + 'px',
      marginLeft: 100 / steps * index + '%',
      marginTop: stepHeight / 2 + 'px',
      position: 'absolute',
      width: '1px'
    };
    return {
      height: stepHeight + 'px',
      marginLeft: 100 / steps * index + '%',
      position: 'absolute',
      width: '1px'
    };
  };

  return SliderStep;
}(_StyledComponent3.default)) || _class;

SliderStep.styleRoot = 'SliderStep';
SliderStep.propTypes = {
  blackVersion: _react.PropTypes.bool,
  index: _react.PropTypes.number.isRequired,
  shakySteps: _react.PropTypes.bool,
  stepHeight: _react.PropTypes.number.isRequired,
  steps: _react.PropTypes.number.isRequired
};
SliderStep.defaultProps = {
  stepHeight: 10
};

SliderStep.style = function (_ref) {
  var colors = _ref.colors;
  return {
    step: {
      backgroundColor: '#c7d2dc'
    },

    blackStep: {
      backgroundColor: colors.yellowDark
    },

    lastStep: {
      transform: 'translateX(-1px)'
    }
  };
};

exports.default = SliderStep;
module.exports = exports['default'];