'use strict';

exports.__esModule = true;
exports.default = undefined;

var _objectDestructuringEmpty2 = require('babel-runtime/helpers/objectDestructuringEmpty');

var _objectDestructuringEmpty3 = _interopRequireDefault(_objectDestructuringEmpty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SliderStep = require('./SliderStep.react');

var _SliderStep2 = _interopRequireDefault(_SliderStep);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SliderSteps = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(SliderSteps, _StyledComponent);

  function SliderSteps() {
    (0, _classCallCheck3.default)(this, SliderSteps);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  SliderSteps.prototype.render = function render() {
    var _props = this.props,
        barHeight = _props.barHeight,
        blackVersion = _props.blackVersion,
        formater = _props.formater,
        height = _props.height,
        max = _props.max,
        min = _props.min,
        shakySteps = _props.shakySteps,
        step = _props.step,
        stepHeight = _props.stepHeight,
        unit = _props.unit;

    var stepsCount = Math.ceil((max - min) / step);
    var maxStepsCount = 20;
    var optimalStepsCount = shakySteps ? 26 : 10;

    // For steps count numbers without any common divisor with numbers in range
    // 2..maxStepsCount will render no steps.
    var steps = countSteps(stepsCount, maxStepsCount, optimalStepsCount);

    var stepsArray = (0, _immutable.Range)(0, steps + 1, 1).toJS().map(function (i) {
      return _react2.default.createElement(_SliderStep2.default, {
        blackVersion: blackVersion,
        index: i,
        key: i,
        shakySteps: shakySteps,
        height: height,
        barHeight: barHeight,
        stepHeight: stepHeight,
        steps: steps
      });
    });

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { className: 'sliderSteps', style: style.wrapper },
      _react2.default.createElement(
        'div',
        null,
        stepsArray
      ),
      _react2.default.createElement(
        'div',
        { style: [style.min, style.range] },
        formater(min, unit)
      ),
      _react2.default.createElement(
        'div',
        { style: [style.max, style.range] },
        formater(max, unit)
      )
    );
  };

  SliderSteps.style = function style(_ref, props) {
    (0, _objectDestructuringEmpty3.default)(_ref);
    var barHeight = props.barHeight,
        height = props.height,
        stepHeight = props.stepHeight;

    return {
      wrapper: {
        position: 'relative',
        width: '100%',
        top: (height - barHeight) / 2 - stepHeight + 'px'
      },

      min: {
        left: '0'
      },

      max: {
        right: '0'
      },

      range: {
        top: (height - barHeight) / 2 + stepHeight + 4 + 'px',
        position: 'absolute',
        fontSize: '13px'
      }
    };
  };

  return SliderSteps;
}(_StyledComponent3.default)) || _class;

SliderSteps.styleRoot = 'SliderSteps';
SliderSteps.propTypes = {
  barHeight: _react.PropTypes.number.isRequired,
  blackVersion: _react.PropTypes.bool,
  defaultValue: _react.PropTypes.number.isRequired,
  formater: _react.PropTypes.func.isRequired,
  max: _react.PropTypes.number.isRequired,
  min: _react.PropTypes.number.isRequired,
  shakySteps: _react.PropTypes.bool,
  step: _react.PropTypes.number.isRequired,
  stepHeight: _react.PropTypes.number.isRequired,
  unit: _react.PropTypes.string
};
SliderSteps.defaultProps = {
  barHeight: 5,
  formater: function formater(value, unit) {
    return unit + ' ' + value;
  },
  stepHeight: 8
};
exports.default = SliderSteps;


function countSteps(stepsCount, maxStepsCount, optimalStepsCount) {
  // eslint-disable-line
  for (var i = maxStepsCount; i >= 2; i--) {
    if (stepsCount % i === 0) {
      if (i < optimalStepsCount) return optimalStepsCount;
      if (i % 2 !== 0) return i + 1;
      return i;
    }
  }
  return optimalStepsCount;
}
module.exports = exports['default'];