'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Clearfix = require('../layout/Clearfix.react');

var _Clearfix2 = _interopRequireDefault(_Clearfix);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Slider = require('./Slider.react');

var _Slider2 = _interopRequireDefault(_Slider);

var _SliderInput = require('./SliderInput.react');

var _SliderInput2 = _interopRequireDefault(_SliderInput);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SliderWithControls = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(SliderWithControls, _StyledComponent);

  function SliderWithControls() {
    (0, _classCallCheck3.default)(this, SliderWithControls);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  SliderWithControls.prototype.onSliderChange = function onSliderChange(value) {
    var onChange = this.props.onChange;

    onChange(value);
  };

  SliderWithControls.prototype.render = function render() {
    if (this.props.loading) return _react2.default.createElement(
      'div',
      null,
      'loading'
    );

    var _props = this.props,
        barHeight = _props.barHeight,
        blackVersion = _props.blackVersion,
        defaultValue = _props.defaultValue,
        formater = _props.formater,
        heading = _props.heading,
        height = _props.height,
        kind = _props.kind,
        max = _props.max,
        min = _props.min,
        shakySteps = _props.shakySteps,
        step = _props.step,
        stepHeight = _props.stepHeight,
        unit = _props.unit,
        value = _props.value;

    var style = this.getStyle();

    return _react2.default.createElement(
      'div',
      { style: style.wrapper },
      _react2.default.createElement(_SliderInput2.default, {
        defaultValue: defaultValue,
        blackVersion: blackVersion,
        kind: kind,
        label: heading,
        max: max,
        min: min,
        onChange: this.onSliderChange.bind(this),
        step: step,
        unit: unit,
        value: value
      }),
      _react2.default.createElement(_Clearfix2.default, null),
      _react2.default.createElement(_Slider2.default, {
        blackVersion: blackVersion,
        defaultValue: defaultValue,
        formater: formater,
        kind: kind,
        max: max,
        min: min,
        onChange: this.onSliderChange.bind(this),
        shakySteps: shakySteps,
        barHeight: barHeight,
        height: height,
        stepHeight: stepHeight,
        step: step,
        unit: unit,
        value: value
      })
    );
  };

  return SliderWithControls;
}(_StyledComponent3.default)) || _class;

SliderWithControls.styleRoot = 'SliderWithControls';
SliderWithControls.propTypes = {
  barHeight: _react.PropTypes.number,
  blackVersion: _react.PropTypes.bool,
  defaultValue: _react.PropTypes.number.isRequired,
  formater: _react.PropTypes.func.isRequired,
  heading: _react.PropTypes.string.isRequired,
  height: _react.PropTypes.number,
  kind: _react.PropTypes.oneOf(['amount', 'monthlyPayment', 'term']).isRequired,
  loading: _react.PropTypes.bool,
  max: _react.PropTypes.number.isRequired,
  min: _react.PropTypes.number.isRequired,
  onChange: _react.PropTypes.func,
  selectFormater: _react.PropTypes.func.isRequired,
  shakySteps: _react.PropTypes.bool,
  step: _react.PropTypes.number.isRequired,
  stepHeight: _react.PropTypes.number,
  unit: _react.PropTypes.string.isRequired,
  value: _react.PropTypes.number
};
SliderWithControls.defaultProps = {
  barHeight: 5,
  defaultValue: 5,
  formater: function formater(value, unit) {
    return unit + ' ' + value;
  },
  height: 32,
  max: 10,
  min: 1,
  step: 1,
  stepHeight: 9,
  unit: '€',
  value: 10
};
SliderWithControls.style = {
  wrapper: {
    margin: '10px 0 40px 0'
  }
};
exports.default = SliderWithControls;
module.exports = exports['default'];