'use strict';

exports.__esModule = true;

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _normalizeColors = require('../lib/normalizeColors');

var _normalizeColors2 = _interopRequireDefault(_normalizeColors);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _immutable.fromJS)({

  colors: (0, _normalizeColors2.default)({
    primary: 'hsl(351, 50%, 50%)',
    secondary: 'hsl(50, 100%, 50%)',
    primaryDarker: (0, _color2.default)('#00b2d5').darken(0.2).hex(),
    secondaryDarker: (0, _color2.default)('hsl(50, 100%, 50%)').darken(0.2).hex(),
    error: 'hsl(351, 100%, 42%)',
    success: 'hsl(120, 100%, 42%)',
    black: '#333333',
    grayDarker: 'hsl(0, 0%, 20%)',
    grayDark: 'hsl(0, 0%, 30%)',
    gray: 'hsl(0, 0%, 50%)',
    grayLight: 'hsl(0, 0%, 70%)',
    grayLighter: 'hsl(0, 0%, 85%)',
    grayLightest: 'hsl(0, 0%, 90%)',
    white: 'hsl(0, 0%, 100%)',
    border: 'hsl(0, 0%, 60%)',
    yellowDark: '#877103',
    yellowLight: '#FFD900',
    textPrimary: 'hsl(0, 0%, 25%)',
    textSecondary: 'hsl(0, 0%, 50%)',
    background: '#fff'
  }),

  mediaQueries: {
    breakpointLarge: '@media screen and (min-width: 786px)',
    breakpointLaptop: '@media screen and (max-width: 1200px)',
    breakpointLaptopSmall: '@media screen and (max-width: 991px)',
    breakpointTablet: '@media screen and (max-width: 767px)',
    breakpointSmall: '@media screen and (max-width: 480px)',
    retina: '@media (-webkit-min-device-pixel-ratio: 2)',
    smallScreen: '@media (max-width: 480px), (max-height: 414px)'
  },

  sizes: {}

});
module.exports = exports['default'];