'use strict';

exports.__esModule = true;

var _normalizeColors = require('../lib/normalizeColors');

var _normalizeColors2 = _interopRequireDefault(_normalizeColors);

var _immutable = require('immutable');

var _Button = require('../buttons/Button.vivus');

var _Button2 = _interopRequireDefault(_Button);

var _ButtonLink = require('../buttons/ButtonLink.vivus');

var _ButtonLink2 = _interopRequireDefault(_ButtonLink);

var _Checkbox = require('../forms/Checkbox.vivus');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _Heading = require('../typography/Heading.vivus');

var _Heading2 = _interopRequireDefault(_Heading);

var _Label = require('../forms/Label.vivus');

var _Label2 = _interopRequireDefault(_Label);

var _MenuButton = require('../menus/MenuButton.vivus');

var _MenuButton2 = _interopRequireDefault(_MenuButton);

var _MenuItem = require('../menus/MenuItem.vivus');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _MultiField = require('../forms/MultiField.vivus');

var _MultiField2 = _interopRequireDefault(_MultiField);

var _Panel = require('../panels/Panel.vivus');

var _Panel2 = _interopRequireDefault(_Panel);

var _PasswordField = require('../forms/PasswordField.vivus');

var _PasswordField2 = _interopRequireDefault(_PasswordField);

var _ProgressBar = require('../progress/ProgressBar.vivus');

var _ProgressBar2 = _interopRequireDefault(_ProgressBar);

var _ProgressBarStep = require('../progress/ProgressBarStep.vivus');

var _ProgressBarStep2 = _interopRequireDefault(_ProgressBarStep);

var _RadioSelect = require('../forms/RadioSelect.vivus');

var _RadioSelect2 = _interopRequireDefault(_RadioSelect);

var _Select = require('../forms/Select.vivus');

var _Select2 = _interopRequireDefault(_Select);

var _Slider = require('../sliders/Slider.vivus');

var _Slider2 = _interopRequireDefault(_Slider);

var _SliderInput = require('../sliders/SliderInput.vivus');

var _SliderInput2 = _interopRequireDefault(_SliderInput);

var _SliderStep = require('../sliders/SliderStep.vivus');

var _SliderStep2 = _interopRequireDefault(_SliderStep);

var _SliderSteps = require('../sliders/SliderSteps.vivus');

var _SliderSteps2 = _interopRequireDefault(_SliderSteps);

var _Spinner = require('../progress/Spinner.vivus');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _TextField = require('../forms/TextField.vivus');

var _TextField2 = _interopRequireDefault(_TextField);

var _VerticalMenuItem = require('../menus/VerticalMenuItem.vivus');

var _VerticalMenuItem2 = _interopRequireDefault(_VerticalMenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _immutable.fromJS)({
  globals: {
    colors: (0, _normalizeColors2.default)({
      primary: '#A6CE39',
      primaryDarker: '#91B332',
      background: '#eceef2',
      backgroundDarker: '#E4E6EA',
      secondary: '#026D35',
      additional: '#6C6F70',
      warning: '#fecd0b',
      error: '#d9001e',
      info: '#A7CE3A',
      white: '#ffffff',
      black: '#000000',
      light: '#ffffff',
      dark: '#2B2B2B',
      gray: '#808080',
      grayDark: '#4d4d4d',
      grayDarker: '#46484B',
      grayLight: '#B3B3B3',
      monotone1: '#f2f2f2',
      monotone2: '#d5d5d5',
      monotone3: '#959595',
      monotone4: '#555555',
      monotone5: '#363636',
      inputColor: '#474747',
      inputBorder: '#d3d3d3',
      yellowLight: '#FFD900'
    }),
    sizes: {
      inputHeight: '40px'
    },
    mediaQueries: {
      x: 1
    }
  },
  Button: _Button2.default,
  ButtonLink: _ButtonLink2.default,
  Checkbox: _Checkbox2.default,
  Heading: _Heading2.default,
  Panel: _Panel2.default,
  ProgressBar: _ProgressBar2.default,
  ProgressBarStep: _ProgressBarStep2.default,
  TextField: _TextField2.default,
  Label: _Label2.default,
  MenuButton: _MenuButton2.default,
  MenuItem: _MenuItem2.default,
  MultiField: _MultiField2.default,
  PasswordField: _PasswordField2.default,
  RadioSelect: _RadioSelect2.default,
  Select: _Select2.default,
  Slider: _Slider2.default,
  SliderInput: _SliderInput2.default,
  SliderStep: _SliderStep2.default,
  SliderSteps: _SliderSteps2.default,
  Spinner: _Spinner2.default,
  VerticalMenuItem: _VerticalMenuItem2.default
});
module.exports = exports['default'];