'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableCell = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(TableCell, _StyledComponent);

  function TableCell() {
    (0, _classCallCheck3.default)(this, TableCell);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  TableCell.prototype.render = function render() {
    var _props = this.props,
        alignTop = _props.alignTop,
        bold = _props.bold,
        children = _props.children,
        center = _props.center,
        className = _props.className,
        first = _props.first,
        fadeOut = _props.fadeOut,
        last = _props.last,
        noPadding = _props.noPadding,
        right = _props.right,
        rightBorder = _props.rightBorder;

    var style = this.getStyle();

    return _react2.default.createElement(
      'td',
      { className: className, style: [style.base, center && style.center, bold && style.bold, right && style.right, first && style.first, last && style.last, rightBorder && style.rightBorder, alignTop && style.alignTop, noPadding && style.noPadding]
      },
      children,
      fadeOut && _react2.default.createElement('span', { style: style.fadeOut })
    );
  };

  return TableCell;
}(_StyledComponent3.default)) || _class;

TableCell.styleRoot = 'TableCell';
TableCell.propTypes = {
  alignTop: _react.PropTypes.bool,
  bold: _react.PropTypes.bool,
  center: _react.PropTypes.bool,
  children: _react.PropTypes.any,
  className: _react.PropTypes.string,
  fadeOut: _react.PropTypes.bool,
  first: _react.PropTypes.bool,
  last: _react.PropTypes.bool,
  noPadding: _react.PropTypes.bool,
  right: _react.PropTypes.bool,
  rightBorder: _react.PropTypes.bool
};
TableCell.defaultProps = {
  alignTop: false,
  bold: false,
  center: false,
  fadeOut: false,
  first: false,
  noPadding: false,
  right: false,
  rightBorder: false
};
TableCell.style = {
  base: {
    padding: '12px',
    position: 'relative'
  },

  alignTop: {
    verticalAlign: 'top'
  },

  bold: {
    fontWeight: 'bold'
  },

  center: {
    textAlign: 'center'
  },

  first: {
    padding: '12px 12px 12px 0px'
  },

  last: {
    padding: '12px 0px 12px 12px'
  },

  right: {
    textAlign: 'right'
  },

  noPadding: {
    padding: '12px 3px'
  },

  rightBorder: {
    borderRightWidth: '1px',
    borderRightStyle: 'solid',
    borderColor: 'inherit'
  },

  fadeOut: {
    display: 'block',
    position: 'absolute',
    top: '0',
    left: '0',
    right: '0',
    bottom: '0',
    background: 'linear-gradient(0deg, rgba(255, 255, 255, 1) 38%,  rgba(255, 255, 255, 0) 100%)'
  }
};
exports.default = TableCell;
module.exports = exports['default'];