'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Heading = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(Heading, _StyledComponent);

  function Heading() {
    (0, _classCallCheck3.default)(this, Heading);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  Heading.prototype.render = function render() {
    var _props = this.props,
        Element = _props.kind,
        centered = _props.centered,
        children = _props.children,
        decorated = _props.decorated,
        decorationColor = _props.decorationColor,
        decoratedVertically = _props.decoratedVertically,
        decorationStyle = _props.decorationStyle,
        id = _props.id,
        inheritedStyle = _props.inheritedStyle,
        noMargin = _props.noMargin,
        thin = _props.thin,
        withSubheading = _props.withSubheading;

    var decorationColorStyle = { backgroundColor: decorationColor };
    var style = this.getStyle();

    var text = typeof children === 'string' ? _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: children } }) : children;

    return _react2.default.createElement(
      Element,
      {
        id: id,
        style: [style.base, style[Element], decoratedVertically && style.decoratedVertically, inheritedStyle && inheritedStyle, centered && style.centered, thin && style.thin, withSubheading && style.withSubheading, noMargin && style.noMargin]
      },
      text,
      (decorated || decoratedVertically) && _react2.default.createElement('div', { style: [style.decoration.base, style.decoration['' + Element], decoratedVertically && !centered && style.decoration.vertical, decorationColor && decorationColorStyle, centered && style.decoration.centered, decorationStyle]
      })
    );
  };

  return Heading;
}(_StyledComponent3.default)) || _class;

Heading.styleRoot = 'Heading';
Heading.propTypes = {
  centered: _react.PropTypes.bool,
  children: _react.PropTypes.any.isRequired,
  decorated: _react.PropTypes.bool,
  decorationColor: _react.PropTypes.string,
  decorationStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  decoratedVertically: _react.PropTypes.bool,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  kind: _react.PropTypes.oneOf(['h1', 'h2', 'h3', 'h4', 'h5']).isRequired,
  noMargin: _react.PropTypes.bool,
  thin: _react.PropTypes.bool,
  withSubheading: _react.PropTypes.bool,
  id: _react.PropTypes.string
};

Heading.style = function (_ref) {
  var _h, _h2;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    base: {
      color: colors.grayDarker,
      fontSize: '15px',
      fontWeight: '700',
      lineHeight: '1',
      margin: '1em 0 .4em',
      position: 'relative'
    },
    decoratedVertically: {
      paddingLeft: '4rem'
    },
    h1: (_h = {
      fontWeight: '700'
    }, _h[mediaQueries.smallScreen] = {
      fontSize: '38px'
    }, _h),
    h2: (_h2 = {
      fontWeight: '700'
    }, _h2[mediaQueries.smallScreen] = {
      fontSize: '32px'
    }, _h2),
    h3: {
      fontSize: '26px',
      fontWeight: '700'
    },
    h4: {
      fontSize: '22px',
      fontWeight: '300',
      margin: '3rem 0 1.5rem'
    },
    h5: {
      fontSize: '18px',
      fontWeight: '700',
      marginTop: '15px',
      margin: '1.5rem 0 1rem'
    },
    centered: {
      textAlign: 'center'
    },
    decoration: {
      base: {
        backgroundColor: colors.secondary,
        display: 'block',
        ineHeight: 'inherit',
        minWidth: '15%',
        maxWidth: '24%',
        position: 'relative',
        width: '48px'
      },
      vertical: {
        position: 'absolute',
        left: 0,
        top: '-10%',
        marginTop: 0,
        borderRadius: 0,
        height: '120%',
        minWidth: '7px',
        maxWidth: '7px',
        width: '7px'
      },
      centered: {
        left: '50%',
        transform: 'translateX(-50%)'
      },
      h5: { height: '2px' }
    },
    thin: {
      fontWeight: '100'
    },
    noMargin: {
      margin: 0
    },
    withSubheading: {
      margin: '1em 0 0'
    }
  };
};

exports.default = Heading;
module.exports = exports['default'];