'use strict';

exports.__esModule = true;
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _Heading = require('./Heading.react');

var _Heading2 = _interopRequireDefault(_Heading);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StyledComponent2 = require('../StyledComponent.react');

var _StyledComponent3 = _interopRequireDefault(_StyledComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HeadingWithValue = (0, _radium2.default)(_class = function (_StyledComponent) {
  (0, _inherits3.default)(HeadingWithValue, _StyledComponent);

  function HeadingWithValue() {
    (0, _classCallCheck3.default)(this, HeadingWithValue);
    return (0, _possibleConstructorReturn3.default)(this, _StyledComponent.apply(this, arguments));
  }

  HeadingWithValue.prototype.render = function render() {
    var _props = this.props,
        kind = _props.kind,
        children = _props.children,
        decorated = _props.decorated,
        decorationColor = _props.decorationColor,
        inheritedStyle = _props.inheritedStyle,
        noMargin = _props.noMargin,
        thin = _props.thin,
        value = _props.value,
        warn = _props.warn;


    var text = typeof children === 'string' ? _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: children } }) : children;

    var style = this.getStyle();

    return _react2.default.createElement(
      _Heading2.default,
      {
        kind: kind,
        decorated: decorated,
        decorationColor: decorationColor,
        noMargin: noMargin,
        thin: thin,
        inheritedStyle: !!inheritedStyle && inheritedStyle
      },
      _react2.default.createElement(
        'div',
        { style: style.flex },
        _react2.default.createElement(
          'div',
          { style: style.headingText },
          text
        ),
        _react2.default.createElement(
          'div',
          { style: style.valueWrapper },
          _react2.default.createElement(
            'span',
            { style: [style.value, style.value[kind]] },
            value
          )
        )
      ),
      warn && _react2.default.createElement(
        'span',
        { style: style.warn },
        warn
      )
    );
  };

  return HeadingWithValue;
}(_StyledComponent3.default)) || _class;

HeadingWithValue.styleRoot = 'HeadingWithValue';
HeadingWithValue.propTypes = {
  children: _react.PropTypes.any.isRequired,
  decorated: _react.PropTypes.bool,
  decorationColor: _react.PropTypes.string,
  inheritedStyle: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  kind: _react.PropTypes.oneOf(['h1', 'h2', 'h3', 'h4', 'h5']).isRequired,
  noMargin: _react.PropTypes.bool,
  thin: _react.PropTypes.bool,
  value: _react.PropTypes.string.isRequired,
  warn: _react.PropTypes.bool
};

HeadingWithValue.style = function (_ref) {
  var _h, _h2, _value;

  var colors = _ref.colors,
      mediaQueries = _ref.mediaQueries;
  return {
    flex: {
      display: 'flex',
      alignItems: 'center'
    },

    headingText: {
      flex: '1'
    },

    valueWrapper: {
      textAlign: 'right'
    },

    value: (_value = {
      fontSize: '53px',
      fontWeight: '500',
      display: 'block'
    }, _value[mediaQueries.breakpointLaptop] = {
      fontSize: '41px',
      marginTop: '16px'
    }, _value[mediaQueries.breakpointLaptopSmall] = {
      fontSize: '37px',
      marginTop: '19px'
    }, _value.h1 = (_h = {}, _h[mediaQueries.smallScreen] = {
      fontSize: '38px'
    }, _h), _value.h2 = (_h2 = {}, _h2[mediaQueries.smallScreen] = {
      fontSize: '32px'
    }, _h2), _value.h3 = {
      fontSize: '26px'
    }, _value.h4 = {
      fontSize: '22px'
    }, _value.h5 = {
      fontSize: '18px'
    }, _value),

    warn: {
      color: colors.error,
      fontWeight: '500',
      fontSize: '14px',
      display: 'block',
      textAlign: 'right',
      marginTop: '-5px'
    }
  };
};

exports.default = HeadingWithValue;
module.exports = exports['default'];