"use strict";

exports.__esModule = true;

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

exports.default = unaryMemoize;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *
 *
 * @param  {[type]} f [description]
 * @return {[type]}   [description]
 */
function unaryMemoize(f) {
  var cache = new _map2.default();
  return function (arg) {
    var result = cache.get(arg);
    if (result) return result;
    result = f.apply(null, [arg]);
    cache.set(arg, result);
    return result;
  };
}
module.exports = exports["default"];